//
//  AppDelegate.m
//  TalkfunSDKDemo
//
//  Created by talk－fun on 15/11/24.
//  Copyright © 2015年 talk-fun. All rights reserved.
//

#import "AppDelegate.h"
#import "TalkfunCourseListViewController.h"
#import "NavLoginViewController.h"
#import <Bugly/Bugly.h>
#import <SDWebImage/SDImageCache.h>
#import "XXShieldSDK.h"

@interface AppDelegate ()

@property (nonatomic,strong) UIAlertController *notReachableAlertView;
@property (nonatomic,strong) TalkfunDownloadManager * downloadManager;
@property(nonatomic,strong)NSString*releaseNotes;

@property(nonatomic,strong)NSString*trackViewUrl;



@end

@implementation AppDelegate



- (UIAlertController *)notReachableAlertView
{
    if (!_notReachableAlertView) {
      
        _notReachableAlertView = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"网络中断!" preferredStyle:UIAlertControllerStyleAlert];
        
        UIAlertAction *otherAction = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            
            
        }];
        
        [_notReachableAlertView addAction:otherAction];
        
      
    }
    return _notReachableAlertView;
}



- (UIInterfaceOrientationMask)application:(UIApplication *)application supportedInterfaceOrientationsForWindow:(UIWindow *)window {

    
    if([NSStringFromClass([[self getCurrentVC] class]) isEqualToString:@"TalkfunCourseListViewController"])
    {
        return UIInterfaceOrientationMaskPortrait;
    }
    
    
    
        return UIInterfaceOrientationMaskAll;

}


- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
     [[UIApplication sharedApplication] setIdleTimerDisabled:YES];
    if (@available(iOS 13.0, *)) {
        
 
    }else{
        [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
    }
    NSLog(@"TalkfunSDKVersion====>%@",TalkfunSDKVersion);
    

    
    
    //设置状态栏字体颜色为白色
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;

    // 1.创建窗口 在IO18 或 xcode16,系统会自动创建了
    if (!self.window) {
        self.window = [[[UIWindow alloc]init] initWithFrame:[TalkfunUtils getMainScreen]];
    }

    // 3.显示窗口
    [self.window makeKeyAndVisible];
    
    
    [NSThread sleepForTimeInterval:1.5];
    
     
    
    [SDImageCache sharedImageCache];
    
    self.downloadManager = [TalkfunDownloadManager shareManager];
    WeakSelf
   self.downloadManager.diskLowReminderValueCallback = ^{
        
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"磁盘可用空间不足,无法下载!" preferredStyle:UIAlertControllerStyleAlert];

    UIAlertAction *otherAction = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
    }];


    [alertController addAction:otherAction];
    if (IsIPAD) {
    alertController.popoverPresentationController.sourceView = weakSelf.window;
    alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
    }
    [[weakSelf getCurrentVC] presentViewController:alertController animated:YES completion:nil];

//    NSLog(@"磁盘空间不足够");

    };
  
#ifndef __OPTIMIZE__
    
    NSLog(@"Debug=========");
 #else
    NSLog(@"release=========");
    
     [Bugly startWithAppId:@"ba918ce702"];
     [XXShieldSDK registerStabilitySDK];
    
    
#endif

    TalkfunCourseListViewController * loginVC = [TalkfunCourseListViewController new];
    NavLoginViewController * nav = [[NavLoginViewController alloc] initWithRootViewController:loginVC];
    self.window.rootViewController = nav;
    
    //         ios8后，需要添加这个注册，才能得到授权
    if ([[UIApplication sharedApplication] respondsToSelector:@selector(registerUserNotificationSettings:)]) {
        UIUserNotificationType type =  UIUserNotificationTypeAlert | UIUserNotificationTypeBadge | UIUserNotificationTypeSound;
        UIUserNotificationSettings *settings = [UIUserNotificationSettings settingsForTypes:type categories:nil];
        [[UIApplication sharedApplication] registerUserNotificationSettings:settings];
        //             通知重复提示的单位，可以是天、周、月
        //                        notification.repeatInterval = kCFCalendarUnitSecond;
#pragma mark 设置NSCalendarUnitDay即代表每天重复
        //            cation.repeatInterval = NSCalendarUnitDay;
    }
    
#pragma mark - 版本更新检测
    [self checkForUpdate];
    
    

    //网络检测
    AFNetworkReachabilityManager *manager = [AFNetworkReachabilityManager sharedManager];
    
    [manager setReachabilityStatusChangeBlock:^(AFNetworkReachabilityStatus status) {
        UIViewController*controller =  [weakSelf getCurrentVC];
        
        NSString *className =NSStringFromClass([controller class]);

          weakSelf.status = status;
        if ([className isEqualToString:@"Talkfun1to16Live"]) {
            
            //在小班,不用显示
            return ;
        }
        if ([className isEqualToString:@"TalkfunLive1to1"]) {
            
            //在小班,不用显示
            return ;
        }

        dispatch_async(dispatch_get_main_queue(), ^{
            BOOL iswork = false;
            // 当网络状态改变时调用
            switch (status) {
                case AFNetworkReachabilityStatusUnknown:
//                    NSLog(@"未知网络");
                    iswork = NO;
                    if (weakSelf.window&&[weakSelf.window.rootViewController isKindOfClass:[UIViewController class]]&&weakSelf.notReachableAlertView&&weakSelf.window.rootViewController.presentedViewController == nil) {
                        if (IsIPAD) {
                            weakSelf.notReachableAlertView.popoverPresentationController.sourceView = weakSelf.window.rootViewController.view;
                            weakSelf.notReachableAlertView.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
                        }
                        [weakSelf.window.rootViewController presentViewController:weakSelf.notReachableAlertView animated:YES completion:nil];
                    }
                    break;
                case AFNetworkReachabilityStatusNotReachable:
//                    NSLog(@"没有网络");
                  
                    iswork = NO;
                    if (weakSelf.window&&[weakSelf.window.rootViewController isKindOfClass:[UIViewController class]]&&weakSelf.notReachableAlertView&&weakSelf.window.rootViewController.presentedViewController == nil) {
                        if (IsIPAD) {
                            weakSelf.notReachableAlertView.popoverPresentationController.sourceView = weakSelf.window.rootViewController.view;
                            weakSelf.notReachableAlertView.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
                        }
                        [weakSelf.window.rootViewController presentViewController:weakSelf.notReachableAlertView animated:YES completion:nil];
                    }
                    
                    break;
                case AFNetworkReachabilityStatusReachableViaWWAN:
                    
//                    NSLog(@"手机自带网络");
                   
                    iswork = YES;
                    
                    break;
                case AFNetworkReachabilityStatusReachableViaWiFi:

                    iswork = YES;
                    break;
                    
                 
                 
            }
            [[NSNotificationCenter defaultCenter] postNotificationName:@"CourseListnoReachable" object:@{@"iswork":@(iswork)}];
        });
        
        
      
    }];
    
    //开始监控
    [manager startMonitoring];
    
  
    
    return YES;
}

// 当通过URL把我的应用程序打开时,会执行该方法
- (BOOL)application:(UIApplication *)app openURL:(NSURL *)url options:(NSDictionary<NSString *,id> *)options
{
    /**
    // 1.将url转成字符串
    NSString *urlString = url.absoluteString;
    
    NSString * str = [urlString stringByReplacingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
    
    NSUInteger origin = [str rangeOfString:@"TalkfunSDK://"].location + 13;
    NSString *End = [str substringFromIndex:origin];
    
    NSDictionary *getDict =   [self DictionaryConversionString:End];
    
    if ([getDict isKindOfClass:[NSDictionary class]]) {
        //点播
        if (getDict[@"type"]&&[getDict[@"type"] isEqualToString:@"vod"]) {
            [self vodWithDict:getDict];
            //直播
        }else  if (getDict[@"type"]&&[getDict[@"type"] isEqualToString:@"live"]){
            [self liveWithDict:getDict];
        }
    }
     */
    return YES;
}

-(NSString*) removeLastOneChar:(NSString*)origin
{
    NSString* cutted;
    if([origin length] > 0){
        cutted = [origin substringToIndex:([origin length]-1)];// 去掉最后一个","
    }else{
        cutted = origin;
    }
    return cutted;
}
+ (void)registerLocalNotification:(NSString *)alertTime AndBody:(NSString *)alerbody{
    UILocalNotification *notification = ({
        UILocalNotification *cation =    [[UILocalNotification alloc] init];

        NSDate * currentDate = [NSDate date];
        //        通知时间
        cation.fireDate = currentDate;
        //         通知内容
        cation.alertBody =  alerbody;
        
      
        NSInteger badgeNumber = [UIApplication sharedApplication].applicationIconBadgeNumber;
        
//        NSLog(@"%ld",(long)badgeNumber);
        
        cation.applicationIconBadgeNumber = [UIApplication sharedApplication].applicationIconBadgeNumber + 1;
        //通知被触发时播放的声音
        cation.soundName = UILocalNotificationDefaultSoundName;
        //通知参数
        NSDictionary *userDict = [NSDictionary dictionaryWithObject:alerbody forKey:@"key"];
        cation.userInfo = userDict;
        //ios8后，需要添加这个注册，才能得到授权
        if ([[UIApplication sharedApplication] respondsToSelector:@selector(registerUserNotificationSettings:)]) {
            UIUserNotificationType type =  UIUserNotificationTypeAlert | UIUserNotificationTypeBadge | UIUserNotificationTypeSound;
            UIUserNotificationSettings *settings = [UIUserNotificationSettings settingsForTypes:type categories:nil];
            [[UIApplication sharedApplication] registerUserNotificationSettings:settings];
        }
        cation;
    });
    //    执行通知注册
    [[UIApplication sharedApplication] presentLocalNotificationNow:notification];

    
}


-(void)application:(UIApplication *)application didReceiveLocalNotification:(UILocalNotification *)notification{

}
// 当我们应用程序即将失去焦点的时候调用
- (void)applicationWillResignActive:(UIApplication *)application {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
}
// 当我们应用程序完全进入后台的时候调用
- (void)applicationDidEnterBackground:(UIApplication *)application {
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
}
// 当我们应用程序即将进入前台的时候调用
- (void)applicationWillEnterForeground:(UIApplication *)application {
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    
    
    
//    [[NSNotificationCenter defaultCenter] postNotificationName:@"TF_applicationWillEnterForeground" object:nil userInfo:@{}];

}
// 当我们应用程序完全获取焦点的时候调用
// 只有当一个应用程序完全获取到焦点,才能与用户交互.
- (void)applicationDidBecomeActive:(UIApplication *)application {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    [UIApplication sharedApplication].applicationIconBadgeNumber = 0;
}
// 当我们应用程序即将关闭的时候调用
- (void)applicationWillTerminate:(UIApplication *)application {
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    
}

//- (BOOL)application:(UIApplication *)application shouldAllowExtensionPointIdentifier:(NSString *)extensionPointIdentifier
//{
//    return NO;
//}


#pragma mark - 版本更新检测
- (void)checkForUpdate {
    // 本地版本
    NSString *appVersion = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    
    NSString *identifier = [[NSBundle mainBundle] bundleIdentifier];
    
    //商版本
    NSString *url = [NSString stringWithFormat:@"https://itunes.apple.com/cn/lookup?bundleId=%@",identifier];
    AFHTTPSessionManager *mgr = [AFHTTPSessionManager manager];
    
    [mgr GET:url parameters:nil headers:nil progress:^(NSProgress * _Nonnull downloadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        NSDictionary *responseDict = responseObject;
              if ([responseDict[@"resultCount"] integerValue] == 0) {
                  return;
              }
              // 商版本
              NSString *storeVersion = [(NSArray *)responseDict[@"results"] firstObject][@"version"];
              // 更新内容
              self.releaseNotes = [(NSArray *)responseDict[@"results"] firstObject][@"releaseNotes"];
              // 商链接
              self.trackViewUrl = [(NSArray *)responseDict[@"results"] firstObject][@"trackViewUrl"];
              
              //        NSLog(@"\n\nappVersion = %@\nstoreVersion = %@\ntrackViewUrl = %@ @\trackViewUrl = %@ ",appVersion, storeVersion, self.trackViewUrl,self.releaseNotes);
              
              [self compareString:appVersion string:storeVersion];
              
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
    }];
    
   
    
    
}

- (void)compareString:(NSString *)appVersion string:(NSString *)storeVersion {
    NSArray *currentVersionStr = [self makeArray:[appVersion componentsSeparatedByString:@"."]];
    NSArray *newVersionStr = [self makeArray:[storeVersion componentsSeparatedByString:@"."]];
    if ([newVersionStr[0] integerValue] > [currentVersionStr[0] integerValue]) {
        [self alertUpdateVC:storeVersion];
    }else if ([newVersionStr[0] integerValue] == [currentVersionStr[0] integerValue]) {
        if ([newVersionStr[1] integerValue] > [currentVersionStr[1] integerValue]) {
            [self alertUpdateVC:storeVersion];
        }else if ([newVersionStr[1] integerValue] == [currentVersionStr[1] integerValue]) {
            if ([newVersionStr[2] integerValue] > [currentVersionStr[2] integerValue]) {
                [self alertUpdateVC:storeVersion];
            }
        }
    }
}
- (void)alertUpdateVC:(NSString *)storeVersion {
    NSString *title = [NSString stringWithFormat:@"检测到新版本:%@",storeVersion];
    
    if ([[UIDevice currentDevice].systemVersion floatValue] >= 8.0) {
        
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:self.releaseNotes preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        }];
        
        UIAlertAction *updateAction = [UIAlertAction actionWithTitle:@"查看" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            [[UIApplication sharedApplication] openURL:[NSURL URLWithString:self.trackViewUrl]];
        }];
        [alertController addAction:cancelAction];
        [alertController addAction:updateAction];
        if (IsIPAD) {
            alertController.popoverPresentationController.sourceView = self.window.rootViewController.view;
            alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
        }

        if (self.window.rootViewController.presentedViewController == nil) {
           [self.window.rootViewController presentViewController:alertController animated:YES completion:nil];
        }
    }
}
- (NSArray *)makeArray:(NSArray *)array {
    NSMutableArray *arr = [NSMutableArray arrayWithArray:array];
    // 两位数字的版本号前面加0
    for (NSInteger i = 0; i < 3 - array.count; i ++) {
        [arr addObject:@"0"];
    }
    
    return arr;
}

//获取当前屏幕显示的viewcontroller
- (UIViewController *)getCurrentVC
{
    UIViewController *rootViewController = [UIApplication sharedApplication].keyWindow.rootViewController;
    
    UIViewController *currentVC = [self getCurrentVCFrom:rootViewController];
    
    return currentVC;
}

- (UIViewController *)getCurrentVCFrom:(UIViewController *)rootVC
{
    UIViewController *currentVC;
    
    if ([rootVC presentedViewController]) {
        // 视图是被presented出来的
        
        rootVC = [rootVC presentedViewController];
    }
    
    if ([rootVC isKindOfClass:[UITabBarController class]]) {
        // 根视图为UITabBarController
        
        currentVC = [self getCurrentVCFrom:[(UITabBarController *)rootVC selectedViewController]];
        
    } else if ([rootVC isKindOfClass:[UINavigationController class]]){
        // 根视图为UINavigationController
        
        currentVC = [self getCurrentVCFrom:[(UINavigationController *)rootVC visibleViewController]];
        
    } else {
        // 根视图为非导航类
        
        currentVC = rootVC;
    }
    
    return currentVC;
}


@end
