//
//  TFCourseStatusView.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/6/12.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TFCourseStatusView: UIView {
    var viewH:CGFloat = 80+51
    //占位图
    let bitmapImg = UIImageView.init()
    //主播暂时不在
    let leaveTemporarilyLabel = UILabel()
    //距离直播还有
    let clockLabel = UILabel()
    //20:21:55
    let clockTimeLabel = UILabel()
    let shadow_3 = NSShadow()
    let shadow_4 = NSShadow()
    
    var startTime:NSInteger = 0
    var timer:Timer? = nil
    
    var clockLabelWidth:CGFloat = 0
    override init(frame: CGRect) {
        super.init(frame: frame)
     
        self.isHidden = true
        
        self.bitmapImg.image = UIImage.init(named: "课程未开始")
        addSubview(self.bitmapImg)
        bitmapImg.contentMode = .scaleAspectFit
        self.addSubview(self.leaveTemporarilyLabel)

        shadow_3.shadowColor = UIColor(red: 0, green: 0, blue: 0,alpha:0.5)
        shadow_3.shadowBlurRadius = 3
        shadow_3.shadowOffset = CGSize(width: 0, height: 0)
        
        
        shadow_4.shadowColor = UIColor(red: 0, green: 0, blue: 0,alpha:0.5)
        shadow_4.shadowBlurRadius = 4
        shadow_4.shadowOffset = CGSize(width: 0, height: 0)
        

        self.leaveTemporarilyLabel.attributedText = NSMutableAttributedString.getAttributed(string: "主播暂时不在，请稍后再来", font: UIFont.nameFang("PingFang SC-Regular", size: 14), foregroundColor: UIColor(red: 126/255.0, green: 128/255.0, blue: 136/255.0, alpha: 1),shadow:shadow_3).setAlignment(.center)
        //-----------------
        self.addSubview(self.clockLabel)
        let clocKLabel_attributedText = NSMutableAttributedString.getAttributed(string: "距离直播开始还有", font: UIFont.nameFang("PingFang SC-Regular", size: 14), foregroundColor: .white ,shadow:shadow_4)

        self.clockLabel.attributedText = clocKLabel_attributedText
        
        clockLabelWidth = clocKLabel_attributedText.getWidth()
        self.addSubview(self.clockTimeLabel)
        
        self.clockLabel.isHidden = true
        self.clockTimeLabel.isHidden = true
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func clockTimeLabel_attributedText(text:String)
    {

        let clockTimeLabel_attributedText = NSMutableAttributedString.getAttributed(string: text, font: UIFont.nameFang("PingFang SC-Regular", size: 14), foregroundColor: UIColor.white,shadow:shadow_4)
        
        self.clockTimeLabel.attributedText = clockTimeLabel_attributedText
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        bitmapImg.frame = CGRect(x: (self.frame.width-160)/2, y: 0, width: 160, height: 80)
        leaveTemporarilyLabel.frame = CGRect(x: 0, y: bitmapImg.frame.maxY+4, width: self.frame.width, height: 20)
        clockLabel.frame = CGRect(x: bitmapImg.frame.origin.x-11, y: leaveTemporarilyLabel.frame.maxY+2, width: clockLabelWidth, height: 25)
        clockTimeLabel.frame = CGRect(x: clockLabel.frame.maxX+2, y: clockLabel.frame.origin.y, width: 80, height: 25)
        
    }
    
    func timeIntervalString(until timestamp: NSInteger) -> String {
        // 获取当前时间戳
        let currentTimestamp = TalkfunSharedTools.getCurrentDateString()
        
        // 计算时间差
        let interval = timestamp - currentTimestamp
        
        // 确保时间差为正值
        guard interval > 0 else {
            return String(format: "00:00:00")
        }
        
        // 计算小时、分钟和秒
        let hours = Int(interval) / 3600
        let minutes = (Int(interval) % 3600) / 60
        let seconds = Int(interval) % 60
        
        // 格式化为 xx小时:xx分钟:xx秒 的形式
        return String(format: "%02d:%02d:%02d", hours, minutes, seconds)
    }
    @objc public func timerStop()
    {
        if((self.timer) != nil)
        {
            self.timer!.invalidate()
            self.timer = nil
        }
       
    }
    
    func setDateContent(startTime:NSInteger)
    {
        if (self.startTime != startTime ) {
            self.startTime = startTime
        }
        //00:15:41
        let timeStr = self.timeIntervalString(until: startTime)
        self.clockTimeLabel_attributedText(text: timeStr)

        if ( TalkfunSharedTools.getCurrentDateString() < startTime  && self.timer == nil) {
            self.timer = Timer.scheduledTimer(timeInterval: 1.0, target: self, selector: #selector(timerAction), userInfo: nil, repeats: true)
            RunLoop.main.add(self.timer! , forMode: RunLoop.Mode.default)
            
            self.clockLabel.isHidden = false
            self.clockTimeLabel.isHidden = false
            
        }
        else if (TalkfunSharedTools.getCurrentDateString() >= startTime ){
            
            self.clockLabel.isHidden = true
            self.clockTimeLabel.isHidden = true
            
            self.timerStop()
        }

    }
    @objc public func timerAction()
    {
        self.setDateContent(startTime: self.startTime)
    }
}
