//
//  TF_UITableView.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/8/27.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_UITableView: UITableView {

    override init(frame: CGRect, style: UITableView.Style) {
        super.init(frame: frame, style: style)
        
        // 自定义UITableView的设置
        separatorStyle = .none
        backgroundColor = UIColor.white
        //表示UIScrollView不会根据安全区域调整其内边距。
        if #available(iOS 11.0, *) {
            self.contentInsetAdjustmentBehavior = .never
        } else {
            // Fallback on earlier versions
        }
        // 消除UITableView顶部和底部的间距
        self.separatorInset = UIEdgeInsets.zero
        self.estimatedSectionHeaderHeight = 0
        self.estimatedSectionFooterHeight = 0
        self.sectionHeaderHeight = 0.01
        self.sectionFooterHeight = 0.01
        self.tableHeaderView = UIView(frame: CGRect(x: 0, y: 0, width: 0, height: CGFLOAT_MIN))
        self.tableFooterView = UIView(frame: CGRect(x: 0, y: 0, width: 0, height: CGFLOAT_MIN))
        
     
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
