//
//  TF_HorBackQuestionView.swift
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2021/12/29.
//  Copyright © 2021 Talkfun. All rights reserved.
//

import UIKit


class TF_HorBackQuestionView: UIView,UITableViewDelegate,UITableViewDataSource {

    var datasource:[TFPlaybackQuestionData] = []
    var nodataView:UIView!
    @objc public var isShow:Bool = false  //记录是否显示该view
    @objc public var tableview:UITableView!
    var titleLab:UILabel!
    var closeBtn:UIButton!
    var noImg:UIImageView!
    var noLab:UILabel!
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.titleLab = UILabel.init()
        self.titleLab.text = "提问记录"
        self.titleLab.textAlignment = .center
        self.titleLab.textColor = UIColor(red: 48/255.0, green: 51/255.0, blue: 75/255.0, alpha: 1.0)
        self.titleLab.font = UIFont.PingFang(size: 18)
        self.addSubview(self.titleLab)
    
        self.closeBtn = UIButton.init()
        self.closeBtn.setImage(UIImage.init(named: "close_gray"), for: .normal)
        self.closeBtn.backgroundColor = UIColor.clear
        self.addSubview(self.closeBtn)
      
        self.tableview = UITableView.init(frame: CGRect.zero)
        self.tableview.delegate = self
        self.tableview.dataSource = self
        self.tableview.backgroundColor = UIColor.clear
        self.tableview.register(TF_BackQuestionCell.self, forCellReuseIdentifier: "horbackQuestion")
        self.tableview.separatorStyle = UITableViewCell.SeparatorStyle.none
        self.addSubview(self.tableview)
        
        self.nodataView = UIView.init()
       
        self.addSubview(self.nodataView)
      
        let noImg = UIImageView.init()
        noImg.frame = CGRect(x: (self.nodataView.frame.size.width-200)/2.0, y: 60, width: 200, height: 150)
        noImg.image = UIImage.init(named: "Default page_ask")
        self.noImg = noImg
        self.nodataView.addSubview(noImg)
     
    
        let noLabel = UILabel.init()
        noLabel.text = "暂无提问";
        noLabel.font = UIFont.PingFang(size: 16)
        noLabel.textColor = UIColor(red: 20/255.0, green: 23/255.0, blue: 26/255.0, alpha: 1.0)
        noLabel.textAlignment = .center
        self.noLab = noLabel
        self.nodataView.addSubview(noLabel)
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        self.titleLab.frame = CGRect(x: (self.frame.size.width-100)/2.0, y: 20, width: 100, height: 30)
        self.closeBtn.frame = CGRect(x: self.frame.size.width-10-30, y: 20, width: 30, height: 30)
        self.nodataView.frame = CGRect(x: 0, y: 70, width: self.frame.size.width, height: self.frame.size.height-70)

        self.tableview.frame = CGRect(x: 0, y: 70, width: self.frame.size.width, height: self.frame.size.height-70)
      
        self.noImg.frame = CGRect(x: (self.nodataView.frame.size.width-200)/2.0, y: (self.nodataView.frame.size.height-150)/2.0, width: 200, height: 150)
        self.noLab.frame = CGRect(x: 0, y: self.noImg.frame.maxY-40, width: self.nodataView.frame.size.width, height: 22)
       
    }
    
    //回放提问信息
    func updatePlayBackQuestion(list:NSMutableArray?) {
        
         self.datasource.removeAll()
         list?.forEach({  model1 in
            self.datasource.append(model1 as! TFPlaybackQuestionData)
          })
          
          self.tableview.reloadData()
        let indexpath = NSIndexPath.init(row: self.datasource.count - 1, section: 0)
        self.tableview.scrollToRow(at: indexpath as IndexPath, at: .bottom, animated: true)
    
          if self.datasource.count > 0 {
              self.nodataView.isHidden = true
          } else {
              self.nodataView.isHidden = false
          }
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return self.datasource.count
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        let model:TFPlaybackQuestionData = self.datasource[indexPath.row]
        
        return self.getHeight(model: model)
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "horbackQuestion", for: indexPath) as! TF_BackQuestionCell
     
        cell.cellwidth = self.frame.size.width
        cell.selectionStyle = .none
        cell.isQuestion = true
        cell.isChatArea = false
        cell.isOrientationLandscape = true
        let model:TFPlaybackQuestionData = self.datasource[indexPath.row]
        cell.setmodel(model: model)
        

        return cell
    }
    
    func getHeight(model:TFPlaybackQuestionData) -> CGFloat {

        let nickname = model.nickname + " "
        let str11 = nickname + model.content
        let AttributedString11 = NSMutableAttributedString.init(string: str11)
       
        let font:UIFont = UIFont.systemFont(ofSize: 14)
        
        let size = TalkfunSharedTools.getSizeLabel(labelString: AttributedString11, labelWidth:self.tableview.frame.size.width-35-16-12-16, labelfont: font)
        
    
        if (model.answer.count > 0) {
            var height:CGFloat = 0;
            var anserwidth:CGFloat = 0;
          
            for i in 0..<model.answer.count {
                let answer:TFPlaybackQuestionAnswer = model.answer[i] as! TFPlaybackQuestionAnswer
            
                let str1 = answer.nickname + answer.content
                let AttributedString1 = NSMutableAttributedString.init(string: str1)

                let attr132: [NSAttributedString.Key : Any] = [.font: UIFont.systemFont(ofSize: 14),]
                AttributedString1.addAttributes(attr132, range: NSRange(location: 0, length: str1.count))
             
                let attch = NSTextAttachment.init()
               
               
                attch.bounds = CGRect(x: 0, y: -3, width: 27, height: 15)
                let imageStr = NSAttributedString.init(attachment: attch)
                AttributedString1.insert(imageStr, at: answer.nickname.count+1)
                let Attri = NSAttributedString.init(string: " ")
                AttributedString1.insert(Attri, at: answer.nickname.count+2)
            
                
                let AttributeName: [NSAttributedString.Key : Any] = [.kern:5]
                AttributedString1.addAttributes(AttributeName, range: NSRange(location: answer.nickname.count+2, length: 1))
                
                
                let attr22: [NSAttributedString.Key : Any] = [.font: UIFont.systemFont(ofSize: 14),]
                
                AttributedString1.addAttributes(attr22, range: NSRange(location: answer.nickname.count+2, length: answer.content.count))
                let attr24: [NSAttributedString.Key : Any] = [.font: UIFont.systemFont(ofSize: 14),]
                AttributedString1.addAttributes(attr24, range: NSRange(location: 0, length: AttributedString1.length))
          
                let answersize = TalkfunSharedTools.getSizeLabel(labelString: AttributedString1, labelWidth:self.tableview.frame.size.width-35-16-12-16, labelfont: font)
                
                
  
               //取最大值
                anserwidth = answersize.width > anserwidth ? answersize.width: anserwidth
           
             
                height = height+answersize.height+10;
            
                
            }
            
            return size.height+10+1+height+8;

        } else {
            
            return size.height+8+12;
        
        }
        
    }
    
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

}
