//
//  TLuckyBagNoticeCell.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/21.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TLuckyBagNoticeCell: UITableViewCell {
    
    @objc public var cellwidth:CGFloat = 0
    
    @objc public var model:TF_LivingChatData?
    {
        didSet{
            if(model != nil)
            {
                self.setModelUI(model: model!)
            }
        }
    }
  
    @objc public let bgView = UIView()
    @objc public let avatarImageView = UIImageView()
    let content = TF_StoyCopyTextView.init()
    
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)

        
        bgView.backgroundColor = UIColor(red: 62/255.0, green: 122/255.0, blue: 241/255.0, alpha: 0.5)
        bgView.addSubview(avatarImageView)
        avatarImageView.image = UIImage(named: "福袋通知图标")
        

        self.contentView.addSubview(self.bgView)
        bgView.layer.masksToBounds = true
        bgView.layer.cornerRadius = 8
        
        
        bgView.addSubview(self.content)
        self.content.backgroundColor = UIColor.clear
        self.content.isScrollEnabled = false
        self.content.textContainer.lineFragmentPadding = 0
        self.content.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        
    }
    
    static func getBgViewWidth(_ cellwidth:CGFloat)->CGFloat
    {
        return  cellwidth-10.0-85.0
    }
    func setModelUI(model:TF_LivingChatData)
    {
      if let luckyBagNoticeAttributedString = model.luckyBagNoticeAttributedString
        {
          //左10  右85
          var bgViewWidth = TLuckyBagNoticeCell.getBgViewWidth(cellwidth)
          
          if luckyBagNoticeAttributedString.getWidth()+37+16<bgViewWidth {
              bgViewWidth = luckyBagNoticeAttributedString.getWidth()+37+16
          }
          
          let bgViewHegiht = luckyBagNoticeAttributedString.requiredHeight(forWidth: bgViewWidth)
          
        //上9  下8   左47 右16
          bgView.frame = CGRect(x: 10, y: 9, width: bgViewWidth, height: bgViewHegiht+9+9)
          avatarImageView.frame = CGRect(x: 8, y: 10, width: 20, height: 20)
          
          let contentWidth = bgView.frame.width-37-16
          content.frame = CGRect(x: 37, y: 9.0, width: contentWidth , height: bgView.frame.height-9-9)
                            
          content.attributedText = luckyBagNoticeAttributedString
      }
         
 
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
