class TF_LivingProgress: UIButton {
    
    /// 0-1;
    @objc public var progress: CGFloat = 0
    // 完整的颜色
    var wholeColor = UIColor(red: 220/255.0, green: 238/255.0, blue: 255/255.0, alpha: 1.0)
    // 进度的颜色
    var speedColor = UIColor(red: 65/255.0, green: 150/255.0, blue: 235/255.0, alpha: 1.0)
    
    @objc func progressUI(value: CGFloat) {
        self.progress = value
        self.setNeedsDisplay()
    }
    
    override func draw(_ rect: CGRect) {
        let lineWidth: CGFloat = 4

        // 获取上下文
        guard let ctx = UIGraphicsGetCurrentContext() else { return }

        let center = CGPoint(x: self.frame.size.width / 2, y: self.frame.size.height / 2) // 设置圆心位置
        // 设置半径
        let radius = self.frame.size.width / 2 - (lineWidth / 2)
        
        // 圆起点位置
        let startA = -Double.pi / 2
        // 圆终点位置
        let endA = startA + Double.pi * 2

        let path = UIBezierPath(arcCenter: center, radius: radius, startAngle: CGFloat(startA), endAngle: CGFloat(endA), clockwise: true)

        // 设置线条宽度
        ctx.setLineWidth(lineWidth)
        // 设置描边颜色
        wholeColor.setStroke()
        ctx.setAlpha(1)
        // 把路径添加到上下文
        ctx.addPath(path.cgPath)
        // 渲染
        ctx.strokePath()

        // 设置进度圆弧
        let progressEndA = startA - Double.pi * 2 * Double(self.progress)
        let progressPath = UIBezierPath(arcCenter: center, radius: radius, startAngle: CGFloat(startA), endAngle: CGFloat(progressEndA), clockwise: false)

        // 设置线条宽度
        ctx.setLineWidth(lineWidth)
        // 设置描边颜色
        speedColor.setStroke()
        // 把路径添加到上下文
        ctx.addPath(progressPath.cgPath)
        // 渲染
        ctx.strokePath()
    }
}
