//
//  TF_LivingNavigationBar.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/4/7.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit

class TF_LivingNavigationBar: TalkfunHitTestView {
    @objc public let view = TalkfunHitTestView()
    //浮动广告列表,目前仅支持竖屏模式
    @objc public let adListView = TF_AdListView()
    //直播关闭
    @objc public let livingClose = UIButton()
    //直播刷新
    @objc public let livingRefresh = UIButton()
    //邀请榜单UIButton
    @objc public let invitationList = TF_InvitationList()
    @objc public var mNavigationbarHeight:CGFloat = 0
    @objc public let zhuboView = UIView()
    
    var offset_value_y:CGFloat = 0
    //主播头像
    @objc public let avatarImage = UIImageView()
    //主播名字
    @objc public let nicknameLabel = UILabel()
    //在线观看人数
    @objc public let viewersLabel = UILabel()
    //关注
    @objc public let attentionButton = UIButton()
    //关注的背景
    @objc public let attentionButtonbackgroundColor = UIView()
    
    //课程未开始前的处理
    let courseStatus = TFCourseStatusView()

    //直播结束
//    @objc public let liveBroadcastClosedImage = UIImageView()
//    //直播结束label
//    @objc public let liveBroadcastClosedLabel = UILabel()
    //滚动通知
    @objc public let announceRollView = TF_AnnounceRollView()
    
    //观看
    let watchLabel = UILabel()
    let gl = CAGradientLayer()
    /**pageViewMode 生活直播专用
     0二分屏  横屏
     1竖屏
     2课件模式
     3三分屏
     **/
    func setPageViewMode(_ pageViewMode:NSInteger)
    {
        
        if pageViewMode==0 {
            livingClose.isHidden = true
            livingRefresh.isHidden = true
            zhuboView.isHidden = true
            adListView.isHidden = true
            
        }else{
            livingClose.isHidden = false
            livingRefresh.isHidden = false
            zhuboView.isHidden = false
            adListView.isHidden = false
        }
        
        
    }
    override init(frame: CGRect) {
        super.init(frame: frame)
        //TODO:浮动广告列表VIew
    
        self.adListView.backgroundColor = UIColor.clear
        self.addSubview(self.adListView)
        adListView.isUserInteractionEnabled = false
        

        self.addSubview(self.view)
        //TODO:退出直播间
        self.livingClose.setImage(UIImage.init(named: "LivingClose"), for: .normal)
        self.livingClose.backgroundColor = UIColor.clear
        self.addSubview(self.livingClose)
        livingClose.setLightGrayShadow()
    
        //TODO:
        self.zhuboView.backgroundColor = UIColor(red: 0/255.0 , green: 0/255.0 , blue: 0/255.0 , alpha: 0.3)
        self.view.addSubview(self.zhuboView)
        
        //TODO:邀请榜单
        self.invitationList.isHidden = true
        self.invitationList.backgroundColor = UIColor(red: 0/255.0 , green: 0/255.0 , blue: 0/255.0 , alpha: 0.3)
        self.invitationList.layer.cornerRadius = 11.5
        self.view.addSubview(self.invitationList)
        
        //TODO:刷新
        self.livingRefresh.setImage(UIImage.init(named: "livingRefresh"), for: .normal)
        self.livingRefresh.backgroundColor = UIColor.clear
        self.addSubview(self.livingRefresh)
        livingRefresh.setLightGrayShadow()
        
        //TODO:主播头像
        self.avatarImage.contentMode = .scaleAspectFill;
        self.avatarImage.backgroundColor = UIColor.clear
        self.zhuboView.addSubview(self.avatarImage)
        //TODO:主播名字
        self.nicknameLabel.numberOfLines = 0
        self.zhuboView.addSubview(self.nicknameLabel)
        self.nicknameLabel.font = UIFont.PingFang(size: 14)

        self.nicknameLabel.textColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1)
     
        ////在线观看人数
        self.viewersLabel.numberOfLines = 0;
        self.zhuboView.addSubview(self.viewersLabel)
        self.viewersLabel.textColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1)
        self.viewersLabel.font = UIFont.PingFang(size: 10)
    
        self.zhuboView.addSubview(self.attentionButtonbackgroundColor)
        self.attentionButtonbackgroundColor.layer.addSublayer(self.gl)
      
        //关注
        self.attentionButtonbackgroundColor.isHidden = true
        self.attentionButton.isHidden = true
        self.zhuboView.addSubview(self.attentionButton)
        self.attentionButton.setTitle("关注", for: .normal)
        self.attentionButton.titleLabel!.font = UIFont.PingFang(size: 14)
        //--------------------
        self.addSubview(courseStatus)
       
        //-------------
        //TODO:直播结束图片
//        self.liveBroadcastClosedImage.isHidden = true
//        self.liveBroadcastClosedImage.image = UIImage.init(named: "TalkfunLivingLiveBroadcastClosed")
//      
//        self.liveBroadcastClosedImage.contentMode =  .scaleToFill;
//        self.liveBroadcastClosedImage.backgroundColor = UIColor.clear
//        self.addSubview(self.liveBroadcastClosedImage)
//        
//        //TODO:直播结束UILabel
//        self.liveBroadcastClosedLabel.isHidden = true
//        self.liveBroadcastClosedLabel.numberOfLines = 0;
//        self.addSubview(self.liveBroadcastClosedLabel)
//        self.liveBroadcastClosedLabel.textAlignment = .center
//
//        self.liveBroadcastClosedLabel.attributedText = NSMutableAttributedString.getAttributed(string: "直播已结束", font: UIFont.PingFang(size: 18), foregroundColor: UIColor(red: 177/255.0, green: 209/255.0, blue: 248/255.0, alpha: 1));
//        self.liveBroadcastClosedLabel.textColor = UIColor(red: 177/255.0, green: 209/255.0, blue: 248/255.0, alpha: 1)
//        self.liveBroadcastClosedLabel.alpha = 1.0
    
        //TODO:滚动通知
        self.addSubview(self.announceRollView)
        
    }
    
  
  
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        let avatarImageH = 35.0
        let avatarImageY = 2.5
      
        let livingCloseH:CGFloat = 30
        let livingCloseY:CGFloat = mNavigationbarHeight + ((avatarImageH-livingCloseH)/2)+avatarImageY+(livingCloseH/4)
        self.livingClose.frame = CGRect(x: self.frame.size.width - 30 - 15, y: livingCloseY, width: livingCloseH, height: livingCloseH)
       
        self.adListView.frame = CGRect(x: 0, y: livingCloseY, width: self.frame.size.width, height: self.frame.size.height - livingCloseY)
       
        self.livingRefresh.frame = CGRect(x: self.frame.size.width - 30 - 15, y: self.livingClose.frame.maxY+15, width: livingCloseH, height: livingCloseH)
     
        if (self.zhuboView.frame.size.width > 0 ) {
            self.zhuboView.layer.cornerRadius = 20;
            
            self.avatarImage.layer.masksToBounds = true
            
            
            self.avatarImage.frame = CGRect(x: 3.5, y: avatarImageY, width: 35, height: avatarImageH)
    
            self.avatarImage.layer.cornerRadius = self.avatarImage.frame.size.height / 2.0;
            self.nicknameLabel.frame = CGRect(x: 45, y: avatarImageY, width: 81, height: 20)
        
            self.viewersLabel.frame = CGRect(x: 45, y: self.zhuboView.frame.size.height - 14 - 3, width: 47.5, height: 14)
            
            
            self.attentionButtonbackgroundColor.frame = CGRect(x: self.zhuboView.frame.size.width - 40 - 8, y: 6, width: 40, height: 28)
            self.attentionButton.frame = self.attentionButtonbackgroundColor.frame
            self.gl.frame = self.attentionButton.bounds;
            self.gl.startPoint = CGPoint(x: 0.5, y: 0)
          
            self.gl.endPoint = CGPoint(x: 0.5, y: 1)
            self.gl.colors = [UIColor(red: 255/255.0, green: 172/255.0, blue: 77/255.0, alpha: 1.0).cgColor, UIColor(red: 255/255.0, green: 114/255.0, blue: 78/255.0, alpha: 0.3).cgColor]
            self.gl.locations = [0,1]
            self.gl.cornerRadius = 14
        }
        
        courseStatus.frame = CGRect(x: 0, y: (self.frame.height-courseStatus.viewH)/2, width: self.frame.size.width, height: courseStatus.viewH)
        
        //加5 是为了不与弹窗关注,有重叠
//        let spacing:CGFloat = -50;


//        let liveBroadcastClosedY:CGFloat = 176/667.0*self.frame.size.height
//        
//        self.liveBroadcastClosedImage.frame = CGRect(x: (self.frame.size.width - 110)/2, y: liveBroadcastClosedY, width: 110, height: 110)
//   
//        self.liveBroadcastClosedLabel.frame = CGRect(x: 0, y: self.liveBroadcastClosedImage.frame.maxY+10, width: self.frame.size.width, height: 25)

        //榜单点击button
        self.invitationList.frame = CGRect(x: 0, y: self.zhuboView.frame.maxY+20, width: 95, height: 23)
        
        //滚动通知
        self.announceRollView.frame = CGRect(x: 0, y: self.invitationList.frame.maxY+10, width: self.frame.size.width, height: 36)
    
    }
    //直播结束是否隐藏
    @objc public func liveBroadcastClosed(hidde:Bool)
    {
//        self.liveBroadcastClosedImage.isHidden = hidde
//        self.liveBroadcastClosedLabel.isHidden = hidde
    }
  
    //直播开始
    @objc public func liveStarted()
    {
      
        self.courseStatus.isHidden = true
        
//        //直播结束
//        self.liveBroadcastClosedImage.isHidden = true
//        //直播结束label
//        self.liveBroadcastClosedLabel.isHidden = true
     
        
    }
}
