//
//  TF_LivingPptView.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/8/26.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit
import TalkFunBarrageRenderer

typealias TF_LivingPptView_customFrameBlock = (_ frame:CGRect) -> Void
class TF_LivingPptView_custom: UIView {

    var customAvatarBorderY:CGFloat = 0
    @objc public var frameBlock:TF_LivingPptView_customFrameBlock?
    override func layoutSubviews() {
        super.layoutSubviews()
        
        if frameBlock != nil {
            frameBlock!(CGRect(x: 00, y: 0, width: self.frame.width, height: self.frame.height))
        }
    }
}
class TF_LivingPptView: UIView {

    let backgroundImageView = UIImageView(image: UIImage(named: "life_whiteboard_bg"))
    let emptyDocument = UIImageView(image: UIImage(named: "life_ic_courseware"))

    let view = TF_LivingPptView_custom()
    //工具按键 ,默认隐藏, 横屏模式再显示
    let tool = TF_LivingPptViewTool()
    let mNavigationbarHeight = UIDevice.xp_safeDistanceTop()
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.view.backgroundColor = .white
        self.addSubview(backgroundImageView)
        self.addSubview(emptyDocument)

        self.addSubview(view)


        tool.isHidden = true
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        backgroundImageView.frame = CGRect(x: 0, y: 0, width: self.frame.width, height: self.frame.height)
        tool.frame = CGRect(x: 0, y: mNavigationbarHeight, width: self.frame.width, height: self.frame.height)
        view.frame = CGRect(x: 0, y: 0, width: self.frame.width, height: self.frame.height)
        
        emptyDocument.frame = CGRect(x: (self.frame.width-34)/2, y: (self.frame.height-34)/2, width: 34, height: 34)
        
    }
    /**pageViewMode 生活直播专用
     0二分屏  横屏
     1竖屏
     2课件模式
     3三分屏
     **/
    func setPageViewMode(_ pageViewMode:NSInteger)
    {
        if pageViewMode==0 {
            tool.isHidden = false
        }else{
            tool.isHidden = true
        }
    }
}
class TF_LivingPptViewTool: TalkfunHitTestView {
    /**返回*/
    let gobackBtn = UIButton()
    /**刷新*/
    let refreshBtn = UIButton()
    /**弹幕*/
    let barrageBtn = UIButton()
    /**全屏*/
    let fullScreenBtn = UIButton()
    /**总人数**/
    let totalLabel = UILabel()
    
    //弹幕
    let barrageRender = TalkFunBulletView()
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        
        self.addSubview(totalLabel)
        totalLabel.backgroundColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.3)
        totalLabel.isHidden = true

        self.addSubview(gobackBtn)
        gobackBtn.setImage(UIImage(named: "goback"), for: .normal)
        gobackBtn.setLightGrayShadow()
        
        self.addSubview(refreshBtn)
        refreshBtn.setImage(UIImage(named: "mask_icon_reflesh"), for: .normal)
        refreshBtn.setLightGrayShadow()
        
        self.addSubview(barrageBtn)
        barrageBtn.setImage(UIImage(named: "弹幕开"), for: .selected)
        barrageBtn.setImage(UIImage(named: "弹幕关"), for: .normal)
        barrageBtn.setLightGrayShadow()
        
        self.addSubview(fullScreenBtn)
        fullScreenBtn.setImage(UIImage(named: "退出全屏"), for: .selected)
        fullScreenBtn.setImage(UIImage(named: "进入全屏"), for: .normal)
        fullScreenBtn.setLightGrayShadow()
        
        barrageBtn.isSelected = true
        self.barrageRender.bulletSwitch = true
        self.barrageRender.tf_height = 136
        self.barrageRender.isUserInteractionEnabled = false
        self.addSubview(barrageRender)
        barrageBtn.addTarget(self, action: #selector(self.barrageBtnClick), for: .touchUpInside)
    }
    @objc func barrageBtnClick(btn:UIButton)
    {
        btn.isSelected = !btn.isSelected
        self.barrageRender.bulletSwitch = btn.isSelected
    }
   
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
       
        let refreshBtn_y = self.frame.height-24-10
        refreshBtn.frame = CGRect(x: 12, y: refreshBtn_y, width: 24, height: 24)
        gobackBtn.frame = CGRect(x: 12, y: 10, width: 24, height: 24)
        
        
        let fullScreenBtn_y = refreshBtn_y
        fullScreenBtn.frame = CGRect(x: self.frame.width-24-12, y: fullScreenBtn_y, width: 24, height: 24)
        
        let barrageBtn_x = fullScreenBtn.frame.origin.x-16-24
        let barrageBtn_y = fullScreenBtn_y
        barrageBtn.frame = CGRect(x: barrageBtn_x, y: barrageBtn_y, width: 24, height: 24)
        
        
        self.barrageRender.frame = CGRect(x: 0, y: 0, width: self.frame.width, height: self.frame.height)
    }
}
