//
//  TF_LivingSuperPreview.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/8/26.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_LivingSuperPreview: TFtouchesMoved {
    var tempFrame:CGRect = CGRect(x: 0, y: 0, width: 0, height: 0)
    /**视频容器*/
    let cameraContainerView = TF_LivingSuperPreviewCamera()

    /**桌面分享容器*/
    let desktopContainerView = UIView()
    /**暖场视频*/
    let warmupContainerView = UIView()
    
    //全屏
    let fullScreenBtn = TF_LivingSuperPreview_btn()
    //切换
    let switchBtn = UIButton()
    //缩小
    let shrinkBtn = UIButton()
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.backgroundColor = .white
        self.addSubview(cameraContainerView)
        self.cameraContainerView.isUserInteractionEnabled = false
           
        self.desktopContainerView.isHidden = true
        self.desktopContainerView.isUserInteractionEnabled = false
        self.desktopContainerView.backgroundColor = UIColor.black
        self.addSubview(desktopContainerView)
        
        //TODO:暖场视频
        self.warmupContainerView.isHidden = true
        self.warmupContainerView.isUserInteractionEnabled = false
        self.warmupContainerView.backgroundColor = UIColor.clear
        self.addSubview(warmupContainerView)
        
       
        fullScreenBtn.backgroundColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.5)
        self.addSubview(fullScreenBtn)
        fullScreenBtn.isHidden = true
        
        switchBtn.setImage(UIImage(named: "容器切换"), for: .normal)
        self.addSubview(switchBtn)
        switchBtn.isHidden = true
        
        shrinkBtn.setImage(UIImage(named: "最小化"), for: .normal)
        self.addSubview(shrinkBtn)
        shrinkBtn.isHidden = true
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        cameraContainerView.frame = self.bounds

        desktopContainerView.frame = self.bounds
        warmupContainerView.frame = self.bounds
        
        fullScreenBtn.frame = CGRect(x: self.frame.width-12-20, y: self.frame.height-20-8, width: 20, height: 20)
        
        shrinkBtn.frame = CGRect(x: self.frame.width-12-16, y: 3, width: 16, height: 16)
        switchBtn.frame = CGRect(x: fullScreenBtn.frame.origin.x-6-16, y: 3, width: 16, height: 16)
        
        
    }
    
}
class TF_LivingSuperPreview_btn: TF_LivingSuperPreviewCameraBtn {

    let btn = UIButton()
    override init(frame: CGRect) {
        super.init(frame: frame)
        btn.setImage(UIImage(named: "进入全屏"), for: .normal)
        btn.setImage(UIImage(named: "退出全屏"), for: .selected)
        self.addSubview(btn)
        
        self.layer.masksToBounds = true
        self.layer.cornerRadius = 4
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        self.btn.frame = CGRect(x: (self.frame.width-12)/2, y: (self.frame.height-12)/2, width: 12, height: 12)
    }
    override func point(inside point: CGPoint, with event: UIEvent?) -> Bool {
        
        let biggerFrame =  self.bounds.insetBy(dx: -4, dy:  -4)

        return biggerFrame.contains(point)
    }

}

class TF_LivingSuperPreviewCamera: UIView {
    /**语音直播*/
    let voiceLive = TF_VoiceLive.init(frame: CGRect(x: 0, y: 0, width: 0, height: 0))
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.voiceLive.isHidden = true
        self.voiceLive.isUserInteractionEnabled = false
        self.addSubview(voiceLive)
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
    
        if voiceLive.superview == self {
            voiceLive.frame = self.bounds
        }
        
    }
}
//增大区域
class TF_LivingSuperPreviewCameraBtn: UIButton {
    var dx:CGFloat = 4
    var dy:CGFloat = 4
    override func point(inside point: CGPoint, with event: UIEvent?) -> Bool {
        
        let biggerFrame =  self.bounds.insetBy(dx: -dx, dy:  -dy)

        return biggerFrame.contains(point)
    }

    
}
