//
//  TF_Pull_upView.swift
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2022/4/3.
//  Copyright © 2022 Talkfun. All rights reserved.
//

import UIKit
typealias TF_Pull_upViewBtnBlock = (_ btn:TF_TitleButton) -> Void
class TF_Pull_upView: TF_TopRightOrCornerTopLeft  {

    var pageViewMode:NSInteger = 1
    
    let line = UIView()
    let titleScrollView = UIScrollView()
    var titleBtnArray:[TF_TitleButton] = []
    
    let wkWebScrollView = UIScrollView()
    var wkWebViewArray:[TF_PPTWKWebView] = []

    //二分屏专用  关注
    let follow = UIButton()
    var btnBlock:TF_Pull_upViewBtnBlock?
    override init(frame: CGRect) {
        super.init(frame: frame)

        self.titleScrollView.isPagingEnabled = true
        self.titleScrollView.showsVerticalScrollIndicator = false
        self.titleScrollView.showsHorizontalScrollIndicator = false
        self.addSubview(self.titleScrollView)
        //线
        self.line.backgroundColor = UIColor(red: 238/255.0, green: 238/255.0, blue: 239/255.0, alpha: 1.0)
        self.addSubview(self.line)
  
        self.wkWebScrollView.isPagingEnabled = true;
        self.wkWebScrollView.isScrollEnabled = false
        self.addSubview(self.wkWebScrollView)
        //-------
        follow.titleLabel?.font = UIFont.PingFang(size: 15)
        follow.setTitle("关注", for: .normal)
        follow.backgroundColor = UIColor(red: 1/255, green: 194/255, blue: 255/255, alpha: 1)
        self.addSubview(follow)
        follow.isHidden = true
        follow.layer.masksToBounds = true
        
       
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        var titleScrollView_width = self.frame.size.width
        if pageViewMode==0 {
            titleScrollView_width = self.frame.width-10-50-10
        }
        titleScrollView.frame = CGRect(x: 0, y: 0, width: titleScrollView_width, height: 40)
        
        follow.frame = CGRect(x: titleScrollView_width, y: (titleScrollView.frame.height-30)/2, width: 55, height: 30)
        follow.layer.cornerRadius = follow.frame.height/2

       
        line.frame = CGRect(x: 0, y: titleScrollView.frame.height-0.5, width: self.frame.size.width, height: 0.5)
        
        self.wkWebScrollView.frame = CGRect(x: 0, y: self.line.frame.maxY, width: self.frame.size.width, height: self.frame.size.height-self.line.frame.maxY)
     
        
    }
    @objc func btnClick(btn:TF_TitleButton)
  
    {
        for i in stride(from: 0, to: self.titleBtnArray.count ,by: 1) {
            let view = self.titleBtnArray[i]
            view.setTitleColor(UIColor(red: 77/255.0, green: 83/255.0, blue: 88/255.0, alpha: 1.0), for: .normal)
            //灰色
            
             view.Underline.isHidden = true
        }
        //蓝色
        btn.setTitleColor(UIColor(red: 1/255.0, green: 194/255.0, blue: 255/255.0, alpha: 1.0), for: .normal)
        
        
        btn.Underline.isHidden = false
        let btnWidth:CGFloat = self.frame.size.width
        
        self.wkWebScrollView.setContentOffset(CGPoint(x: Int(btnWidth)*btn.tag, y: 0), animated: true)
       
        
         var t:Int = btn.tag;

         let tabsData = self.wkWebViewArray[t]
        
        let isurl = TalkfunSharedTools.isWhetherNoUrl(tabsData.content as String)
        
        if (isurl) {
            TalkfunSharedTools.openUrl(str: tabsData.content as NSString)
        }

        
        let i:Int = Int(self.frame.size.width)/90
            t = t+1
   
        if (t>=i) {
            if (t==self.wkWebViewArray.count) {
                self.titleScrollView.contentOffset = CGPoint(x: 90*(self.wkWebViewArray.count-i), y: 0)
                
            } else {
                self.titleScrollView.contentOffset = CGPoint(x:90*(t-i+1), y: 0)
            }
        } else {
            self.titleScrollView.contentOffset =  CGPoint(x:0, y: 0)
    
        }
        if pageViewMode==0 {
            if btnBlock != nil {
                btnBlock!(btn)
            }
        }
        
    }
    
   @objc public func destroy()
    {
        for i in stride(from: 0, to: self.wkWebViewArray.count ,by: 1) {
        let view = self.wkWebViewArray[i]
            view.removeFromSuperview()

        }
        self.wkWebViewArray.removeAll()

    }
    @objc public func getPPTVIew()->(UIView?)
    {
    
        for i in stride(from: 0, to: self.wkWebViewArray.count ,by: 1) {
        let view = self.wkWebViewArray[i]
        
            if (view.type == "courseware") {
                return view.PPTView
            }
            
        }

        return nil;

    }
    @objc public func getChatView()->(UIView)
    {
    
        for i in stride(from: 0, to: self.wkWebViewArray.count ,by: 1) {
        let view = self.wkWebViewArray[i]
        
            if (view.type == "chat") {
                return view
            }
            
        }

        return UIView();

    }
    
    /**pageViewMode 生活直播专用
     0二分屏  横屏
     1竖屏
     2课件模式
     3三分屏
     **/
    func initUI(tabsDataList: [TFtabsData],pageViewMode:NSInteger)

    {
        self.pageViewMode = pageViewMode
        if pageViewMode==0 {
            self.follow.isHidden = false
        }else{
            self.follow.isHidden = true
        }
        self.wkWebScrollView.setContentOffset(CGPoint(x: 0, y: 0), animated: false)
      
        var newTabsDataList:[TFtabsData] = []
        for i in stride(from: 0, to: tabsDataList.count ,by: 1) {
           let tabsData = tabsDataList[i]
            
            if pageViewMode==0 {
                //不要课件
                if ( tabsData.type != "courseware") {
                    newTabsDataList.append(tabsData)
                }
                
            }
           else if pageViewMode==1 {
                //竖屏模式
                //不是聊天  不是榜单
                if (tabsData.type != "chat" && tabsData.type != "invite") {
                    newTabsDataList.append(tabsData)
                }
            }
            else if pageViewMode==2 || pageViewMode==3 {
                //课件模式
                //不是聊天  不是榜单
                if (tabsData.type != "chat" && tabsData.type != "invite" && tabsData.type != "courseware") {
                    newTabsDataList.append(tabsData)
                }
                
            }
            
         
        }
        for i in stride(from: 0, to: self.titleBtnArray.count ,by: 1) {
        let view = self.titleBtnArray[i]

            view.removeFromSuperview()

        }
        self.titleBtnArray.removeAll()

        for i in stride(from: 0, to: self.wkWebViewArray.count ,by: 1) {
        let view = self.wkWebViewArray[i]
            view.removeFromSuperview()

        }
        self.wkWebViewArray.removeAll()

        
        self.wkWebScrollView.contentSize = CGSize(width: CGFloat(newTabsDataList.count)*self.wkWebScrollView.frame.size.width, height: self.wkWebScrollView.frame.size.height)
        
        
        let width:Int = 90
        for i in stride(from: 0, to: newTabsDataList.count ,by: 1) {

            let tabsData = newTabsDataList[i]
            
            let titleButton = TF_TitleButton()
          
            titleButton.tag = i
            titleButton.titleStr = tabsData.title
            titleButton.setTitle(tabsData.title, for: .normal)

            titleButton.titleLabel!.font = UIFont.PingFang(size: 15)

            titleButton.frame = CGRect(x: width*i, y: 0, width: width, height: Int(self.titleScrollView.frame.size.height))

            if (i == 0) {
                
                titleButton.setTitleColor(UIColor(red: 1/255.0, green: 194/255.0, blue: 255/255.0, alpha: 1.0), for: .normal)
                //蓝色
            
                titleButton.Underline.isHidden = false
            }else{
                //灰色
                titleButton.setTitleColor(UIColor(red: 77/255.0, green: 83/255.0, blue: 88/255.0, alpha: 1.0), for: .normal)
               
                titleButton.Underline.isHidden = true
            }
            titleButton.addTarget(self, action: #selector(self.btnClick(btn:)), for: .touchUpInside)
            
            self.titleScrollView.addSubview(titleButton)
            self.titleBtnArray.append(titleButton)
  
            let WebView = TF_PPTWKWebView()
            WebView.frame = CGRect(x: self.wkWebScrollView.frame.size.width * CGFloat(i), y: 0, width: self.wkWebScrollView.frame.size.width, height: self.wkWebScrollView.frame.size.height)
     
          
            self.wkWebScrollView.addSubview(WebView)
            self.wkWebViewArray.append(WebView)
          
            
            WebView.tag = i
            WebView.type = tabsData.type as NSString;
            //课件
            if (WebView.type == "courseware") {
                WebView.coursewareUI()
              
            }
            //自定义链接
          else if (WebView.type == "link") {
              WebView.linkUI(content: tabsData.content as NSString)

            }else if (WebView.type == "editor") {
            //自定义图文
                WebView.editorUI(msg: tabsData.content as NSString)

              
            }
      
        }

        if (width*newTabsDataList.count > Int(self.frame.size.width)) {
            self.titleScrollView.contentSize = CGSize(width: width*newTabsDataList.count, height: 0)
        } else {
            self.titleScrollView.contentSize = CGSize(width: Int(self.frame.size.width), height: 0)
        }

    }
    @objc public func isShow(value:Bool)
    {
        if pageViewMode==0 {
            return
        }
        if let superview = self.superview
        {
            UIView.animate(withDuration: 0.5) {
                
           let pull_upViewHight:CGFloat = 397
                if (value) {
                    
                    self.frame = CGRect(x: 0, y: superview.frame.size.height - pull_upViewHight, width: superview.frame.size.width, height: pull_upViewHight)
       
                }else{
                   
                    self.frame = CGRect(x: 0, y: superview.frame.size.height, width: superview.frame.size.width, height: pull_upViewHight)
                 
                }
            }
        }
     
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}
