

import UIKit
import TFAnimatedImage
class TF_VoiceLive: UIImageView {
    @objc public let avatar = UIImageView()
    let avatarBorder = UIView()
    let YView = UIView()
    let voice = UIView()
    let loadingExpression = TFAnimatedImageView()
    let title = UILabel()
 
    @objc public var moreShow:Bool = false
    
    var customAvatarBorderY:CGFloat = 0
    var avatarBorderW:CGFloat = 110
    var avatarBorderH:CGFloat = 110
    
    var avatarW:CGFloat = 95
    var avatarH:CGFloat = 95
    
    var voiceW:CGFloat = 35
    var voiceH:CGFloat = 35
    
    var title_spacing:CGFloat = 30
    var titleH:CGFloat = 28
    
    
     override init(frame: CGRect) {
         super.init(frame: frame)
         self.image = UIImage.init(named: "livingVoiceLive")
     
         self.avatarBorder.backgroundColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1.0)
         self.addSubview(self.avatarBorder)
         
         self.avatar.contentMode = .scaleAspectFill
         self.avatar.layer.masksToBounds  =  true
         self.avatar.backgroundColor = UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1.0)
         self.avatarBorder.addSubview(self.avatar)
         
         self.voice.backgroundColor = UIColor(red: 0/255.0, green: 0/255.0, blue: 0/255.0, alpha: 0.73)
         self.addSubview(self.voice)
         
         self.loadingExpression.backgroundColor = UIColor.clear
         self.voice.addSubview(self.loadingExpression)
        let retinaPath = Bundle.main.path(forResource: "TF_VoiceLiveAnimation", ofType: "gif")
         if retinaPath != nil {
             if let data = NSData(contentsOfFile: retinaPath! as String) {
                 self.loadingExpression.animatedImage =  TFAnimatedImage.init(animatedGIFData: data as Data)
             }
         }


         self.title.textAlignment = .center
         self.title.numberOfLines = 0;
         self.addSubview(self.title)
         

         self.title.attributedText = NSMutableAttributedString.getAttributed(string: "语音直播中", font: UIFont.PingFang(size: 18), foregroundColor: UIColor(red: 255/255.0, green: 255/255.0, blue: 255/255.0, alpha: 1.0))
         
         
     }
    override func layoutSubviews() {
        super.layoutSubviews()
        
        var avatarBorderY:CGFloat = 139.0/667.0*self.frame.size.height
        if customAvatarBorderY>0 {
            avatarBorderY = customAvatarBorderY
        }

        self.avatarBorder.frame = CGRect(x: (self.frame.size.width - avatarBorderW)/2, y: avatarBorderY, width: avatarBorderW, height: avatarBorderH)
        self.avatarBorder.layer.cornerRadius = self.avatarBorder.bounds.size.width / 2
        
        self.avatar.frame = CGRect(x: (self.avatarBorder.frame.size.width-avatarW)/2, y: (self.avatarBorder.frame.size.height-avatarH)/2, width: avatarW, height: avatarH)
        self.avatar.layer.cornerRadius = self.avatar.bounds.size.width / 2
        
        self.voice.frame = CGRect(x: self.avatarBorder.frame.maxX-voiceW, y: self.avatarBorder.frame.maxY-voiceH, width: voiceW, height: voiceH)
        self.voice.layer.cornerRadius = self.voice.bounds.size.width / 2;
        self.loadingExpression.frame = self.voice.bounds;

        self.title.frame = CGRect(x: 0, y: self.avatarBorder.frame.maxY+title_spacing, width: self.frame.size.width, height: titleH)
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
 
}
