//
//  TF_LuckyBagReceive.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/15.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit
import BRPickerView
//领奖
class TF_LuckyBagReceive: TF_LuckyBagBaseView {
    //标题
    let top_title = UITextView()
    //发送评论，参与抽奖
    let submit = TF_luckyBag_details_button()
    //详情标题
    let details_title = TF_DashedBorderTextView()
    let optionsScrollView = UIScrollView()
    var optionsList:[TF_LuckyBagReceive_options] = []
    /**福袋ID*/
    var ID:NSInteger = 0
    var shwoTimer:Timer?
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.view_hegiht = 449
        view.addSubview(top_title)
        top_title.textContainer.lineFragmentPadding = 0;
        top_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        top_title.isUserInteractionEnabled = false
        top_title.backgroundColor = .clear
        top_title.attributedText = NSAttributedString.getAttributed(string: "领奖信息", font: UIFont.nameFang("PingFang SC-Bold", size: 18), foregroundColor: UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)).setAlignment(.center)
        
        view.addSubview(submit)
        submit.backgroundColor = UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)
        submit.layer.masksToBounds = true
        submit.layer.cornerRadius = 14
        submit.setAttributedTitle(NSAttributedString.getAttributed(string: "提交", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)
        
        view.addSubview(details_title)
        details_title.textContainer.lineFragmentPadding = 0;
        details_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        details_title.layer.masksToBounds = true
        details_title.layer.cornerRadius = 8
        details_title.isUserInteractionEnabled = false
        details_title.backgroundColor = .clear
        view.addSubview(optionsScrollView)

        shwoTimer = Timer.scheduledTimer(timeInterval: 1.5, target: self, selector: #selector(shwoTimerClick), userInfo: nil, repeats: true)
        RunLoop.main.add(shwoTimer! , forMode: RunLoop.Mode.default)
        close.addTarget(self, action: #selector(closeClick2), for: .touchUpInside)
        
        
//        //键盘显示前
//        NotificationCenter.default.addObserver(self, selector: #selector(self.keyboardWillShow(noti:)), name: UIResponder.keyboardWillShowNotification, object: nil)
//
//        //键盘隐藏前
//        NotificationCenter.default.addObserver(self, selector: #selector(self.KeyboardWillHide(noti:)), name: UIResponder.keyboardWillHideNotification, object: nil)
//        
        
        
    }
    @objc func closeClick2()
    {
//        NotificationCenter.default.removeObserver(self)
    }
    
    @objc func keyboardWillShow(noti:NSNotification) {
        if let view = UIResponder.tf_firstResponder() {
            
            if (view is TF_LuckyBagReceive_optionsTextView){
                

                
                let keyboardInfo:NSDictionary = noti.userInfo! as NSDictionary
                
                let keyboardFrameEnd:NSValue = keyboardInfo.value(forKey: UIResponder.keyboardFrameEndUserInfoKey) as! NSValue
                
                let frame:CGRect = keyboardFrameEnd.cgRectValue
               
                
                let animationDuration:NSNumber = keyboardInfo.value(forKey: UIResponder.keyboardAnimationDurationUserInfoKey) as! NSNumber
                //  执行动画
                let duration = animationDuration.floatValue
                
                let firstResponder = view as! TF_LuckyBagReceive_optionsTextView
                
//                let keyWindow = TalkfunSharedTools.keyWindow()
                // 先将坐标转换到窗口坐标系
            let windowFrame = firstResponder.convert(self.frame, to: nil)
            
            
                print("键盘frame: \(view.frame)")
                
                print("firstResponder 在屏幕的坐标: \(windowFrame)")
                
                
//                UIScreen.main.bounds
            }
            
        }
  
    }
    
    //隐藏键盘
    @objc func KeyboardWillHide(noti:NSNotification) {
//        if (self.currentTextView(self.textView) == true) {
        if let view = UIResponder.tf_firstResponder() {
            
            if (view is TF_LuckyBagReceive_optionsTextView){
                
                let firstResponder = view as! TF_LuckyBagReceive_optionsTextView
                
                let keyboardInfo:NSDictionary = noti.userInfo! as NSDictionary
                
                let animationDuration:NSNumber = keyboardInfo.value(forKey: UIResponder.keyboardAnimationDurationUserInfoKey) as! NSNumber
                //  执行动画
                let duration = animationDuration.floatValue
            }
            
        }
         
                
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        top_title.frame = CGRect(x: 0, y: 16, width: view_width, height: 25)
        
        submit.frame = CGRect(x: 16, y: view_hegiht-16-40, width: view_width-16-16, height: 40)
        
        details_title.frame = CGRect(x: 16, y: 49, width: view_width-16-16, height: 47)
        self.centerTextInTextView()

    }
    
   @objc func shwoTimerClick() {

       if optionsScrollView.contentSize.height>optionsScrollView.frame.height {
           self.optionsScrollView.flashScrollIndicators()
       }
     
    }
    private func centerTextInTextView() {
        let topInset = (details_title.bounds.size.height - details_title.contentSize.height) / 2.0
        details_title.contentInset = UIEdgeInsets(top: max(0, topInset), left: 0, bottom: 0, right: 0)
        details_title.scrollIndicatorInsets = details_title.contentInset
    }
    
    func setUI(pendingReceive:TFLuckyBag_details)
    {
        

        self.ID = pendingReceive.id
        //奖品名称
        details_title.attributedText = NSAttributedString.getAttributed(string: pendingReceive.prize, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.center)
        
        self.optionsList.removeAll()
        for i in 0..<optionsList.count {
           let options_view = optionsList[i]
            options_view.removeFromSuperview()
        }
        //要收集的信息列表
        let receiveInfoObj = pendingReceive.receiveInfoOri
        var options_view_y:CGFloat = 0
        for i in 0..<receiveInfoObj.count {
            
            let model = receiveInfoObj[i] as! TFLuckyBag_details_receive
            
            let options_view = TF_LuckyBagReceive_options()
            self.optionsList.append(options_view)
            optionsScrollView.addSubview(options_view)
            options_view.setUI(model: model)
 
            var options_view_h:CGFloat = 36+40
            //地址
            if model.type==4 {
                options_view_h = 36+40+8+40
            }
            
            options_view.frame = CGRect(x: 0.0, y: options_view_y, width: view_width-16-16, height: options_view_h)

            options_view_y = options_view.frame.maxY


        }
        //默认高度
        var optionsScrollViewHegiht:CGFloat = 280
        if options_view_y>=280 && options_view_y<=360 {
            optionsScrollViewHegiht = options_view_y
        }else if (options_view_y > 360)
        {
            optionsScrollViewHegiht = 360
        }
        self.view_hegiht = 100+optionsScrollViewHegiht+89
        self.layoutSubviews()
        optionsScrollView.frame = CGRect(x: 16, y: 100, width: view_width-16-16, height: optionsScrollViewHegiht)
        
        optionsScrollView.contentSize = CGSize(width: view_width-16-16, height: options_view_y)


    }
  
    
}

class TF_LuckyBagReceive_options_address_Button: UIButton {
    var spacing: CGFloat = 0.0 // 图片和文字的间距

    let img:UIImageView = UIImageView.init()
    let  lab:UILabel = UILabel.init()
    
     override init(frame: CGRect) {
         super.init(frame: frame)

         addSubview(self.img)

         addSubview(self.lab)
         img.image = UIImage(named: "向下箭头")
      
     }
     
     override func layoutSubviews() {
         super.layoutSubviews()
         self.img.frame = CGRect(x: self.frame.width-8-14, y: (self.frame.height-12)/2, width: 12, height: 12)
         
         let labX = 8.0
         let labW = self.img.frame.maxX-labX-12
         self.lab.frame = CGRect(x: labX, y: (self.frame.height-20)/2, width: labW, height: 20)
     
     }
  
     required init?(coder: NSCoder) {
         fatalError("init(coder:) has not been implemented")
     }
}

class TF_LuckyBagReceive_options_address: UIButton {
    var province_City_area:String = ""
    
    //省
    let province = TF_LuckyBagReceive_options_address_Button()
    //市
    let city = TF_LuckyBagReceive_options_address_Button()
    //区 TF_ImageRightButton
    let area = TF_LuckyBagReceive_options_address_Button()
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.addSubview(province)
        self.addSubview(city)
        self.addSubview(area)
        

        province.backgroundColor = .white
        city.backgroundColor = .white
        area.backgroundColor = .white
              
        province.layer.masksToBounds = true
        city.layer.masksToBounds = true
        area.layer.masksToBounds = true
        
        province.layer.cornerRadius = 8
        city.layer.cornerRadius = 8
        area.layer.cornerRadius = 8
        
        province.isUserInteractionEnabled = false
        area.isUserInteractionEnabled = false
        city.isUserInteractionEnabled = false
        
       
//        province.setImage(UIImage(named: "向下箭头"), for: .normal)
//        city.setImage(UIImage(named: "向下箭头"), for: .normal)
//        area.setImage(UIImage(named: "向下箭头"), for: .normal)
        
        province.lab.attributedText = NSAttributedString.getAttributed(string: "请选择省", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
        city.lab.attributedText = NSAttributedString.getAttributed(string: "请选择市", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
        area.lab.attributedText = NSAttributedString.getAttributed(string: "请选择区", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
        
    
        
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        let provinceW = (self.frame.width-11-11)/3
        province.frame = CGRect(x: 0, y: 0, width: provinceW, height: self.frame.height)
        city.frame = CGRect(x: province.frame.maxX+11, y:0 , width: provinceW, height: self.frame.height)
        
        area.frame = CGRect(x: city.frame.maxX+11, y: 0, width: provinceW, height: self.frame.height)
    }
}

class TF_LuckyBagReceive_options: UIView {
    //标题
    let title = UILabel()
    //地址
    let address = TF_LuckyBagReceive_options_address()

    //详细地址
    let content = TF_LuckyBagReceive_optionsTextView()

    var model = TFLuckyBag_details_receive()
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.addSubview(title)
        self.addSubview(address)
        address.isHidden = true
        address.backgroundColor = .clear
        address.addTarget(self, action: #selector(showPickerView), for: .touchUpInside)
        
        self.addSubview(content)

        content.font = UIFont.PingFang(size: 14)
        content.layer.masksToBounds = true
        content.layer.cornerRadius = 8
        
        
        let doneButton = UIBarButtonItem(title: "完成", style: .done, target: self, action: #selector(password_doneButtonTapped))
        
        let toolbar = UIToolbar()
        toolbar.sizeToFit()
        toolbar.items = [UIBarButtonItem(barButtonSystemItem: .flexibleSpace, target: nil, action: nil), doneButton]
        content.inputAccessoryView = toolbar
    }
    @objc func password_doneButtonTapped() {
        self.content.resignFirstResponder()
    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func setUI(model:TFLuckyBag_details_receive)
    {
        self.model = model
        //地址
        if model.type == 4 {
            address.isHidden = false
        }else
        {
            address.isHidden = true
        }
    
        let title_attributedText = NSMutableAttributedString.getAttributed(string: model.title, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
        
        //必选
        if(model.required)
        {
            title_attributedText.insert(NSMutableAttributedString.getAttributed(string: "*", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 255/255, green: 0, blue: 0, alpha: 1)), at: 0)
        }
        title.attributedText = title_attributedText
        
        if model.descriptionMsg.count>0 {
            content.tf_placeholder = model.descriptionMsg
        }
        
    }
    override func layoutSubviews() {
        super.layoutSubviews()
        title.frame = CGRect(x: 0, y: 12, width: self.frame.width, height: 20)
        address.frame = CGRect(x: 0, y: 36, width: self.frame.width, height: 40)
        content.frame = CGRect(x: 0, y: self.frame.height-40, width: self.frame.width, height: 40)
    }
    //TODO: 记录上一次选择的地址
    var addressSelectIndexs: [NSNumber] = []


   @objc func showPickerView()
    {
        self.endEditing(true)
        // 地区
        let textPickerView = BRTextPickerView(pickerMode: .componentCascade)
        textPickerView.title = "请选择地区"
        // 设置数据源
        textPickerView.fileName = "TFregion_tree_data.json"
        // 设置选择器显示的列数(即层级数)，默认是根据数据源层级动态计算显示。
        // 如：设置1则只显示前1列数据（即只显示省）；设置2则只显示前2列数据（即只显示省、市）；设置3则只显示前3列数据（即显示省、市、区）
        textPickerView.showColumnNum = 3
        textPickerView.selectIndexs = self.addressSelectIndexs

        textPickerView.multiResultBlock = { [weak self] (models, indexs) in
            guard let `self` = self else { return }
            if let indexs = indexs {
                self.addressSelectIndexs = indexs
            }
            
            
   
            
            if let models = models {

                for i in 0..<models.count {
                    let new_model:BRTextModel = models[i]

                    if let text = new_model.text {
                        if i==0 {
                            address.province.lab.attributedText = NSAttributedString.getAttributed(string: text, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
                        }else  if i==1 {
                            address.city.lab.attributedText = NSAttributedString.getAttributed(string: text, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
                            
                        }else  if i==2 {
                            
                            address.area.lab.attributedText = NSAttributedString.getAttributed(string: text, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
                        }
                   
                        self.address.province_City_area  = self.address.province_City_area+text
                    }
                  
                }
              
            }
            
            print("拼接的地址是========>",self.address.province_City_area)
         
            
           

        }

        textPickerView.show()

        
    }
}
class TF_DashedBorderTextView: UITextView {
    private let dashedBorderLayer = CAShapeLayer()

    // 初始化
    override init(frame: CGRect, textContainer: NSTextContainer?) {
        super.init(frame: frame, textContainer: textContainer)
        setupDashedBorder()
    }

    required init?(coder: NSCoder) {
        super.init(coder: coder)
        setupDashedBorder()
    }

    /// 设置虚线边框
    private func setupDashedBorder() {
        dashedBorderLayer.name = "dashedBorderLayer"
        dashedBorderLayer.strokeColor = UIColor(red: 194/255, green: 32/255, blue: 67/255, alpha: 1).cgColor // 默认颜色
        dashedBorderLayer.fillColor = nil // 不填充
        dashedBorderLayer.lineWidth = 1.0 // 默认线宽
        dashedBorderLayer.lineDashPattern = [4, 2] // 默认虚线样式
        self.layer.addSublayer(dashedBorderLayer)

        // 默认圆角
        self.layer.cornerRadius = 8
        self.clipsToBounds = true
    }

    /// 更新虚线边框的路径
    private func updateDashedBorderPath() {
        let path = UIBezierPath(roundedRect: self.bounds, cornerRadius: self.layer.cornerRadius)
        dashedBorderLayer.path = path.cgPath
        dashedBorderLayer.frame = CGRect(x: 0, y: 0, width: self.bounds.width, height: self.bounds.height)
    }

    /// 布局变化时更新边框
    override func layoutSubviews() {
        super.layoutSubviews()
        updateDashedBorderPath()
    }

    /// 提供接口自定义颜色
    func setDashedBorderColor(_ color: UIColor) {
        dashedBorderLayer.strokeColor = color.cgColor
    }

    /// 提供接口自定义线宽
    func setDashedBorderLineWidth(_ width: CGFloat) {
        dashedBorderLayer.lineWidth = width
    }

    /// 提供接口自定义虚线样式
    func setDashedBorderLineDashPattern(_ pattern: [NSNumber]) {
        dashedBorderLayer.lineDashPattern = pattern
    }
}
class TF_LuckyBagReceive_optionsTextView: TF_TextView, UITextViewDelegate {
    
    override init(frame: CGRect, textContainer: NSTextContainer?) {
          super.init(frame: frame, textContainer: textContainer)
          self.delegate = self
      }
      
      required init?(coder: NSCoder) {
          super.init(coder: coder)
          self.delegate = self
      }

    // 限制只输入纯文字，过滤掉表情符号
       func textView(_ textView: UITextView, shouldChangeTextIn range: NSRange, replacementText text: String) -> Bool {
           // 使用正则表达式检查输入是否包含表情符号
           let emojiPattern = "[\\x{1F600}-\\x{1F64F}\\x{1F300}-\\x{1F5FF}\\x{1F680}-\\x{1F6FF}\\x{1F700}-\\x{1F77F}\\x{1F780}-\\x{1F7FF}\\x{1F800}-\\x{1F8FF}\\x{1F900}-\\x{1F9FF}\\x{1FA00}-\\x{1FA6F}\\x{1FA70}-\\x{1FAFF}\\x{2600}-\\x{26FF}\\x{2700}-\\x{27BF}\\x{2300}-\\x{23FF}]"
           
           do {
               let regex = try NSRegularExpression(pattern: emojiPattern, options: [])
               // 如果输入的文字匹配表情符号，则返回 false，禁止输入
               if regex.firstMatch(in: text, options: [], range: NSRange(location: 0, length: text.count)) != nil {
                   return false
               }
           } catch {
//               print("正则表达式错误: \(error.localizedDescription)")
           }
           
           return true
       }
}
    
