//
//  TF_LuckyBagView_WinnersList.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/13.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_LuckyBagViewWinnersList: TF_LuckyBagBaseView , UITableViewDelegate,UITableViewDataSource {

    //标题
    let top_title = UITextView()
    //福袋详情
    let details_title = UITextView()
    

    let tableView = UITableView()
    var list:[TFListLuckyBagWinner_data] = []
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.frame = UIScreen.main.bounds
    
        self.view_width = 342.0
        self.view_hegiht = 288.0
                
        view.addSubview(top_title)
        top_title.textContainer.lineFragmentPadding = 0;
        top_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        top_title.isUserInteractionEnabled = false
        top_title.backgroundColor = .clear
        
        details_title.layer.masksToBounds = true
        details_title.layer.cornerRadius = 14
        details_title.backgroundColor = .white
        details_title.textContainer.lineFragmentPadding = 0;
        details_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        details_title.isUserInteractionEnabled = false
        view.addSubview(details_title)
        
        view.addSubview(tableView)
        tableView.backgroundColor = .clear
        tableView.delegate = self
        tableView.dataSource = self
        tableView.register(TF_LuckyBagView_WinnersList_cell.self, forCellReuseIdentifier: "TF_LuckyBagView_WinnersList_cell")
        tableView.separatorStyle = .none
        
        
    }

    func setMode(_ model:TFListLuckyBagWinner)
    {
        
        top_title.attributedText = NSAttributedString.getAttributed(string: model.luckyBag.winnerNum.ToString() + "位幸运观众", font: UIFont.nameFang("PingFang SC-Bold", size: 18), foregroundColor: UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)).setAlignment(.center)
        
        details_title.attributedText = NSAttributedString.getAttributed(string: model.luckyBag.prize, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.center)
        
        
        self.list.removeAll()
        self.list = model.data.compactMap { $0 as? TFListLuckyBagWinner_data }
        tableView.reloadData()
        
    }
    private func centerTextInTextView() {
        let topInset = (details_title.bounds.size.height - details_title.contentSize.height) / 2.0
        details_title.contentInset = UIEdgeInsets(top: max(0, topInset), left: 0, bottom: 0, right: 0)
        details_title.scrollIndicatorInsets = details_title.contentInset
    }
    

    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        top_title.frame = CGRect(x: 0, y: 16, width: view_width, height: 25)
        details_title.frame = CGRect(x: 16, y: 66, width: view_width-16-16, height: 48)
        
        centerTextInTextView()
        let tableView_y = details_title.frame.maxY+8
        let tableView_height = view.frame.height-tableView_y
        tableView.frame = CGRect(x: 0, y: tableView_y, width: view_width, height: tableView_height)
        
    }
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return list.count
    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 24+12;
    }
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCell(withIdentifier: "TF_LuckyBagView_WinnersList_cell", for: indexPath) as! TF_LuckyBagView_WinnersList_cell
        cell.selectionStyle = .none
        cell.backgroundColor = .clear
        let order_attrString = NSMutableAttributedString.getAttributed(string: (indexPath.row+1).ToString(), font: UIFont.nameFang("PingFang SC-Regular", size: 14), foregroundColor: UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1))
        cell.order.attributedText = order_attrString
        let order_height = order_attrString.getHeight()
        cell.order.frame = CGRect(x: 12, y: (24-order_height)/2, width: order_attrString.getWidth(), height: order_height)
        cell.avatar.frame = CGRect(x: cell.order.frame.maxX+8, y: 0, width: 24, height: 24)
        cell.avatar.layer.masksToBounds = true
        cell.avatar.layer.cornerRadius = 12
        let model = list[indexPath.row]
        let url:URL? = URL.init(string: model.avatar)
        cell.avatar.sd_setImage(with: url, completed: nil)

        let name_attributedText = NSAttributedString.getAttributed(string: model.nickname, font:UIFont.PingFang(size: 14) , foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1))
        cell.name.attributedText = name_attributedText
        cell.name.frame = CGRect(x: cell.avatar.frame.maxX+8, y: cell.avatar.frame.minY+2, width: name_attributedText.getWidth(), height: name_attributedText.getHeight())
        return cell
    }

}
class TF_LuckyBagView_WinnersList_cell: UITableViewCell {
    //顺序
    let order = UILabel()
    
    let avatar = UIImageView()
    let name = UILabel()
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)
        
    self.addSubview(order)
    self.addSubview(avatar)
    self.addSubview(name)
        
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
     
       
    }
    
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }

}
