//
//  TF_LuckyBagWinning.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/15.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit

class TF_LuckyBagWinning: TF_LuckyBagBaseView {
    //标题
    let top_title = UITextView()
    //福袋详情
    let details_title = UITextView()
    
    //福袋图标
    let icon = UIImageView()
    //立即领取
    let receive = TF_luckyBag_details_button()
    //提示
    let tips =  UITextView()
    //TODO: 查看中奖列表的入口
    let viewThePrize = TF_ImageRightButton()
    override init(frame: CGRect) {
        super.init(frame: frame)
  
        view.addSubview(top_title)
        top_title.textContainer.lineFragmentPadding = 0;
        top_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        top_title.backgroundColor = .clear
        top_title.isUserInteractionEnabled = false
        
        //不一样的地方
        details_title.backgroundColor = .clear
        details_title.textContainer.lineFragmentPadding = 0;
        details_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        details_title.isUserInteractionEnabled = false
        view.addSubview(details_title)
        
        view.addSubview(icon)
        
        view.addSubview(receive)
        receive.backgroundColor = UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)
        receive.layer.masksToBounds = true
        receive.layer.cornerRadius = 14
        
        view.addSubview(tips)
        tips.textContainer.lineFragmentPadding = 0;
        tips.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        tips.backgroundColor = .clear
        tips.isUserInteractionEnabled = false

        view.addSubview(viewThePrize)
        viewThePrize.setAttributedTitle(NSAttributedString.getAttributed(string: "查看幸运观众", font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 132/255, green: 138/255, blue: 156/255, alpha: 1)), for: .normal)
        viewThePrize.setImage(UIImage(named: "右箭头"), for: .normal)
        viewThePrize.isHidden = true
    }
 
    func setLuckyBagWinning(isWinner:Bool,prize:String="",prizeImage:String="",tips_str:String="")
    {
        var top_title_str:String = "没抽中福袋"
        var receive_str:String = "知道了"
        var details_title_str:String = "送您一个好运气~"
        
        var placeholderImage_str:String = "福袋运气"
        if isWinner {
            top_title_str = "恭喜抽中福袋"
            receive_str = "立即领取"
            placeholderImage_str = "福袋-大"
            details_title_str = prize
        }
        
        top_title.attributedText = NSAttributedString.getAttributed(string: top_title_str, font: UIFont.nameFang("PingFang SC-Bold", size: 18), foregroundColor: UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)).setAlignment(.center)
        //领取
        receive.setAttributedTitle(NSAttributedString.getAttributed(string: receive_str, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)
        
        //奖品名称
        details_title.attributedText = NSAttributedString.getAttributed(string: details_title_str, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.center)

            
        icon.sd_setImage(with: URL(string: prizeImage as String), placeholderImage: UIImage.init(named: placeholderImage_str))
         //有问题请客服
        tips.attributedText = NSAttributedString.getAttributed(string: tips_str , font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 132/255, green: 138/255, blue: 156/255, alpha: 1)).setAlignment(.center)
 
        viewThePrize.isHidden = isWinner
        

    }
    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        
        top_title.frame = CGRect(x: 0, y: 16, width: view_width, height: 25)
        details_title.frame = CGRect(x: 16, y: 57, width: view_width-16-16, height: 48)
        centerTextInTextView()
        
        icon.frame = CGRect(x: (self.view_width-72)/2, y: 109, width: 72, height: 72)
        
        receive.frame = CGRect(x: 16, y: icon.frame.maxY+13, width: self.view_width-16-16, height: 40)
        tips.frame = CGRect(x: 0, y: receive.frame.maxY+16, width: self.view_width, height: 18)
        
        let viewThePrize_width:CGFloat = 72+4+12
        viewThePrize.frame = CGRect(x: (view_width-viewThePrize_width)/2, y: receive.frame.maxY+16, width: viewThePrize_width, height: 18)
    }
    private func centerTextInTextView() {
        let topInset = (details_title.bounds.size.height - details_title.contentSize.height) / 2.0
        details_title.contentInset = UIEdgeInsets(top: max(0, topInset), left: 0, bottom: 0, right: 0)
        details_title.scrollIndicatorInsets = details_title.contentInset
    }

}
class TF_ImageRightButton: UIButton {
    var spacing: CGFloat = 0.0 // 图片和文字的间距

    var isExchange:Bool = true
    override func layoutSubviews() {
        super.layoutSubviews()

        if isExchange {
            guard let imageView = self.imageView, let titleLabel = self.titleLabel else { return }

            let imageWidth = imageView.frame.width
            let titleWidth = titleLabel.intrinsicContentSize.width

            // 调整图片和文字的位置
            self.titleEdgeInsets = UIEdgeInsets(top: 0, left: -imageWidth - spacing, bottom: 0, right: imageWidth)
            self.imageEdgeInsets = UIEdgeInsets(top: 0, left: titleWidth + spacing, bottom: 0, right: -titleWidth)
        }else{
            // 恢复默认布局
            self.titleEdgeInsets = .zero
            self.imageEdgeInsets = .zero
        }

    }
}
