//
//  TF_luckyBag_details.swift
//  TalkfunSDKDemo
//
//  Created by moRui on 2024/11/12.
//  Copyright © 2024 Talkfun. All rights reserved.
//

import UIKit


class TF_luckyBag_details: TF_LuckyBagBaseView {

    //福袋
    let top_title_ImageView = UIImageView()
    //福袋标题底框
    let title_bottom_frame = UIImageView()

    //倒计时
    let countdownLabel = UILabel()
    
    //福袋详情
    let details = UIView()
    //福袋图标
    let icon = UIImageView()
    //详情标题
    let details_title = UITextView()
    //共10份 1234人参与
    let participantNum_title = UITextView()
    
    //--------任务view-------------------------
    let task = UIView()
    //参与任务
    let task_title = UILabel()
    //观看直播 (默认隐藏,读取后端数据,决定显示隐藏)
    let tisa_watch = UILabel()
    //未达成
    let not_reached = UILabel()
    
    //发送评论
    let task_msg = UILabel()
    
    //发送评论，参与抽奖
    let send = TF_luckyBag_details_button()
    let bottom_title = UIButton()

   var new_model = TFLuckyBag_details()
    var new_isReached:Bool = true
    override init(frame: CGRect) {
        super.init(frame: frame)
        
        self.frame = UIScreen.main.bounds
        
        self.view_width = 342.0

    
        top_title_ImageView.image = UIImage(named: "超级福袋")
        view.addSubview(top_title_ImageView)
        
        details.layer.masksToBounds = true
        details.layer.cornerRadius = 14
        details.backgroundColor = .white
        view.addSubview(details)
        
        title_bottom_frame.contentMode = .scaleToFill
        title_bottom_frame.image = UIImage(named: "福袋标题底框")
        view.addSubview(title_bottom_frame)

        title_bottom_frame.addSubview(countdownLabel)
        details.addSubview(icon)
        icon.contentMode = .scaleToFill

        details.addSubview(details_title)
        details_title.isUserInteractionEnabled = false
        details_title.textContainer.lineFragmentPadding = 0;
        details_title.textContainerInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        //-----------------------------
        details.addSubview(participantNum_title)
        participantNum_title.isUserInteractionEnabled = false
        participantNum_title.textContainer.lineFragmentPadding = 0;
        participantNum_title.textContainerInset = UIEdgeInsets(top: 0, left: 4, bottom: 0, right: 0)
        participantNum_title.layer.borderWidth = 1
        participantNum_title.layer.borderColor = UIColor(red: 152/255, green: 156/255, blue: 170/255, alpha: 1).cgColor
        participantNum_title.layer.masksToBounds = true
        participantNum_title.layer.cornerRadius = 4
        //---------------------------
        view.addSubview(task)
        task.layer.masksToBounds = true
        task.layer.cornerRadius = 8
        task.backgroundColor = .white
        
        task.addSubview(task_title)
        task_title.attributedText = NSAttributedString.getAttributed(string: "参与任务", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)).setAlignment(.left)
        task.addSubview(tisa_watch)
        task.addSubview(not_reached)
        
        task.addSubview(task_msg)
        //---------------------------
        
        view.addSubview(send)
        send.backgroundColor = UIColor(red: 250/255, green: 43/255, blue: 88/255, alpha: 1)
        send.layer.masksToBounds = true
        send.layer.cornerRadius = 14
        send.setAttributedTitle(NSAttributedString.getAttributed(string: "发送评论，参与抽奖", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 255/255, green: 255/255, blue: 255/255, alpha: 1)), for: .normal)


        
        view.addSubview(bottom_title)
        bottom_title.setAttributedTitle(NSAttributedString.getAttributed(string: "请勿离开直播间，否则抽奖资格失效", font: UIFont.PingFang(size: 12), foregroundColor: UIColor(red: 132/255, green: 138/255, blue: 156/255, alpha: 1)), for: .normal)
        
        self.addSubview(close)
        close.setImage(UIImage(named: "daka_close"), for: .normal)
        close.backgroundColor = UIColor(red: 0, green: 0, blue: 0, alpha: 0.2)
        close.addTarget(self, action: #selector(closeClick2), for: .touchUpInside)
        
        NotificationCenter.default.addObserver(self, selector: #selector(self.countdownSeconds(noti:)), name: Notification.Name("TF_luckyBag_details_countdown"), object: nil)
                
    }
  
    @objc func countdownSeconds(noti:NSNotification) {
        
        if let countdownSeconds = noti.object as? String {
            
            countdownLabel.attributedText = NSAttributedString
                      .getAttributed(
                          string: formatCountdown(NSInteger(countdownSeconds)!)+" 后开奖",
                          font: UIFont.PingFang(size: 12),
                          foregroundColor: .white
                      )
                      .setAlignment(.center)
            
        }
        
    }
    @objc func closeClick2()
    {
        NotificationCenter.default.removeObserver(self)
        self.removeFromSuperview()
    }

    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    func isReachedUI(_ isReached:Bool)
    {
        if new_isReached != isReached || not_reached.attributedText == nil  {
            new_isReached = isReached
            var msg:String = "未达成"
            var foregroundColor:UIColor = UIColor(red: 132/255, green: 138/255, blue: 156/255, alpha: 1)
            if isReached {
                msg = "已达成"
                foregroundColor = UIColor(red: 252/255, green: 143/255, blue: 159/255, alpha: 1)
            }
            not_reached.attributedText = NSAttributedString.getAttributed(string: msg, font: UIFont.PingFang(size: 14), foregroundColor:foregroundColor ).setAlignment(.right)
        }

    }
    func setModel(_ model:TFLuckyBag_details,participated:Bool)
    {
        new_model = model
        //--------------------------------------------
        top_title_ImageView.frame = CGRect(x: (view_width-148)/2, y: 16, width: 148, height: 32)
        
        details.frame = CGRect(x: 16, y: 66, width: view_width-16-16, height: 112)
        
        title_bottom_frame.frame = CGRect(x: (view_width-158)/2, y: 60, width: 158, height: 28)
        
        countdownLabel.frame = CGRect(x: 0, y: 0, width: title_bottom_frame.frame.width, height: title_bottom_frame.frame.height)
        
        icon.frame = CGRect(x: 20, y: 36, width: 56, height: 56)
        details_title.frame = CGRect(x: 92, y: 28, width: details.frame.width-92-12, height: 40)
        
        send.participateText = model.participateText
        send.ID = model.id
       
        let participantNum_title_attributedText = NSAttributedString.getAttributed(string: "共"+model.prizeNum.ToString()+"份"+model.participantNum.ToString()+"人参与", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 152/255, green: 156/255, blue: 170/255, alpha: 1)).setAlignment(.left)
        participantNum_title.attributedText = participantNum_title_attributedText
        participantNum_title.frame = CGRect(x: 92, y: details_title.frame.maxY+8, width: participantNum_title_attributedText.getWidth()+8, height: 20)
        //---------------------------------
    
        task_title.frame = CGRect(x: 12, y: 8, width:view_width-12-12-16-16, height: 20)
        tisa_watch.frame = CGRect(x: 12, y: task_title.frame.maxY+4, width: view_width-12-12-16-16, height: 20)
        not_reached.frame = CGRect(x: 12, y: task_title.frame.maxY+4, width: view_width-12-12-16-16, height: 20)
        
        var task_msg_y = task_title.frame.maxY+4
        if model.participantConditionObj.watchDuration.enable {
            task_msg_y = tisa_watch.frame.maxY+4
           
            tisa_watch.attributedText = NSAttributedString.getAttributed(string: "观看直播：" + (model.participantConditionObj.watchDuration.config.duration/60).ToString() + "分钟", font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.left)
          

            //已参加
            if participated {
                self.isReachedUI(true)
            }else{
                self.isReachedUI(false)
            }
        }
        
        task_msg.frame = CGRect(x: 12, y: task_msg_y, width: view_width-12-12-16-16, height: 20)
        
        task.frame = CGRect(x: 16, y: details.frame.maxY+8, width: view_width-16-16, height: task_msg.frame.maxY+8)
        
        //--------------
       // 发送评论，参与抽奖
        send.frame = CGRect(x: 16, y: task.frame.maxY+16, width: view_width-16-16, height: 40)
        //请勿离开直播间，否则抽奖资格失效
        bottom_title.frame = CGRect(x: 16, y: send.frame.maxY+16, width: view_width-16-16, height: 40)
        
        self.view_hegiht = bottom_title.frame.maxY+20
        self.layoutSubviews()
        //------------------

        //奖品名称
        details_title.attributedText = NSAttributedString.getAttributed(string: model.prize, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.left)

        task_msg.attributedText = NSAttributedString.getAttributed(string: "发送评论："+model.participateText, font: UIFont.PingFang(size: 14), foregroundColor: UIColor(red: 54/255, green: 54/255, blue: 59/255, alpha: 1)).setAlignment(.left)
        
        icon.sd_setImage(with: URL(string: model.prizeImage as String), placeholderImage: UIImage.init(named: "福袋-大"))
        //已参加
        if participated {
            send.alpha = 0.5
            send.isUserInteractionEnabled = false
        }
        
        

    }

    
    private func formatCountdown(_ seconds: NSInteger) -> String {
        let minutes = seconds / 60
        let remainingSeconds = seconds % 60
        return String(format: "%02d:%02d", minutes, remainingSeconds)
    }
}
class TF_luckyBag_details_button: UIButton {
    /**示例:"我已参与福袋，期待中大奖"*/
    var participateText:String = ""
    /**福袋ID*/
    var ID:NSInteger = 0
}
