//  Created by 邓盛明 on 2022/2/11.
//  Copyright © 2022 Talkfun. All rights reserved.

#import "TalkfunAllCourseViewController.h"
#import "TalkfunCourseListCell.h"
#import "MJExtension.h"
#import "TalkfunCourseManager.h"
#import "TalkfunPasswordAlertView.h"

@interface TalkfunAllCourseViewController ()<UITableViewDelegate,UITableViewDataSource>

@property(nonatomic,strong)NSMutableArray * allCourseData; // 所有课程
@property (nonatomic,assign) NSInteger pageNum;
@property(nonatomic,strong)NSNumber * last_id; // 下一页需要的参数
@property(nonatomic,assign)BOOL isReload;

@property(nonatomic,strong)UIButton * zhidingBtn;
@end

@implementation TalkfunAllCourseViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.pageNum = 1;
    self.last_id = @(0);
    self.allCourseTableview = [[UITableView alloc]initWithFrame:self.view.bounds style:UITableViewStylePlain];
    self.allCourseTableview.delegate = self;
    self.allCourseTableview.dataSource = self;
    self.allCourseTableview.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.allCourseTableview.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.allCourseTableview];

    WeakSelf //下拉刷新
    MJRefreshGifHeader * header = [MJRefreshGifHeader headerWithRefreshingBlock:^{
        
        
            if (weakSelf.isReload == NO) {
                  weakSelf.pageNum = 1;
                  [weakSelf footerName:NO];

                [weakSelf getAllCourseData:weakSelf.listKey listSign:weakSelf.listSign];
                [weakSelf.allCourseTableview.mj_header endRefreshing];
             }
          
        }];
        weakSelf.allCourseTableview.mj_header = header;
         [header setImages:nil forState:MJRefreshStateIdle];
         header.lastUpdatedTimeLabel.hidden = YES;
         header.stateLabel.textColor = UIColorFromRGBHex(0xaaaaaa);
         header.stateLabel.font = [UIFont systemFontOfSize:13];
    
    //上拉刷新
    MJRefreshAutoGifFooter * footer = [MJRefreshAutoGifFooter footerWithRefreshingBlock:^{
        
        
           if (weakSelf.isReload == NO) {
                 weakSelf.pageNum +=1;
               
               [weakSelf getAllCourseData:weakSelf.listKey listSign:weakSelf.listSign];
                [weakSelf.allCourseTableview.mj_footer endRefreshing];
                 
             }
            
      
    }];
     footer.automaticallyRefresh = NO;
     self.allCourseTableview.mj_footer = footer;
     [self footerName:NO];
     footer.stateLabel.textColor = UIColorFromRGBHex(0xaaaaaa);
     footer.stateLabel.font = [UIFont systemFontOfSize:13];
    
    [self.view addSubview:self.noLiveImgview];
    [self.view addSubview:self.noliveLab];
    [self.view addSubview:self.joinLive];
    
    [self.view addSubview:self.zhidingBtn];
    
}

- (void)footerName:(BOOL)footerName
{
     MJRefreshAutoGifFooter * footer = (MJRefreshAutoGifFooter *)self.allCourseTableview.mj_footer;
    if (footerName) {
        [footer setTitle:@"向下来可以加载数据" forState:MJRefreshStateIdle];
        [footer setTitle:@"松开加载更多数据" forState:MJRefreshStateWillRefresh];
        [footer setTitle:@"正在加载更多数据" forState:MJRefreshStateRefreshing];
        [footer setTitle:@"所有数据加载完毕，没有更多数据了" forState:MJRefreshStateNoMoreData];
    }
    else
    {
        [footer setTitle:@"" forState:MJRefreshStateIdle];
        [footer setTitle:@"" forState:MJRefreshStateWillRefresh];
        [footer setTitle:@"" forState:MJRefreshStateRefreshing];
    }
}

#pragma --mark  获取所有课程
-(void)getAllCourseData:(NSString *)listKey listSign:(NSString *)listsign

{
    if (listKey==nil&&listsign==nil) {
        return;
    }
    
    NSMutableDictionary * params = [NSMutableDictionary dictionary];
    params[@"action"] = @"listCourse";
    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;

    params[@"listSign"] = listsign;

    params[@"listKey"] = listKey;
    params[@"page"] = @(self.pageNum);
    if (self.pageNum == 1) {
        params[@"last_id"] = @"0";
    } else {
        params[@"last_id"] = self.last_id;
    }

    self.isReload = YES;
   WeakSelf
    [TalkfunLoginRequest requestForNewLogin:params callback:^(id result) {
//        NSLog(@"获取所有课程==%@",result);
      
        if ([result isKindOfClass:[NSDictionary class]]) {
      
                  weakSelf.isReload = NO;
                if ([result[@"code"] intValue] == 0) {
                  
                if (weakSelf.pageNum == 1) {
                     [weakSelf.allCourseData removeAllObjects];
                 }
                if (result[@"data"]) {
                    NSDictionary * dataDict = result[@"data"];
                    if (dataDict[@"list"] && [dataDict[@"list"] isKindOfClass:[NSArray class]]) {
                        NSArray * list = dataDict[@"list"];
                          if (list.count > 0) {
                            NSDictionary * d = list[list.count-1];
                            weakSelf.last_id = d[@"last_id"]?d[@"last_id"]:@(0);
                             }
                        
                        [weakSelf.allCourseData addObjectsFromArray:[TalkfunAllCourseModel mj_objectArrayWithKeyValuesArray:list]];
                                  
                        [weakSelf.allCourseTableview reloadData];
                         if (weakSelf.allCourseData.count > 0) {
                            [weakSelf footerName:YES];
                             weakSelf.noliveLab.hidden = YES;
                             weakSelf.noLiveImgview.hidden = YES;
                             weakSelf.joinLive.hidden = YES;
                         } else {
                            [weakSelf footerName:NO];
                             weakSelf.noliveLab.hidden = NO;
                             weakSelf.noLiveImgview.hidden = NO;
                             weakSelf.joinLive.hidden = NO;
                        }
                        
                      }
                  }

                [weakSelf.allCourseTableview.mj_header endRefreshing];

                }
                else {
                    weakSelf.noliveLab.hidden = NO;
                    weakSelf.noLiveImgview.hidden = NO;
                    weakSelf.joinLive.hidden = NO;

                    [TalkfunLoginRootViewController TF_progressHUDShow:result[@"msg"]];
                    
                }
         
        }
        
    }];
    
}
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
    
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 100;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.allCourseData.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  
        TalkfunCourseListCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cell1"];
        
        if (!cell) {
        cell = [[TalkfunCourseListCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell1"];
         
        }
        
        TalkfunAllCourseModel * model = self.allCourseData[indexPath.row];
       
        cell.width = [self getMainScreenBounds].size.width;
        cell.height = cell.frame.size.height;
        cell.selectionStyle = UITableViewCellSelectionStyleNone;
        cell.model = model;
        return  cell;
    
}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return UITableViewCellEditingStyleDelete | UITableViewCellEditingStyleInsert;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
        TalkfunAllCourseModel * model = self.allCourseData[indexPath.row];
        NSArray * array = [self.manager selectCourseList];
        if (array.count > 0) {

            NSDictionary * dict = [self isEqualTomodel:model];
           
            if ([dict isKindOfClass:[NSDictionary class]]) {
                NSDictionary * dictmodel = dict[@"params"];
                if ([dictmodel isKindOfClass:[NSDictionary class]]) {
                    [TalkfunLoginRootViewController nav:self.navigationController viewController:self params:dictmodel callback:^(id result) {
                        if ([result isKindOfClass:[NSDictionary class]]) {
                            if ([result[@"code"] intValue] == 0) {
                                
                            } else {
                                
                                [self getinLive:model];
                                
                            }
                        }
                    }];
                } else {
                    
                    [self getinLive:model];
                }
            }
        } else {
            [self getinLive:model];
        }

    
}

//是否可以编辑  默认YES
-(BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
        return NO;
}
- (NSMutableDictionary*)isEqualTomodel:(TalkfunAllCourseModel *)model
{
    NSMutableDictionary*dict = [NSMutableDictionary dictionary];
    
    NSMutableDictionary * params = [NSMutableDictionary dictionary];
    params[@"pid"] = model.pid;
    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;
    params[@"type"] = model.type;
    //设置默认渠道0

    NSArray * array = [self.manager selectCourseList];
//    NSLog(@"mdoelss:%@",model.IDs);
        for (TalkfunMyCourseModel * mymodel in array) {

           if ([model.course_id intValue] == 0) {
              
               if ([mymodel.IDs isEqualToString:model.IDs]) {
                   if ([mymodel.type isEqualToString:model.type]) {
                      params[@"password"] = mymodel.password;
                      params[@"id"] = mymodel.IDs;
                      params[@"nickname"] = mymodel.nickname;
                      [dict setObject:params forKey:@"params"];
                      return dict;
                   }
                  
               }
           } else {

               if ([mymodel.account isEqualToString:model.course_id]) {
                   params[@"password"] = mymodel.password;
                   params[@"id"] = mymodel.account;
                   params[@"nickname"] = mymodel.nickname;
                   [dict setObject:params forKey:@"params"];
                   return dict;
               }
           }
       }

           
    return dict;
}
-(NSMutableArray *)allCourseData
{
    if (!_allCourseData) {
        _allCourseData = [NSMutableArray array];
    }
    return _allCourseData;
}

-(UIButton *)zhidingBtn
{
    if (!_zhidingBtn) {
        _zhidingBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        _zhidingBtn.frame = CGRectMake([self getMainScreenBounds].size.width-70, [self getMainScreenBounds].size.height-200, 45, 45);
        [_zhidingBtn setBackgroundColor:[UIColor whiteColor]];
        [_zhidingBtn setImage:[UIImage imageNamed:@"zhiding"] forState:UIControlStateNormal];
        _zhidingBtn.layer.cornerRadius = 22.5;
        _zhidingBtn.layer.shadowColor = [UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:0.16].CGColor;
        _zhidingBtn.layer.shadowOffset = CGSizeMake(0,2);
        _zhidingBtn.layer.shadowRadius = 6;
        _zhidingBtn.layer.shadowOpacity = 1;
        [_zhidingBtn addTarget:self action:@selector(createZhidingtoTop) forControlEvents:UIControlEventTouchUpInside];
        _zhidingBtn.hidden = YES;
       
    }
    return _zhidingBtn;
}

#pragma mark  置顶
-(void)createZhidingtoTop
{
    if (self.allCourseData.count == 0) {
        return;
    }
    NSIndexPath * path = [NSIndexPath indexPathForRow:0 inSection:0];
    [self.allCourseTableview scrollToRowAtIndexPath:path atScrollPosition:UITableViewScrollPositionBottom animated:YES];
}
@end
