//
//  TalkfunMyCourseViewController.m
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2022/2/11.
//  Copyright © 2022 Talkfun. All rights reserved.
//

#import "TalkfunMyCourseViewController.h"
#import "TalkfunSecondNewLoginViewController.h"
#import "TalkfunCourseManager.h"
#import "TalkfunCourseListCell.h"
#import "TalkfunPasswordAlertView.h"
#include "AFNetworking.h"

@interface TalkfunMyCourseViewController ()<UITableViewDelegate,UITableViewDataSource>

@property (nonatomic,assign) NSInteger secondPageNum;
@property(nonatomic,strong)NSMutableArray * myCourseData; //我的课程
@property (nonatomic,strong) TalkfunDownloadManager * downloadManager;
@property (nonatomic,strong) UIView * footerView;
//下载列表
//记住选中的cell的indexPath
@property (nonatomic,strong) NSMutableArray * selectedArray;
@end

@implementation TalkfunMyCourseViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.secondPageNum = 1;
    self.myCourseTableview = [[UITableView alloc]initWithFrame:self.view.bounds style:UITableViewStylePlain];
    self.myCourseTableview.delegate = self;
    self.myCourseTableview.dataSource = self;
    self.myCourseTableview.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.myCourseTableview.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.myCourseTableview];
    self.myCourseTableview.allowsSelectionDuringEditing = YES;
    WeakSelf //下拉刷新
    MJRefreshGifHeader * secondheader = [MJRefreshGifHeader headerWithRefreshingBlock:^{

        weakSelf.secondPageNum = 1;
        [weakSelf footerName:NO];
        NSLog(@"chenckStr:%@",weakSelf.checkStr);
        [weakSelf checkmyCourse:weakSelf.checkStr];
        
       }];
       weakSelf.myCourseTableview.mj_header = secondheader;
       [secondheader setImages:nil forState:MJRefreshStateIdle];
       secondheader.lastUpdatedTimeLabel.hidden = YES;
       secondheader.stateLabel.textColor = UIColorFromRGBHex(0xaaaaaa);
       secondheader.stateLabel.font = [UIFont systemFontOfSize:13];
    
    [self.view addSubview:self.noLiveImgview];
    [self.view addSubview:self.noliveLab];
    [self.view addSubview:self.joinLive];
    
}

-(void)reloadMyCourseData
{
    NSArray * arr = [self.manager selectCourseList];
      if (arr.count > 0) {
          NSString * str = [self appendCheckStr:arr];
          [self checkmyCourse:str];
      }
}
#pragma mark  检查我的课程
-(void)checkmyCourse:(NSString *)idTypes
{

    [self.myCourseData removeAllObjects];
    NSMutableDictionary * params = [NSMutableDictionary dictionary];
    params[@"action"] = @"checkCourse";
    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;
    params[@"ids"] = idTypes;
   
    WeakSelf
    [TalkfunLoginRequest requestForNewLogin:params callback:^(id result) {
//        NSLog(@"检测课程：%@",result);
     
      if ([result isKindOfClass:[NSDictionary class]]) {
            
        if ([result[@"code"] intValue] == 0) {
            if ([result[@"data"] isKindOfClass:[NSDictionary class]]) {
                if ([result[@"data"][@"list"] isKindOfClass:[NSArray class]]) {
                    NSArray * list = result[@"data"][@"list"];
                    if (list.count > 0) {
                        NSArray * arr = [weakSelf.manager selectCourseList];
                        for (int i=0; i<list.count; i++) {
                            NSDictionary * dict = list[i];
                            if (arr.count > 0) {
                                
                           TalkfunMyCourseModel * model = arr[i];
                                NSLog(@"model.listKey==%@,listKey==%@",model.listKey,weakSelf.listKey);
                            if ([model.listKey isEqualToString:weakSelf.listKey]) {
                               model.IDs = dict[@"id"];
                               model.type = dict[@"type"];
                               model.status = dict[@"status"];
                               model.start_time = dict[@"start_time"];
                               model.title = dict[@"title"];
                              
                               [weakSelf.manager updateCourseModel:model];
                               [weakSelf.myCourseData addObject:model];
                            }
                        }
                     }
                        [weakSelf.myCourseTableview reloadData];
                        NSLog(@"数量:%ld",weakSelf.myCourseData.count);
                        if (weakSelf.myCourseData.count > 0) {
                            [weakSelf footerName:YES];
                            weakSelf.noliveLab.hidden = YES;
                            weakSelf.noLiveImgview.hidden = YES;
                            weakSelf.joinLive.hidden = YES;
                         } else {
                            [weakSelf footerName:NO];
                             weakSelf.noliveLab.hidden = NO;
                             weakSelf.noLiveImgview.hidden = NO;
                             weakSelf.joinLive.hidden = NO;
                           
                         }
                    }
                   
                    [weakSelf.myCourseTableview.mj_header endRefreshing];


                }
            }
        } else {

            
            [self showWithMsg:result[@"msg"]];
        
        }
      }
     
    }];
}
- (void)showWithMsg:(NSString*)msg
{
    [TalkfunLoginRootViewController TF_progressHUDShow:msg];
}

- (void)footerName:(BOOL)footerName
{
     MJRefreshAutoGifFooter * footer = (MJRefreshAutoGifFooter *)self.myCourseTableview.mj_footer;
    if (footerName) {
        [footer setTitle:@"向下来可以加载数据" forState:MJRefreshStateIdle];
        [footer setTitle:@"松开加载更多数据" forState:MJRefreshStateWillRefresh];
        [footer setTitle:@"正在加载更多数据" forState:MJRefreshStateRefreshing];
        [footer setTitle:@"所有数据加载完毕，没有更多数据了" forState:MJRefreshStateNoMoreData];
    }
    else
    {
        [footer setTitle:@"" forState:MJRefreshStateIdle];
        [footer setTitle:@"" forState:MJRefreshStateWillRefresh];
        [footer setTitle:@"" forState:MJRefreshStateRefreshing];
    }
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
    
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 100;
}
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return self.myCourseData.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    TalkfunCourseListCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cell2"];
    
    if (!cell) {
    cell = [[TalkfunCourseListCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell2"];
     
    }
    if (indexPath.row>=self.myCourseData.count) {
        
        
        return cell ;
    }
    TalkfunMyCourseModel * mymodel = self.myCourseData[indexPath.row];
  
    cell.width = [self getMainScreenBounds].size.width;
    
    cell.height = cell.frame.size.height;
    cell.mymodel = mymodel;
    UILongPressGestureRecognizer * longPressGesture = [[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(cellLongPress:)];
    longPressGesture.minimumPressDuration = 1;
    [cell addGestureRecognizer:longPressGesture];
    cell.downBtn.tag = indexPath.row+450;
    [cell.downBtn addTarget:self action:@selector(dowmloadCourseClick:) forControlEvents:UIControlEventTouchUpInside];

    BOOL isfinish = [self.downloadManager isFinishDownload:mymodel.IDs];
    if (isfinish) {
        [cell.downBtn setImage:[UIImage imageNamed:@"下载完成"] forState:UIControlStateNormal];
    } else {
        [cell.downBtn setImage:[UIImage imageNamed:@"下载"] forState:UIControlStateNormal];
    }
    
    return  cell;
}
//我的课程
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (self.myCourseTableview.isEditing) {
        [self.selectedArray addObject:indexPath];
                               
        UIButton * deleteBtn = (UIButton *)[self.footerView viewWithTag:21];
        [deleteBtn setTitle:[NSString stringWithFormat:@"删除(%d)",(int)self.selectedArray.count] forState:UIControlStateNormal];
        [deleteBtn setTitleColor:[UIColor colorWithRed:255/255.0 green:59/255.0 blue:59/255.0 alpha:1.0] forState:UIControlStateNormal];
    } else{
         
        
        [tableView deselectRowAtIndexPath:indexPath animated:YES];
        
        if (indexPath.row < self.myCourseData.count) {
            TalkfunMyCourseModel * model = self.myCourseData[indexPath.row];
                       
               if ([model.status intValue] == 3) {
                   
                    TalkfunPasswordAlertView * alert = [[TalkfunPasswordAlertView alloc]initWithTitle:@"该直播已结束，回放还未生成请稍后再来" message:@"" sureBtn:@"确定" cancleBtn:@""];
                   [alert showPasswordAlertView];
                   __weak TalkfunPasswordAlertView * weakAlert = alert;
                   alert.resultIndex = ^(NSString *string, NSString *nickStr) {
                
                     [weakAlert removeFromSuperview];
                   };
               } else {
                   
              
               
           TalkfunAllCourseModel * allmodel = [[TalkfunAllCourseModel alloc]init];
           
           NSMutableDictionary * params = [NSMutableDictionary dictionary];
           params[@"id"] = model.IDs;
           params[@"type"] = model.type;
           NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
          //uid用户的唯一标识
           params[@"uid"] = newUid;
           params[@"pid"] = model.pid;
           params[@"password"] = model.password;
           params[@"nickname"] = model.nickname;
           //设置默认渠道0

           NSLog(@"password:%@",params);
           WeakSelf
            [TalkfunLoginRootViewController nav:self.navigationController viewController:self params:params callback:^(id result) {
//                   NSLog(@"result:%@",result);
              if ([result[@"code"] intValue] == 0) {
                 
               } else {
                  allmodel.course_id = model.IDs;
                  allmodel.nickname = model.nickname;
                  allmodel.type = model.type;
                  allmodel.pid = model.pid;
                  [weakSelf getinLive:allmodel];
               }
             }];
                   
            }
        }
        
       
    }
}
- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (self.myCourseTableview.editing) {
       return UITableViewCellEditingStyleDelete | UITableViewCellEditingStyleInsert;
      }else{
        return UITableViewCellEditingStyleDelete;
      }
}

- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
        [self.selectedArray removeObject:indexPath];
        UIButton * deleteBtn = (UIButton *)[self.footerView viewWithTag:21];
        [deleteBtn setTitle:[NSString stringWithFormat:@"删除(%d)",(int)self.selectedArray.count] forState:UIControlStateNormal];
 
 
}
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
  
        if (editingStyle == UITableViewCellEditingStyleDelete) {
            
            TalkfunMyCourseModel * model = self.myCourseData[indexPath.row];
            [self.manager deleteCourseModel:model];
          
            if(self.myCourseData.count>indexPath.row){
                [self.myCourseData removeObjectAtIndex:indexPath.row];
                }
            NSArray * arr = [self.manager selectCourseList];
            if (self.myCourseData.count == 0) {
                self.noliveLab.hidden = NO;
                self.noLiveImgview.hidden = NO;
                self.joinLive.hidden = NO;
            }
            NSString * str = [self appendCheckStr:arr];
            self.checkStr = str;
            [self.myCourseTableview reloadData];

        }
    
   
}

//是否可以编辑  默认YES
-(BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
 return YES;
}
-(void)removefromBgdBtn:(UIButton *)btn
{
    [btn removeFromSuperview];
}
#pragma mark -- 长按编辑
-(void)cellLongPress:(UILongPressGestureRecognizer *)longRecognizer
{
    if (longRecognizer.state == UIGestureRecognizerStateBegan) {
        [self becomeFirstResponder];

        self.myCourseTableview.allowsMultipleSelectionDuringEditing = YES;
        [self.myCourseTableview setEditing:!self.myCourseTableview.editing animated:YES];
          if (self.myCourseTableview.isEditing) {
              if (self.myCourseTableview.contentSize.height > self.view.frame.size.height - CGRectGetHeight(self.footerView.frame)) {
                 self.myCourseTableview.contentSize = CGSizeMake(CGRectGetWidth(self.myCourseTableview.frame), self.myCourseTableview.contentSize.height + CGRectGetHeight(self.footerView.frame));
                  }
                [self.view addSubview:self.footerView];
              } else {
                [self.footerView removeFromSuperview];
              }
    }
}

-(void)dowmloadCourseClick:(UIButton *)btn
{
    if (self.myCourseData.count == 0) {
        return;
    }
        NSInteger tag = btn.tag-450;
    
        TalkfunMyCourseModel * model = self.myCourseData[tag];
     
          BOOL contains = [self.downloadManager containsPlaybackID:model.IDs];
            if (contains) {
    
     
                [self showWithMsg:@"该回放已下载"];
                return;
            }
            
              NSInteger   status =   [AFNetworkReachabilityManager sharedManager].networkReachabilityStatus;
            if ( status ==AFNetworkReachabilityStatusNotReachable) {
                
                dispatch_async(dispatch_get_main_queue(), ^{
                    
             
                    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"网络已断开" preferredStyle:UIAlertControllerStyleAlert];
                    
                    UIAlertAction *otherAction = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                    }];
                    
                    [alertController addAction:otherAction];
                    if (IsIPAD) {
                        alertController.popoverPresentationController.sourceView = self.view;
                        alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
                    }
                    [self presentViewController:alertController animated:YES completion:nil];
                });
               
            }else if ( status ==AFNetworkReachabilityStatusReachableViaWWAN) {
                
                [self networkAlertShow:tag];
            }else{
                
                [self.downloadManager appendDownloadWithAccessToken:model.access_token playbackID:model.IDs title:nil];
                [self.downloadManager startDownload:model.IDs];

                [self showWithMsg:@"已添加到下载列表"];
             
            }
  
}

- (void)networkAlertShow:(NSInteger )tag
{
    TalkfunMyCourseModel * model = self.myCourseData[tag];
    NSString * access_token = model.access_token;
    NSString * downLoadID = model.IDs;
    WeakSelf

    
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"确定使用蜂窝流量下载?" preferredStyle:UIAlertControllerStyleAlert];
    
    UIAlertAction *otherAction = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        [weakSelf.downloadManager appendDownloadWithAccessToken:access_token playbackID:downLoadID title:nil];
        [weakSelf.downloadManager startDownload:downLoadID];
        
        [self showWithMsg:@"已添加到下载列表"];
 
          
    }];
    
    
    [alertController addAction:otherAction];
    if (IsIPAD) {
        alertController.popoverPresentationController.sourceView = self.view;
        alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
    }
    [self presentViewController:alertController animated:YES completion:nil];
    
}

- (CGRect)getMainScreenBounds
{
    
    CGFloat superViewW = [UIScreen mainScreen].bounds.size.width;
    CGFloat superViewH = [UIScreen mainScreen].bounds.size.height;
        
    //1 ==螢幕直立

    if (superViewH < superViewW) {

            superViewH =  [UIScreen mainScreen].bounds.size.width;
            superViewW =  [UIScreen mainScreen].bounds.size.height;
    }
    
    return CGRectMake(0, 0, superViewW, superViewH);
}

-(NSMutableArray *)myCourseData
{
    if (!_myCourseData) {
        _myCourseData = [NSMutableArray array];
    }
    return _myCourseData;
}
- (UIView *)footerView
{
    if (!_footerView) {
        _footerView = [[UIView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(self.view.frame) - 50 - self.bottomSafe, CGRectGetWidth(self.view.frame), 50)];
        _footerView.backgroundColor = [UIColor colorWithRed:255 / 255.0 green:255 / 255.0 blue:255 / 255.0 alpha:1];
        UILabel * lineLab = [[UILabel alloc]initWithFrame:CGRectMake(0, 0, [self getMainScreenBounds].size.width, 1)];
        lineLab.backgroundColor = [UIColor colorWithRed:220/255.0 green:228/255.0 blue:235/255.0 alpha:1.0];
        
        UIButton * selectAllBtn = ({
            UIButton * btn = [UIButton buttonWithType:UIButtonTypeCustom];
            btn.frame = CGRectMake(0, 10, ([self getMainScreenBounds].size.width-64)/2.0, CGRectGetHeight(_footerView.frame) - 20);
            [btn setTitle:@"全选" forState:UIControlStateNormal];
            btn.titleLabel.font = [UIFont systemFontOfSize:18];
            btn.titleLabel.textAlignment = NSTextAlignmentCenter;
            [btn setTitleColor:[UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0] forState:UIControlStateNormal];
            [btn addTarget:self action:@selector(bianjiClick:) forControlEvents:UIControlEventTouchUpInside];
            btn.selected = NO;
            btn.tag = 20;
            btn;
        });
        
        
        UIButton * editBtn = ({
            UIButton * btn = [UIButton buttonWithType:UIButtonTypeCustom];
            btn.frame = CGRectMake(([self getMainScreenBounds].size.width-64)/2.0, 10, ([self getMainScreenBounds].size.width-64)/2.0, CGRectGetHeight(_footerView.frame) - 20);
            [btn setTitle:@"删除" forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor colorWithRed:176/255.0 green:190/255.0 blue:203/255.0 alpha:1.0] forState:UIControlStateNormal];
            btn.titleLabel.font = [UIFont systemFontOfSize:18];
            btn.titleLabel.textAlignment = NSTextAlignmentCenter;
            [btn addTarget:self action:@selector(bianjiClick:) forControlEvents:UIControlEventTouchUpInside];
            btn.tag = 21;
            
            btn;
        });
        
        UILabel * wlineLab = ({
            UILabel * lab = [[UILabel alloc]initWithFrame:CGRectMake([self getMainScreenBounds].size.width-64, 14.5, 1, 21)];
            lab.backgroundColor = [UIColor colorWithRed:203/255.0 green:213/255.0 blue:222/255.0 alpha:1.0];
            lab;
        });
        
        UIButton * deleteBtn = ({
           UIButton * btn = [UIButton buttonWithType:UIButtonTypeCustom];
            btn.frame = CGRectMake([self getMainScreenBounds].size.width-43, 13.5, 23, 23);
            [btn setImage:[UIImage imageNamed:@"deleteAll"] forState:UIControlStateNormal];
            [btn addTarget:self action:@selector(bianjiClick:) forControlEvents:UIControlEventTouchUpInside];
            btn.tag = 25;
            btn;
        });
        
        [_footerView addSubview:lineLab];
        [_footerView addSubview:selectAllBtn];
        [_footerView addSubview:editBtn];
        [_footerView addSubview:wlineLab];
        [_footerView addSubview:deleteBtn];
    }
    return _footerView;
}


#pragma mark  进行删除全选
-(void)bianjiClick:(UIButton *)btn
{

        if (btn.tag == 10) {
        self.myCourseTableview.allowsMultipleSelectionDuringEditing = YES;
        [self.myCourseTableview setEditing:!self.myCourseTableview.editing animated:YES];
       if (self.myCourseTableview.isEditing) {
           if (self.myCourseTableview.contentSize.height > self.view.frame.size.height - CGRectGetHeight(self.footerView.frame)) {
              self.myCourseTableview.contentSize = CGSizeMake(CGRectGetWidth(self.myCourseTableview.frame), self.myCourseTableview.contentSize.height + CGRectGetHeight(self.footerView.frame));
               }
             [self.view addSubview:self.footerView];
           } else {
             [self.footerView removeFromSuperview];
           }
        } else if (btn.tag == 20){
            [self.selectedArray removeAllObjects];
            btn.selected = !btn.selected;
            if (btn.selected) {
                [btn setTitle:@"取消全选" forState:UIControlStateNormal];
               
                for (int i = 0; i < self.myCourseData.count; i ++) {
                   NSIndexPath * indexPath = [NSIndexPath indexPathForRow:i inSection:0];
                    [self.myCourseTableview selectRowAtIndexPath:indexPath animated:NO scrollPosition:UITableViewScrollPositionTop];
                    [self.selectedArray addObject:indexPath];
                    
                    
                    }
                
                   UIButton * deleteBtn = (UIButton *)[self.footerView viewWithTag:21];
                   [deleteBtn setTitle:[NSString stringWithFormat:@"删除(%d)",(int)self.selectedArray.count] forState:UIControlStateNormal];
                  [deleteBtn setTitleColor:[UIColor colorWithRed:255/255.0 green:59/255.0 blue:59/255.0 alpha:1.0] forState:UIControlStateNormal];

               }else{
                   for (int i = 0; i < self.myCourseData.count; i ++) {
                    NSIndexPath * indexPath = [NSIndexPath indexPathForRow:i inSection:0];
                   [self.myCourseTableview deselectRowAtIndexPath:indexPath animated:YES];
                        }
                    [self resetBtn];
             }
        } else if (btn.tag == 21) {
           
          if(self.myCourseData.count==0){
                return;
             }
            TalkfunPasswordAlertView  * alertView = [[TalkfunPasswordAlertView alloc]initWithTitle:@"确定删除该直播吗" message:@"" sureBtn:@"确定" cancleBtn:@"取消"];
            [alertView showPasswordAlertView];
            WeakSelf
            __weak TalkfunPasswordAlertView * weakAlert = alertView;
            alertView.resultIndex = ^(NSString *string, NSString *nickStr) {
                
               NSMutableArray *modelArray = [NSMutableArray array];
                for (NSIndexPath * indexPath  in weakSelf.selectedArray) {
                    TalkfunMyCourseModel * model = weakSelf.myCourseData[indexPath.row];
                           [modelArray addObject:model];
                       }
                    for (TalkfunMyCourseModel * model in modelArray) {
                           [weakSelf.myCourseData removeObject:model];
                           [weakSelf.manager deleteCourseModel:model];
                         
                      }
               
                       [weakSelf.myCourseTableview reloadData];
                       [weakAlert removeFromSuperview];
                       [weakSelf.footerView removeFromSuperview];
                       [weakSelf resetBtn];
                       [weakSelf.myCourseTableview setEditing:!weakSelf.myCourseTableview.editing animated:YES];
                      NSArray * arr1 = [weakSelf.manager selectCourseList];
                      NSString * checkstr = [weakSelf appendCheckStr:arr1];
                      weakSelf.checkStr = checkstr;
                        if (weakSelf.myCourseData == 0) {
                            weakSelf.noliveLab.hidden = NO;
                            weakSelf.noLiveImgview.hidden = NO;
                            weakSelf.joinLive.hidden = NO;
                        } else {
                            weakSelf.noliveLab.hidden = YES;
                            weakSelf.noLiveImgview.hidden = YES;
                            weakSelf.joinLive.hidden = YES;
                        }
                 };
        } else if (btn.tag == 25) {
            [self.footerView removeFromSuperview];
            [self resetBtn];
            [self.myCourseTableview setEditing:!self.myCourseTableview.editing animated:YES];
        }
        
        
}

-(NSString *)appendCheckStr:(NSArray *)selectArr
{

    NSArray * courselistArr = [self adddmodel:selectArr];
    
        NSString * str1;
        NSString * typeStr=@"";
        for (int i=0; i<courselistArr.count; i++) {
            
            TalkfunMyCourseModel * model = courselistArr[i];
            NSString * idstr;
            if ([model.account intValue] == 0) {
                idstr = model.IDs;
            } else {
                idstr = model.account;
            }
            NSString * typestr = model.type;
            
            if (i==courselistArr.count-1) {
                    str1 = [NSString stringWithFormat:@"%@-%@",idstr,typestr];
              } else {
                  str1 = [NSString stringWithFormat:@"%@-%@,",idstr,typestr];
              }
            typeStr = [typeStr stringByAppendingString:str1];

        }
    
       self.checkStr = typeStr;
    
    return typeStr;

}

-(NSArray *)adddmodel:(NSArray *)selectArr
{
    
    NSMutableArray * arr = [NSMutableArray array];
    
    for (int i=0; i<selectArr.count; i++) {
        TalkfunMyCourseModel * model = selectArr[i];
        if ([model.type intValue] != 5) {
            [arr addObject:model];
        }
    }
    return arr;
}


- (void)resetBtn
{
    [self.selectedArray removeAllObjects];
    UIButton * selectAllBtn = (UIButton *)[self.footerView viewWithTag:20];
    [selectAllBtn setTitle:@"全选" forState:UIControlStateNormal];
    UIButton * deleteBtn = (UIButton *)[self.footerView viewWithTag:21];
    [deleteBtn setTitle:@"删除" forState:UIControlStateNormal];
}


- (TalkfunDownloadManager *)downloadManager
{
    if (!_downloadManager) {
        _downloadManager = [TalkfunDownloadManager shareManager];

    }
    return _downloadManager;
}

- (NSMutableArray *)selectedArray
{
    if (!_selectedArray) {
        _selectedArray = [NSMutableArray new];
    }
    return _selectedArray;
}


@end
