
//  Created by Sunzn on 2017/4/19.
//  Copyright © 2017年 Talkfun. All rights reserved.
//

#import "TalkfunScanViewController.h"
#import <AVFoundation/AVFoundation.h>
#import "TalkfunShadowView.h"
#import "TalkfunLoginRootViewController.h"
#import "TalkfunScanNewLoginViewController.h"

#define kWidth [TalkfunUtils getMainScreen].size.width
#define kHeight [TalkfunUtils getMainScreen].size.height
#define customShowSize CGSizeMake(IsIPAD?400:200, IsIPAD?400:200);
#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0
@interface TalkfunScanViewController ()<AVCaptureMetadataOutputObjectsDelegate,UIImagePickerControllerDelegate,UINavigationControllerDelegate>

@property (strong,nonatomic)AVCaptureDevice * device;
@property (strong,nonatomic)AVCaptureDeviceInput * input;
@property (strong,nonatomic)AVCaptureMetadataOutput * output;
@property (strong,nonatomic)AVCaptureSession * session;
@property (strong,nonatomic)AVCaptureVideoPreviewLayer * preview;
/** 预览图层尺寸 */
@property (nonatomic, assign) CGSize layerViewSize;
/** 有效扫码范围 */
@property (nonatomic, assign) CGSize showSize;
/** 作者自定义的View视图 */
@property (nonatomic, strong) TalkfunShadowView *shadowView;


@end

@implementation TalkfunScanViewController

- (void)viewDidLoad {
    [super viewDidLoad];

    self.automaticallyAdjustsScrollViewInsets = NO;
    self.view.backgroundColor = [UIColor grayColor];
   
    
    NSString *mediaType = AVMediaTypeVideo;//读取媒体类型
    AVAuthorizationStatus authStatus = [AVCaptureDevice authorizationStatusForMediaType:mediaType];//读取设备授权状态
    if(authStatus == AVAuthorizationStatusRestricted || authStatus == AVAuthorizationStatusDenied){
        dispatch_async(dispatch_get_main_queue(), ^{
     
            [self gettileVIew];
            UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"温馨提示" message:@"请启用相机-设置/隐私/相机" preferredStyle:UIAlertControllerStyleAlert];
            
            UIAlertAction *otherAction = [UIAlertAction actionWithTitle:@"确认" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                  
            }];
            
            
            [alertController addAction:otherAction];
            if (IsIPAD) {
                alertController.popoverPresentationController.sourceView = self.view;
                alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
            }
            [self presentViewController:alertController animated:YES completion:nil];
        });
        return;
        
    }
    
    //显示范围
    self.showSize = customShowSize;

    
    // Device
    _device = [AVCaptureDevice defaultDeviceWithMediaType:AVMediaTypeVideo];
    
    // Input
    _input = [AVCaptureDeviceInput deviceInputWithDevice:self.device error:nil];
    
    // Output
    _output = [[AVCaptureMetadataOutput alloc]init];
    [_output setMetadataObjectsDelegate:self queue:dispatch_get_main_queue()];
    
    // Session
    _session = [[AVCaptureSession alloc]init];
    [_session setSessionPreset:AVCaptureSessionPresetHigh];
    
    if ([_session canAddInput:self.input])
    {
        [_session addInput:self.input];
    }
    
    if ([_session canAddOutput:self.output])
    {
        [_session addOutput:self.output];
    }
    if ([_output.availableMetadataObjectTypes containsObject:AVMetadataObjectTypeQRCode]) {

    _output.metadataObjectTypes =@[AVMetadataObjectTypeQRCode];
        
        _preview =[AVCaptureVideoPreviewLayer layerWithSession:_session];
          _preview.videoGravity =AVLayerVideoGravityResizeAspectFill;

          [self.view.layer insertSublayer:_preview atIndex:0];
  
  
    
    //添加背景图片
    NSString * path = [[NSBundle mainBundle]pathForResource:@"55" ofType:@"png"];
    UIImage * scanImage = [UIImage imageWithContentsOfFile:path];
   
    self.view.layer.contents = (id)scanImage.CGImage;
    
    [_session startRunning];
    
  
      }
    //设置可用扫码范围
      [self allowScanRect];
     CGFloat width = 0;
     CGFloat height = 0;
    if (kWidth <kHeight) {
        width = kWidth;
        height = kHeight ;
    }else{
        width = kHeight;
        height =  kWidth;
    }
    
    //添加上层阴影视图
    self.shadowView = [[TalkfunShadowView alloc] initWithFrame:CGRectMake(0, 0, width, height)];
    
    [self.view addSubview:self.shadowView];
    [self.shadowView initTimer];
    self.shadowView.showSize = self.showSize;
    
    UILabel * scanTitle = [[UILabel alloc]initWithFrame:CGRectMake((kWidth-75)/2.0, 9.5, 75, 25)];
    scanTitle.text = @"扫码进入";
    scanTitle.font = [UIFont fontWithName:@"PingFang SC" size:18];
    scanTitle.textColor = [UIColor whiteColor];
    
    [[self gettileVIew] addSubview:scanTitle];
    
    
    
    UILabel * scanMsgLab = [[UILabel alloc]init];

   scanMsgLab.text = @"将二维码放入框内即可自动扫描";
   scanMsgLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
   scanMsgLab.textColor = [UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:1.0];
   scanMsgLab.frame = CGRectMake((kWidth-196)/2.0, (self.shadowView.frame.size.height - self.showSize.height) / 3 + self.showSize.height+30+15, 196, 20);
   [self.view addSubview:scanMsgLab];
            
   
   
            
    UIButton * photoBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    [photoBtn setTitle:@"相册识别" forState:UIControlStateNormal];
    [photoBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
     photoBtn.frame = CGRectMake((kWidth-102)/2.0, CGRectGetMaxY(scanMsgLab.frame)+76, 102, 44);
     photoBtn.titleLabel.font = [UIFont fontWithName:@"PingFang SC" size:17];
     photoBtn.layer.borderWidth = 0.5;
     photoBtn.layer.cornerRadius = 4.0;
     photoBtn.alpha = 1.0;
     photoBtn.layer.borderColor = [UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:1.0].CGColor;
     [photoBtn addTarget:self action:@selector(takeQRCodeFromPic:) forControlEvents:UIControlEventTouchUpInside];
     [self.view addSubview:photoBtn];
            

    
}


-(UIView *)gettileVIew
{
    CGFloat SafetyZone = 0;
       if (KIsiPhoneX) {
         SafetyZone = 24;
          }
       
        UIView * titleV = [[UIView alloc]initWithFrame:CGRectMake(0, 20+SafetyZone, kWidth, 44)];
        
         [self.view addSubview:titleV];
         
         UIButton * backBtn = [UIButton buttonWithType:UIButtonTypeCustom];
         [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
         [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
         backBtn.frame = CGRectMake(0, 0, 44, 44);
         [backBtn addTarget:self action:@selector(backClicl) forControlEvents:UIControlEventTouchUpInside];
         [titleV addSubview:backBtn];
    
    return titleV;
}

- (void)viewDidLayoutSubviews{
    [super viewDidLayoutSubviews];
    _preview.frame =self.view.layer.bounds;
}



- (void)viewDidAppear:(BOOL)animated{
    [super viewDidAppear:animated];
    if (!_session.isRunning) {
        [_session startRunning];
    }
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
      self.navigationController.navigationBar.barStyle = UIBarStyleBlack;
      [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;

}

- (NSString *)encodeString:(NSString*)unencodedString{
    
    NSString*encodedString=(NSString*)
    
    CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                              
                                                              (CFStringRef)unencodedString,
                                                              
                                                              NULL,
                                                              
                                                              (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                              
                                                              kCFStringEncodingUTF8));
    
    return encodedString;
    
}
- (void)captureOutput:(AVCaptureOutput *)captureOutput didOutputMetadataObjects:(NSArray *)metadataObjects fromConnection:(AVCaptureConnection *)connection
{
    NSString *stringValue;
    if ([metadataObjects count] >0){
        //停止扫描
        [_session stopRunning];
        
        AVMetadataMachineReadableCodeObject * metadataObject = [metadataObjects objectAtIndex:0];
        stringValue = metadataObject.stringValue;
        
        TalkfunScanNewLoginViewController * newLoginVC = [[TalkfunScanNewLoginViewController alloc]init];
        newLoginVC.nickName = self.nickName;
    

        NSDictionary * requestDict = @{@"qrCodeUrl":[self encodeString:stringValue]};
       
        WeakSelf
        [TalkfunLoginRequest requestForScanIn:requestDict callback:^(id result) {

            if ([result isKindOfClass:[NSDictionary class]] &&[result[@"code"] intValue] == 0) {

                NSDictionary * data = result[@"data"];
                
                if (data[@"ctag"]) {
                    newLoginVC.ctag = data[@"ctag"];
//                    NSLog(@"data=====>%@",data);
                }
                
                //输入密码进入  回放
                if ([data[@"type"] isEqualToString:@"playbackLogin"]) {
                    newLoginVC.isPlayback = YES;
                    newLoginVC.liveid =   [data[@"liveid"] stringValue] ;

                }
                //只要昵称  直播
                else if ([data[@"type"] isEqualToString:@"tempLogin"]) {

                    // 4为直播，5为回放
                    if ([[data[@"mode"]  stringValue]  isEqualToString:@"4"]) {
                        newLoginVC.isPlayback = NO;
                    }else if ([[data[@"mode"]  stringValue]  isEqualToString:@"5"]){
                        //回放
                        newLoginVC.isPlayback = YES;
                    }
                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];

                    [parameters setObject:data[@"logo"] forKey:@"logo"];
                    [UserDefault setObject:@{
                                             @"logo":data[@"logo"]} forKey:@"LogoUrl"];

                    newLoginVC.liveid = [data[@"roomid"] stringValue];
                    newLoginVC.role = data[@"role"] ;
                    newLoginVC.temporary = data[@"temporary"] ;
                    newLoginVC.et = data[@"et"] ;
                    newLoginVC.sign = data[@"sign"];
                    newLoginVC.logo = data[@"logo"];
                    newLoginVC.title1 = data[@"title"] ;

                }
                //输入帐号密码 直播
                else if ([data[@"type"] isEqualToString:@"liveLogin"]){
                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
                    [parameters setObject:data[@"logo"] forKey:@"logo"];
                    newLoginVC.liveid = [data[@"roomid"] stringValue];
                    newLoginVC.title1 = data[@"title"] ;
                    [UserDefault setObject:@{@"logo":parameters[@"logo"]} forKey:@"LogoUrl"];
                    
//                    NSLog(@"data=====>%@",data);
                }


                //直接进入  直播
                else if ([data[@"type"] isEqualToString:@"live"])  {

                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];

                    NSMutableDictionary *temp = [NSMutableDictionary dictionary];
                    [temp setObject:data[@"access_token"] forKey:@"access_token"];
                    [temp setObject:data[@"title"] forKey:@"title"];
                    [temp setObject:data[@"logo"] forKey:@"logo"];
                    [parameters setObject:temp forKey:@"data"];
                    [parameters setObject:@"0" forKey:@"code"];


                  
                   

                    [self pushLargeLive:data];


                    return;
                }
                //直接进入  回放
                else if ([data[@"type"] isEqualToString:@"playback"]) {

                    NSDictionary *parameters = @{
                                                 @"offlineKey":  [NSString stringWithFormat:@"%@",data[@"liveid"]],
                                                 @"data" : @{
                                                         @"title" : data[@"title"],
                                                         @"logo"  : data[@"logo"],
                                                         @"access_token" : data[@"access_token"],
                                                         },
                                                 @"code" : @"0",
                                                 };



                    [UserDefault setObject:@{
                                             @"logo":parameters[@"data"][@"logo"]} forKey:@"LogoUrl"];


                    dispatch_async(dispatch_get_main_queue(), ^{

                        [TalkfunLoginRootViewController pushLargeBackView:[NSString stringWithFormat:@"%@",data[@"liveid"]] access_token:data[@"access_token"]?data[@"access_token"]:@"" logo:data[@"logo"]?data[@"logo"]:@"" title:data[@"title"]?data[@"title"]:@"" nav:weakSelf.navigationController];

                    });

                    return;


               //课程登陆
                } else if ([data[@"type"] isEqualToString:@"courseLogin"]) {
                    if ([[data[@"mode"]  stringValue]  isEqualToString:@"4"]) {
                        newLoginVC.isPlayback = NO;

                    }else if ([[data[@"mode"]  stringValue]  isEqualToString:@"5"]){
                        //回放
                        newLoginVC.isPlayback = YES;

                    }
                     newLoginVC.liveid = [data[@"courseId"] stringValue];


                    newLoginVC.role = data[@"role"] ;

                    newLoginVC.logo = data[@"logo"];
                    newLoginVC.title1 = data[@"title"] ;
                    
//                    NSLog(@"data=====>%@",data);

                }

            }
            else{

                if ([result isKindOfClass:[NSDictionary class]]){
                    if (result[@"msg"]){


                        dispatch_async(dispatch_get_main_queue(), ^{

                            
                            [weakSelf showWithMsg:result[@"msg"]];
                           
                        });

                    }


                    [_session startRunning];

                }
                return;


            }

            dispatch_async(dispatch_get_main_queue(), ^{
                [weakSelf.navigationController pushViewController:newLoginVC animated:NO];
            });

        }];
        
        
        
    }
}

/** 配置扫码范围 */
-(void)allowScanRect{
    
    
    /** 扫描是默认是横屏, 原点在[右上角]
     *  rectOfInterest = CGRectMake(0, 0, 1, 1);
     *  AVCaptureSessionPresetHigh = 1920×1080   摄像头分辨率
     *  需要转换坐标 将屏幕与 分辨率统一
     */
    
    //剪切出需要的大小位置
    CGRect shearRect = CGRectMake((self.layerViewSize.width - self.showSize.width) / 2,
                                  (self.layerViewSize.height - self.showSize.height) / 3,
                                  self.showSize.height,
                                  self.showSize.height);
    
    
    
    CGFloat deviceProportion = 1920.0 / 1080.0;
    CGFloat screenProportion = self.layerViewSize.height / self.layerViewSize.width;
    
    //分辨率比> 屏幕比 ( 相当于屏幕的高不够)
    if (deviceProportion > screenProportion) {
        //换算出 分辨率比 对应的 屏幕高
        CGFloat finalHeight = self.layerViewSize.width * deviceProportion;
        // 得到 偏差值
        CGFloat addNum = (finalHeight - self.layerViewSize.height) / 2;
        
        // (对应的实际位置 + 偏差值)  /  换算后的屏幕高
        self.output.rectOfInterest = CGRectMake((shearRect.origin.y + addNum) / finalHeight,
                                                shearRect.origin.x / self.layerViewSize.width,
                                                shearRect.size.height/ finalHeight,
                                                shearRect.size.width/ self.layerViewSize.width);
        
    }else{
        
        CGFloat finalWidth = self.layerViewSize.height / deviceProportion;
        
        CGFloat addNum = (finalWidth - self.layerViewSize.width) / 2;
        
        self.output.rectOfInterest = CGRectMake(shearRect.origin.y / self.layerViewSize.height,
                                                (shearRect.origin.x + addNum) / finalWidth,
                                                shearRect.size.height / self.layerViewSize.height,
                                                shearRect.size.width / finalWidth);
    }
    
}

-(void)takeQRCodeFromPic:(UIButton *)btn
{
    if ([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypePhotoLibrary]) {
        
        UIImagePickerController * controller = [[UIImagePickerController alloc]init];
        controller.delegate = self;
        controller.sourceType = UIImagePickerControllerSourceTypeSavedPhotosAlbum;
    controller.modalTransitionStyle=UIModalTransitionStyleFlipHorizontal;
        
        controller.allowsEditing = YES;
        controller.modalPresentationStyle =  UIModalPresentationFullScreen;
        [self presentViewController:controller animated:YES completion:nil];
    }
}

- (void)pushLargeLive:(NSDictionary*)data
{
    [TalkfunLoginRootViewController pushLargeLive:data[@"access_token"]?data[@"access_token"]:@"" title:data[@"title"] ?data[@"title"] :@"" nav:self.navigationController viewController:self];
    
}
- (void)showWithMsg:(NSString*)msg
{
    [TalkfunLoginRootViewController TF_progressHUDShow:msg];
}
- (void)imagePickerController:(UIImagePickerController*)picker didFinishPickingMediaWithInfo:(NSDictionary*)info
{
    [picker dismissViewControllerAnimated:YES completion:nil];
    UIImage * image = [info objectForKey:UIImagePickerControllerEditedImage];
    CIImage * ciImage = [CIImage imageWithCGImage:image.CGImage];

    CIDetector * detector = [CIDetector detectorOfType:CIDetectorTypeQRCode context:nil options:@{CIDetectorAccuracy:CIDetectorAccuracyHigh}];
    
    [picker dismissViewControllerAnimated:YES completion:^{
       
        //检测得到的结果数组
        NSArray * featuresArr = [detector featuresInImage:ciImage];
        if (featuresArr.count > 0) {
            CIQRCodeFeature * feature = [featuresArr objectAtIndex:0];
            NSString * scanResult = feature.messageString;
            NSLog(@"result:%@",scanResult);
            TalkfunScanNewLoginViewController * newLoginVC = [TalkfunScanNewLoginViewController new];

            NSDictionary * requestDict = @{@"qrCodeUrl":[self encodeString:scanResult]};
            NSLog(@"requestDict:%@",requestDict);
                    
        WeakSelf
         [TalkfunLoginRequest requestForScanIn:requestDict callback:^(id result) {
            NSLog(@"回调次数:%@",result);
                        
            if ([result isKindOfClass:[NSDictionary class]] &&[result[@"code"] intValue] == 0) {
                            
            NSDictionary * data = result[@"data"];
                //输入密码进入  回放
                if ([data[@"type"] isEqualToString:@"playbackLogin"]) {
                    newLoginVC.isPlayback = YES;
                    newLoginVC.liveid =   [data[@"liveid"] stringValue] ;
                    
                }
                //只要昵称  直播
                else if ([data[@"type"] isEqualToString:@"tempLogin"]) {
                    
                    // 4为直播，5为回放
                    if ([[data[@"mode"]  stringValue]  isEqualToString:@"4"]) {
                        newLoginVC.isPlayback = NO;
                    }else if ([[data[@"mode"]  stringValue]  isEqualToString:@"5"]){
                        //回放
                        newLoginVC.isPlayback = YES;
                    }
                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
                    
                    [parameters setObject:data[@"logo"] forKey:@"logo"];
                    [UserDefault setObject:@{
                                             @"logo":data[@"logo"]} forKey:@"LogoUrl"];
                    
                    newLoginVC.liveid = [data[@"roomid"] stringValue];
                    newLoginVC.role = data[@"role"] ;
                    newLoginVC.temporary = data[@"temporary"] ;
                    newLoginVC.et = data[@"et"] ;
                    newLoginVC.sign = data[@"sign"];
                    newLoginVC.logo = data[@"logo"];
                    newLoginVC.title1 = data[@"title"] ;
                    
                }
                //输入帐号密码 直播
                else if ([data[@"type"] isEqualToString:@"liveLogin"]){
                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
                    [parameters setObject:data[@"logo"] forKey:@"logo"];
                    newLoginVC.liveid = [data[@"roomid"] stringValue];
                    newLoginVC.title1 = data[@"title"] ;
                    [UserDefault setObject:@{@"logo":parameters[@"logo"]} forKey:@"LogoUrl"];
                }
                
                
                //直接进入  直播
                else if ([data[@"type"] isEqualToString:@"live"])  {
                    
                    NSMutableDictionary *parameters = [NSMutableDictionary dictionary];
                    
                    NSMutableDictionary *temp = [NSMutableDictionary dictionary];
                    [temp setObject:data[@"access_token"] forKey:@"access_token"];
                    [temp setObject:data[@"title"] forKey:@"title"];
                    [temp setObject:data[@"logo"] forKey:@"logo"];
                    [parameters setObject:temp forKey:@"data"];
                    [parameters setObject:@"0" forKey:@"code"];
              
             
                        
                    [self pushLargeLive:data];
                    
                    
                    return;
                }
                //直接进入  回放
                else if ([data[@"type"] isEqualToString:@"playback"]) {
                    
                    NSDictionary *parameters = @{
                                                 @"offlineKey":  [NSString stringWithFormat:@"%@",data[@"liveid"]],
                                                 @"data" : @{
                                                         @"title" : data[@"title"],
                                                         @"logo"  : data[@"logo"],
                                                         @"access_token" : data[@"access_token"],
                                                         },
                                                 @"code" : @"0",
                                                 };
                    
                    
                    
                    [UserDefault setObject:@{
                                             @"logo":parameters[@"data"][@"logo"]} forKey:@"LogoUrl"];
                    
                    
                    dispatch_async(dispatch_get_main_queue(), ^{
                        
                    
                        
                        [TalkfunLoginRootViewController pushLargeBackView:[NSString stringWithFormat:@"%@",data[@"liveid"]] access_token:data[@"access_token"]?data[@"access_token"]:@"" logo:data[@"logo"]?data[@"logo"]:@"" title:data[@"title"]?data[@"title"]:@"" nav:weakSelf.navigationController];
                        
                    });
                    
                    return;
               //课程登陆
                } else if ([data[@"type"] isEqualToString:@"courseLogin"]) {
                    if ([[data[@"mode"]  stringValue]  isEqualToString:@"4"]) {
                        newLoginVC.isPlayback = NO;
                       
                    }else if ([[data[@"mode"]  stringValue]  isEqualToString:@"5"]){
                        //回放
                        newLoginVC.isPlayback = YES;
                        
                    }
                     newLoginVC.liveid = [data[@"courseId"] stringValue];

                    newLoginVC.role = data[@"role"] ;

                    newLoginVC.logo = data[@"logo"];
                    newLoginVC.title1 = data[@"title"] ;
                    
                }
                
            }
            else{
                
                if ([result isKindOfClass:[NSDictionary class]]){
                    if (result[@"msg"]){
                        
                        
                        dispatch_async(dispatch_get_main_queue(), ^{

                            [weakSelf showWithMsg:result[@"msg"]];
                         
                        });
                        
                    }
                    
                    
                    [_session startRunning];
                    
                }
                return;
                
                
            }
            
            
            
//            NSLog(@"来的次数");
            dispatch_async(dispatch_get_main_queue(), ^{
                [weakSelf.navigationController pushViewController:newLoginVC animated:NO];
            });
            
        }];

        } else {
            UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"提示" message:@"扫描不到二维码" preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction * okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:nil];
            [alertController addAction:okAction];
            if (IsIPAD) {
                alertController.popoverPresentationController.sourceView = self.view;
                alertController.popoverPresentationController.sourceRect = CGRectMake(0,0,1.0,1.0);
            }
            [self presentViewController:alertController animated:YES completion:nil];
        }
    }];
}


- (IBAction)backBtnClicked:(UIButton *)sender {
    
    [self.navigationController popViewControllerAnimated:NO];
}

-(void)backClicl
{
     [self.navigationController popViewControllerAnimated:NO];
}

- (void)dealloc{
    
}

@end
