//  Created by 邓盛明 on 2020/7/17.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunSecondNewLoginViewController.h"
#import "TalkfunScanViewController.h"
#import "UIImageView+WebCache.h"

#import "TalkfunCourseManager.h"
#import "TalkfunMyCourseModel.h"

#define NewIDsStr @"newIDs"
#define RememberID @"rememberID"
#define RememberNickID @"rememberNickID1"
#define LogoUrl @"LogoUrl1"
#define kWidth [TalkfunUtils getMainScreen].size.width
#define kHeight [TalkfunUtils getMainScreen].size.height
#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0



@interface TalkfunSecondNewLoginViewController ()<UITextFieldDelegate,UITableViewDelegate,UITableViewDataSource>

@property(nonatomic,strong)UIImageView * bgkImageView; //背景图片

@property(nonatomic,strong)UIButton * saoBtn; // 扫码按钮

@property(nonatomic,strong)UIImageView * saoImgView;

@property(nonatomic,strong)UILabel * saoLab;

@property(nonatomic,strong)UIView * bgView;  //背景view

@property(nonatomic,strong)UIImageView * logoImg;  //公司图片
@property(nonatomic,strong)UIButton * rememberBtn; //记住id

@property(nonatomic,strong)UIButton * joinCourseBtn; //进入课程

@property(nonatomic,strong)UILabel * VersionLab;

@property(nonatomic,strong)UITextField * idTF;//id

@property(nonatomic,strong)UITextField * passwordTF; //密码

@property(nonatomic,strong)UITextField * nicknameTF; // 昵称

@property(nonatomic,strong)UIView * tfView1;

@property(nonatomic,strong)UIView * tfView2;

@property(nonatomic,strong)UIView * tfView3;


//保存直播间登陆的数据
@property(nonatomic,strong)NSMutableDictionary *liveLandingData;

//获取id数组
@property (nonatomic,strong) NSMutableArray * idsArray;

@property (nonatomic,strong) UITableView * tableView;

@property(nonatomic,strong)CAReplicatorLayer *repLicatorLayer;

@end

@implementation TalkfunSecondNewLoginViewController

- (NSMutableDictionary *)liveLandingData
{
    if(!_liveLandingData){
        _liveLandingData = [NSMutableDictionary dictionary];
    } return _liveLandingData;
}


- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    if (@available(iOS 13.0, *)) {
        
 
    }else{
      [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
    }
      //强制翻转屏幕，Home键在右边。

      [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationPortrait) forKey:@"orientation"];

    [self createUI];
    self.manager = [TalkfunCourseManager shareManager];
    [self.manager createTable];
    [self.idsArray removeAllObjects];
    [self.idsArray addObjectsFromArray:[self getNSUserDefaultWithKey:NewIDsStr]];
      NSString * IDStr = [self getNSUserDefaultWithKey:RememberID];
      if (IDStr && ![IDStr isKindOfClass:[NSNull class]]) {
          self.idTF.text = IDStr;
          self.rememberBtn.selected = YES;
      }
    
    NSDictionary * nickIDStr = [self getNSUserDefaultWithKey:RememberNickID];

    if (nickIDStr && ![nickIDStr isKindOfClass:[NSNull class]]) {
        if (self.idTF.text.length > 0) {
            self.nicknameTF.text = nickIDStr[self.idTF.text];

        }
    }

      [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(textFiledEditChanged:)
                                                  name:UITextFieldTextDidChangeNotification object:self.idTF];
      [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
      [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillHide:) name:UIKeyboardWillHideNotification object:nil];

}


-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    self.navigationController.navigationBar.barStyle = UIBarStyleBlack;
      [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    self.joinCourseBtn.userInteractionEnabled = YES;
    [self logoImageSet];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    self.navigationController.navigationBar.hidden = YES;

}

-(void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}


-(void)createUI
{
    CGFloat SafetyZone = 0;
    if (KIsiPhoneX) {
           SafetyZone = 32;
    }
    self.bgkImageView = [[UIImageView alloc]init];
    self.bgkImageView.frame = CGRectMake(0, 0, kWidth, 229+SafetyZone);
    self.bgkImageView.image = [UIImage imageNamed:@"组 1868"];
    [self.view addSubview:self.bgkImageView];
    
    TalkfunIncreaseButton * backBtn = [TalkfunIncreaseButton buttonWithType:UIButtonTypeCustom];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
    [backBtn addTarget:self action:@selector(backBtnClick) forControlEvents:UIControlEventTouchUpInside];
    backBtn.frame = CGRectMake(0, 22+SafetyZone, 40, 40);
    [self.view addSubview:backBtn];
    
    

    
    self.saoBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    self.saoBtn.layer.borderColor = [UIColor whiteColor].CGColor;
    self.saoBtn.layer.borderWidth = 1.0;
    self.saoBtn.layer.cornerRadius = 4.0;
    self.saoBtn.frame = CGRectMake((kWidth-170)/2.0, SafetyZone+46, 170, 50);
    [self.saoBtn addTarget:self action:@selector(scanBtnClicked:) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:self.saoBtn];
    
    self.saoImgView = [[UIImageView alloc]init];
    self.saoImgView.frame = CGRectMake(25.5, 13.5, 23, 23);
    self.saoImgView.image = [UIImage imageNamed:@"扫一扫"];
    [self.saoBtn addSubview:self.saoImgView];
    
    self.saoLab = [[UILabel alloc]init];
    self.saoLab.frame = CGRectMake(CGRectGetMaxX(self.saoImgView.frame)+14.5, 11, 80, 28);
    self.saoLab.text = @"扫码进入";
    self.saoLab.font = [UIFont fontWithName:@"PingFang SC" size:20];
    self.saoLab.textColor = [UIColor whiteColor];
    [self.saoBtn addSubview:self.saoLab];
    
    self.bgView = [[UIView alloc]init];
    if (kWidth == 320) {
     self.bgView.frame = CGRectMake(10, SafetyZone+142.5, kWidth-20, 400);
    } else {
     self.bgView.frame = CGRectMake(17.5, SafetyZone+142.5, kWidth-35, 415);
    }
   
    self.bgView.alpha = 1.0;
    self.bgView.backgroundColor = [UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:1.0];
    self.bgView.layer.shadowColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.16].CGColor;
    self.bgView.layer.shadowOffset = CGSizeMake(0,3.5);
    self.bgView.layer.shadowRadius = 7.5;
    self.bgView.layer.shadowOpacity = 1;
    self.bgView.layer.cornerRadius = 22;
    [self.view addSubview:self.bgView];
    
    self.logoImg = [[UIImageView alloc]init];
    self.logoImg.frame = CGRectMake((self.bgView.frame.size.width-144)/2.0, 24.5, 144, 35);
    self.logoImg.image = [UIImage imageNamed:@"欢拓logo"];
    [self.bgView addSubview:self.logoImg];
    
      UIImageView * binakuangImg = [[UIImageView alloc]init];
     binakuangImg.frame = CGRectMake(CGRectGetMaxX(self.logoImg.frame)+10, 28.5, 63, 27);
     binakuangImg.image = [UIImage imageNamed:@"观看边框"];
     [self.bgView addSubview:binakuangImg];
    
    UILabel * biankuangLab = [[UILabel alloc]init];
    biankuangLab.frame = CGRectMake(CGRectGetMaxX(self.logoImg.frame)+25, 32.5, 42, 20);
    biankuangLab.text = @"观看端";
    biankuangLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
    biankuangLab.textColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
    [self.bgView addSubview:biankuangLab];
    
    
    self.tfView1 = [[UIView alloc]init];
    self.tfView1.frame = CGRectMake(20, CGRectGetMaxY(self.logoImg.frame)+30.5, self.bgView.frame.size.width-40, 44);
    self.tfView1.alpha = 1.0;
    self.tfView1.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
    self.tfView1.layer.borderWidth = 0.5;
    self.tfView1.layer.cornerRadius = 22;
    [self.bgView addSubview:self.tfView1];
    
    UIImageView * tvImg = [[UIImageView alloc]init];
    tvImg.image = [UIImage imageNamed:@"观看tv"];
    if (kWidth == 320) {
        tvImg.frame = CGRectMake(12, 10, 22, 22);
    } else {
       tvImg.frame = CGRectMake(22, 10, 22, 22);
    }
    
    [self.tfView1 addSubview:tvImg];
    
    self.idTF = [[UITextField alloc]init];
    if (kWidth == 320) {
      self.idTF.frame = CGRectMake(CGRectGetMaxX(tvImg.frame)+10, 7, CGRectGetWidth(self.tfView1.frame)-44-13, 30);
    } else {
       self.idTF.frame = CGRectMake(CGRectGetMaxX(tvImg.frame)+17.5, 7, CGRectGetWidth(self.tfView1.frame)-61.5-13, 30);
    }
    self.idTF.font = [UIFont fontWithName:@"PingFang SC" size:16];
    self.idTF.placeholder = @"请输入直播ID或者点播ID";
    self.idTF.delegate = self;
    self.idTF.keyboardType = UIKeyboardTypeNumberPad;
    self.idTF.clearButtonMode = UITextFieldViewModeWhileEditing;
    [self.tfView1 addSubview:self.idTF];
    
    UIButton *deleteIDBtn = [self.idTF valueForKey:@"_clearButton"];

    [deleteIDBtn setImage:[UIImage imageNamed:@"logln_delete"] forState:UIControlStateNormal];

    
    
    self.tfView2 = [[UIView alloc]init];
    self.tfView2.frame = CGRectMake(20, CGRectGetMaxY(self.tfView1.frame)+20, self.bgView.frame.size.width-40, 44);
      self.tfView2.alpha = 1.0;
      self.tfView2.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
      self.tfView2.layer.borderWidth = 0.5;
      self.tfView2.layer.cornerRadius = 22;
      [self.bgView addSubview:self.tfView2];
      UIImageView * passwordImg = [[UIImageView alloc]init];
       passwordImg.image = [UIImage imageNamed:@"password"];
   
       
       [self.tfView2 addSubview:passwordImg];
      self.passwordTF = [[UITextField alloc]init];
     if (kWidth == 320) {
           passwordImg.frame = CGRectMake(12, 10, 22, 22);
          self.passwordTF.frame = CGRectMake(CGRectGetMaxX(passwordImg.frame)+10, 7, CGRectGetWidth(self.tfView1.frame)-44-13, 30);
         
       } else {
           passwordImg.frame = CGRectMake(22, 10, 22, 22);
           self.passwordTF.frame = CGRectMake(CGRectGetMaxX(passwordImg.frame)+17.5, 7, CGRectGetWidth(self.tfView1.frame)-61.5-13, 30);
       }
      
       self.passwordTF.delegate = self;
       self.passwordTF.font = [UIFont fontWithName:@"PingFang SC" size:16];
       self.passwordTF.placeholder = @"请输入密码";
      self.passwordTF.secureTextEntry = YES;
     
      self.passwordTF.clearButtonMode = UITextFieldViewModeWhileEditing;
      [self.tfView2 addSubview:self.passwordTF];
    
     UIButton * deletepasswordBtn = [self.passwordTF valueForKey:@"_clearButton"];
     [deletepasswordBtn setImage:[UIImage imageNamed:@"logln_delete"] forState:UIControlStateNormal];

    
    self.tfView3 = [[UIView alloc]init];
    self.tfView3.frame = CGRectMake(20, CGRectGetMaxY(self.tfView2.frame)+20, self.bgView.frame.size.width-40, 44);
      self.tfView3.alpha = 1.0;
      self.tfView3.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
      self.tfView3.layer.borderWidth = 0.5;
      self.tfView3.layer.cornerRadius = 22;
      [self.bgView addSubview:self.tfView3];
    
    UIImageView * nicknameImg = [[UIImageView alloc]init];
    nicknameImg.image = [UIImage imageNamed:@"昵称"];
    nicknameImg.frame = CGRectMake(22, 10, 22, 22);
    [self.tfView3 addSubview:nicknameImg];
    self.nicknameTF = [[UITextField alloc]init];
    self.nicknameTF.font = [UIFont fontWithName:@"PingFang SC" size:16];
    self.nicknameTF.placeholder = @"请输入昵称";
    self.nicknameTF.secureTextEntry = NO;
    self.nicknameTF.delegate = self;
    self.nicknameTF.clearButtonMode = UITextFieldViewModeWhileEditing;
    [self.tfView3 addSubview:self.nicknameTF];
    
    if (kWidth == 320) {
            nicknameImg.frame = CGRectMake(12, 10, 22, 22);
            self.nicknameTF.frame = CGRectMake(CGRectGetMaxX(nicknameImg.frame)+10, 7, CGRectGetWidth(self.tfView1.frame)-44-13, 30);
           
         } else {
             nicknameImg.frame = CGRectMake(22, 10, 22, 22);
             self.nicknameTF.frame = CGRectMake(CGRectGetMaxX(nicknameImg.frame)+17.5, 7, CGRectGetWidth(self.tfView1.frame)-61.5-13, 30);
         }
    UIButton * deletenickNameBtn = [self.nicknameTF valueForKey:@"_clearButton"];
   
    [deletenickNameBtn setImage:[UIImage imageNamed:@"logln_delete"] forState:UIControlStateNormal];

    
    self.rememberBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    self.rememberBtn.frame = CGRectMake(CGRectGetWidth(self.bgView.frame)-70-24-14, CGRectGetMaxY(self.tfView3.frame)+17.5, 14, 14);
    [self.rememberBtn setImage:[UIImage imageNamed:@"rememberID_nor"] forState:UIControlStateNormal];
    [self.rememberBtn setImage:[UIImage imageNamed:@"remberID"] forState:UIControlStateSelected];
    self.rememberBtn.selected = YES;
    [self.rememberBtn addTarget:self action:@selector(rememberBtnClicked:) forControlEvents:UIControlEventTouchUpInside];
    [self.bgView addSubview:self.rememberBtn];
    
    UILabel * rememberLab = [[UILabel alloc]init];
    rememberLab.frame = CGRectMake(CGRectGetWidth(self.bgView.frame)-24-70, CGRectGetMaxY(self.tfView3.frame)+13, 70, 22.5);
    rememberLab.textColor = [UIColor colorWithRed:134/255.0 green:142/255.0 blue:149/255.0 alpha:1.0];
     NSMutableAttributedString *string = [[NSMutableAttributedString alloc] initWithString:@"记住此ID" attributes:@{NSFontAttributeName: [UIFont fontWithName:@"PingFang SC" size: 16], NSForegroundColorAttributeName: [UIColor colorWithRed:134/255.0 green:142/255.0 blue:149/255.0 alpha:1.0]}];
    rememberLab.attributedText = string;
    rememberLab.textAlignment = NSTextAlignmentRight;
    [self.bgView addSubview:rememberLab];
    
    self.joinCourseBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    self.joinCourseBtn.frame = CGRectMake(20, CGRectGetMaxY(rememberLab.frame)+24.5, CGRectGetWidth(self.tfView3.frame), 50);
    self.joinCourseBtn.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
    self.joinCourseBtn.layer.shadowColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.30].CGColor;
    self.joinCourseBtn.layer.shadowOffset = CGSizeMake(0,2.5);
    self.joinCourseBtn.layer.shadowRadius = 5;
    self.joinCourseBtn.layer.shadowOpacity = 1;
    self.joinCourseBtn.layer.cornerRadius = 25;
    [self.joinCourseBtn setTitle:@"进入课程" forState:UIControlStateNormal];
    [self.joinCourseBtn addTarget:self action:@selector(getInBtnClicked:) forControlEvents:UIControlEventTouchUpInside];
    [self.bgView addSubview:self.joinCourseBtn];
    


}

-(void)backBtnClick
{
    [self.navigationController popViewControllerAnimated:YES];
}

#pragma mark - textfield delegate
- (BOOL)textFieldShouldBeginEditing:(UITextField *)textField{
    if (textField == self.idTF) {
         self.tfView1.layer.borderColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
        self.tfView2.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
        self.tfView3.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
       
        if (textField.text.length == 0) {
            [self historyList:NO];
        }
    }else if (textField == self.passwordTF){

        self.tfView2.layer.borderColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
        self.tfView1.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
        self.tfView3.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
   
      
    }else if (textField == self.nicknameTF){
        self.tfView3.layer.borderColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
        self.tfView2.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
        self.tfView1.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
      
    }

    return YES;
}

- (BOOL)textFieldShouldEndEditing:(UITextField *)textField{
    if (textField == self.idTF) {
//        [self.selectModeBtn setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
//        self.idUnderLineView.backgroundColor = GRAYCOLOR;
    }else if (textField == self.passwordTF){
//        [self.secretBtn setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
//        self.secretUnderLineView.backgroundColor = GRAYCOLOR;
    }else if (textField == self.nicknameTF){
//        [self.nameBtn setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
//        self.nameUnderLineView.backgroundColor = GRAYCOLOR;
    }
    return YES;
}


#pragma mark - 按钮点击事件
- (void)scanBtnClicked:(UIButton *)sender {
   
    if (self.isScanIn) {
        [self.navigationController popViewControllerAnimated:YES];
    }
    else{
        TalkfunScanViewController * scanVC = [TalkfunScanViewController new];
        scanVC.hidesBottomBarWhenPushed = YES;
        scanVC.nickName = self.nicknameTF.text;
        [self.navigationController pushViewController:scanVC animated:YES];
    }
    NSLog(@"___%s___",__func__);
}

- (void)aboutBtnClicked
{

}

//记住id
- (void)rememberBtnClicked:(UIButton *)sender {
    sender.selected = !sender.selected;
    if (sender.selected) {
        self.rememberBtn.selected = YES;
    }
    else
    {
        self.rememberBtn.selected = NO;
    }
    NSLog(@"___%s___",__func__);
}

//获取logo图片
- (void)logoImageSet{
    id obj = [UserDefault objectForKey:LogoUrl];
  
    NSString * logoUrl = obj[@"log"]?obj[@"logo"]:@"";
    if (logoUrl.length > 0) {
        NSString * logoUrl = obj[@"logo"];
        [self.logoImg sd_setImageWithURL:[NSURL URLWithString:logoUrl] placeholderImage:nil options:0];
        
    }else{
        self.logoImg.image = [UIImage imageNamed:@"欢拓logo"];
    }
}

//防止重复添加数据库进数据库,如果有，即不添加。
-(BOOL)isEquattoModelID:(NSString *)idstr
{
   NSArray * array = [self.manager selectCourseList];
     
    for (TalkfunMyCourseModel * model in array) {

        if ([model.IDs isEqualToString:idstr]) {
            
            model.password = self.passwordTF.text;
            [self.manager updateCourseModel:model];
            return NO;

        }
    }
   
    return YES;
}
//TODO: 手动输入直播id与密码 登录

- (void)getInBtnClicked:(UIButton *)sender {



        if (TEXTFIELDHASNOVALUE(self.idTF)) {
            [TalkfunLoginRootViewController TF_progressHUDShow:@"请输入ID"];
           
            return;
        }
        if (TEXTFIELDHASNOVALUE(self.nicknameTF)) {

            [TalkfunLoginRootViewController TF_progressHUDShow:@"昵称不能为空"];
         
               return;
            }
    

    NSMutableDictionary * params = [NSMutableDictionary new];
    params[@"id"] = self.idTF.text;
    params[@"nickname"] = self.nicknameTF.text;
     NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;
    if (!TEXTFIELDHASNOVALUE(self.passwordTF)) {
        params[@"password"] = self.passwordTF.text;
    }
    if (!self.pid) {
        params[@"pid"] = self.pid;
    }

    [self.view endEditing:YES];
    

    [TalkfunLoginRootViewController nav:self.navigationController viewController:self params:params callback:^(id  _Nonnull result) {
        
    }];

}

#pragma mark 当点击键盘的返回键（右下角）时，执行该方法。
-(BOOL)textFieldShouldReturn:(UITextField *)textField{
    
    if(self.idTF == textField){
        [[UIApplication sharedApplication] sendAction:@selector(resignFirstResponder) to:nil from:nil forEvent:nil];
    }
    [self historyList:YES];
    return YES;
}
- (void)textFiledEditChanged:(NSNotification *)notification
{
    UITextField * tf = notification.object;
    NSString * text = tf.text;
    NSArray * IDArray = [self getNSUserDefaultWithKey:NewIDsStr];
    [self.idsArray removeAllObjects];
    if (text.length != 0) {
        for (int i = 0; i < IDArray.count; i ++) {
            NSString * t = IDArray[i];
            if ([t hasPrefix:text] && ![t isEqualToString:text]) {
                [self.idsArray addObject:t];
            }
        }
    }
    else
    {
        [self.idsArray addObjectsFromArray:IDArray];
    }

    [UIView animateWithDuration:0.3 animations:^{
       
        [self reloadData];
    }];
}

#pragma mark - tableView dataSource delegate
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    return self.idsArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    UITableViewCell * cell = [tableView dequeueReusableCellWithIdentifier:@"cell"];
    if (!cell) {
        cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"cell"];
    }
    cell.backgroundColor = UIColorFromRGBHex(0xecf3ff);
    cell.selectionStyle = UITableViewCellSelectionStyleGray;
    cell.textLabel.text = self.idsArray[indexPath.row];
    cell.textLabel.textAlignment = NSTextAlignmentRight;
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    
    self.idTF.text = self.idsArray[indexPath.row];
    
    [self historyList:YES];
}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
   
    return UITableViewCellEditingStyleDelete;
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        UITableViewCell * cell = [tableView cellForRowAtIndexPath:indexPath];
        [self remove:NewIDsStr value:cell.textLabel.text];
    }
}

//是否可以编辑  默认YES
-(BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath{
    return YES;
}


-(void)historyList:(BOOL)hide
{
    WeakSelf
    
    if (hide) {
        [UIView animateWithDuration:0.3 animations:^{
            [weakSelf.tableView setFrame:CGRectMake(CGRectGetMinX(weakSelf.tableView.frame), CGRectGetMaxY(weakSelf.tfView1.frame), CGRectGetWidth(weakSelf.tableView.frame), 0)];
        }];
    }
    else{
        [UIView animateWithDuration:0.3 animations:^{
         
            [self reloadData];
        }];
    }
}

//加载动画
-(void)tranStateAnimation
{
     self.repLicatorLayer = [CAReplicatorLayer layer];
     self.repLicatorLayer.bounds = CGRectMake(0, 0, 100, 100);
     self.repLicatorLayer.cornerRadius = 10.0;
     self.repLicatorLayer.position = self.view.center;
     self.repLicatorLayer.backgroundColor = [UIColor whiteColor].CGColor;
     self.repLicatorLayer.instanceCount = 3;
     self.repLicatorLayer.instanceTransform = CATransform3DMakeTranslation(self.repLicatorLayer.frame.size.width/3, 0, 0);
     self.repLicatorLayer.instanceDelay = 1.0/3;
    self.repLicatorLayer.shadowOffset = CGSizeMake(1, 1);
    self.repLicatorLayer.shadowOpacity = 0.3;
    self.repLicatorLayer.shadowColor = [UIColor lightGrayColor].CGColor;
    
    [self.view.layer addSublayer:self.repLicatorLayer];
    
    
     CALayer * dotLayer = [CALayer layer];
     dotLayer.bounds = CGRectMake(0, 0, 15, 15);
     dotLayer.position = CGPointMake(15, self.repLicatorLayer.frame.size.height/2);
     dotLayer.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:0.6].CGColor;
     dotLayer.cornerRadius    = 7.5;
     dotLayer.transform = CATransform3DMakeScale(0, 0, 0);
     [self.repLicatorLayer addSublayer:dotLayer];
     
     CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"transform.scale"];
     animation.duration    = 1.0;
     animation.fromValue   = @1;
     animation.toValue     = @0;
     animation.repeatCount = MAXFLOAT;
     [dotLayer addAnimation:animation forKey:nil];
    
   
    
}

#pragma mark - 存储数据到本地
- (void)saveValue:(NSString *)key Value:(NSString *)value
{
    @synchronized (self) {
        if (!value) {
            return;
        }
        if([[NSUserDefaults standardUserDefaults] objectForKey:key] == nil || [[[NSUserDefaults standardUserDefaults] objectForKey:key] isKindOfClass:[NSNull class]]){
            
            NSMutableArray * mutable = [NSMutableArray array];
            [mutable addObject:value];
            if (mutable.count != 0) {
                [[NSUserDefaults standardUserDefaults] setValue:mutable forKey:key];
                [[NSUserDefaults standardUserDefaults] synchronize];
            }
        }
        else{
            NSMutableArray * mutable = [[[NSUserDefaults standardUserDefaults] objectForKey:key] mutableCopy];
            //本地数据是否已经包含
            BOOL contains = [mutable containsObject:value];
            
            if (!contains)
            {
                
            }
            else
            {
                [mutable removeObject:value];
            }
            [mutable insertObject:value atIndex:0];
            if (mutable.count != 0) {
                [[NSUserDefaults standardUserDefaults] setValue:mutable forKey:key];
                [[NSUserDefaults standardUserDefaults] synchronize];
            }
        }
        //拿出更新后的数据
        [self.idsArray removeAllObjects];
        [self.idsArray addObjectsFromArray:[self getNSUserDefaultWithKey:NewIDsStr]];
        if (self.idTF.isFirstResponder) {
            [self reloadData];
        }
    }
}

- (void)remove:(NSString *)key value:(NSString *)value{
    @synchronized (self) {
        if (!value) {
            return;
        }
        if([[NSUserDefaults standardUserDefaults] objectForKey:key] == nil || [[[NSUserDefaults standardUserDefaults] objectForKey:key] isKindOfClass:[NSNull class]]){
            return;
        }else{
            NSMutableArray * mutable = [[[NSUserDefaults standardUserDefaults] objectForKey:key] mutableCopy];
            //本地数据是否已经包含
            BOOL contains = [mutable containsObject:value];
            if (contains)
            {
                [mutable removeObject:value];
            }
            [[NSUserDefaults standardUserDefaults] setValue:mutable forKey:key];
            [[NSUserDefaults standardUserDefaults] synchronize];
        }
        //拿出更新后的数据
        [self.idsArray removeAllObjects];
        [self.idsArray addObjectsFromArray:[self getNSUserDefaultWithKey:NewIDsStr]];
        if (self.idTF.isFirstResponder) {
            [self reloadData];
        }
    }
}

-(void)reloadData
{
    [self.tableView reloadData];
       CGRect frame = self.tableView.frame;
       frame.size.height = self.tableView.contentSize.height<30*5?self.tableView.contentSize.height:30*5;
       self.tableView.frame = frame;
}
#pragma mark - 拿本地存储的数据
- (id)getNSUserDefaultWithKey:(NSString *)key{
    
    id obj = [[NSUserDefaults standardUserDefaults] objectForKey:key];
    return obj;
}

-(NSString*)getNumber:(NSObject*)obj
{
    NSString *UsersXid = @"0";
    
    if([obj isKindOfClass:[NSNumber class] ]){
        
        NSNumber  *num     = (NSNumber*) obj;
        NSNumberFormatter *tempNum = [[NSNumberFormatter alloc] init];
        
        UsersXid = [tempNum stringFromNumber:num];
    }else if([obj isKindOfClass:[NSString class] ]){
        
        NSString  *str    = (NSString*)obj;
        UsersXid = str;
    }
    
    return UsersXid;
}
- (void)keyboardWillShow:(NSNotification *)notification{
    [UIView animateWithDuration:0.25 animations:^{
        for (UIView * view in self.view.subviews) {
            view.transform = CGAffineTransformMakeTranslation(0, -44);
        }
        CGRect frame = self.tableView.frame;
        frame.origin.y = CGRectGetMaxY(self.tfView1.frame);
        self.tableView.frame = frame;
    }];
}

- (void)keyboardWillHide:(NSNotification *)notification{
    [UIView animateWithDuration:0.25 animations:^{
        for (UIView * view in self.view.subviews) {
            view.transform = CGAffineTransformIdentity;;
        }
    }];
}
- (NSMutableArray *)idsArray{
    if (!_idsArray) {
        _idsArray = [NSMutableArray new];
    }
    return _idsArray;
}


- (UITableView *)tableView
{
    if (!_tableView) {
        //========= 创建tableView（显示登陆过的帐号）==========
        _tableView = [[UITableView alloc]initWithFrame:CGRectMake(CGRectGetMinX(self.tfView1.frame), CGRectGetMaxY(self.tfView1.frame), CGRectGetWidth(self.tfView1.frame), 0) style:UITableViewStylePlain];
        _tableView.backgroundColor = [UIColor whiteColor];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        //        _tableView.editing = YES;
        _tableView.rowHeight = 30;
        _tableView.layer.borderWidth = 1.5;
        _tableView.layer.borderColor = UIColorFromRGBHex(0x56acf5).CGColor;
        
        _tableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
        _tableView.separatorColor = [UIColor whiteColor];
        _tableView.bounces = NO;
        //        _tableView.scrollEnabled = NO;
        
        [self.bgView addSubview:_tableView];
    }
    return _tableView;
}

- (void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
{
    [self.view endEditing:YES];
    [self historyList:YES];
}
#pragma mark - 旋转
- (BOOL)shouldAutorotate{
    [[UIDevice currentDevice] setValue:@(UIDeviceOrientationPortrait) forKey:@"orientation"];
    return YES;
}
-(UIInterfaceOrientationMask)supportedInterfaceOrientations
{
   
    return UIInterfaceOrientationMaskPortrait;
}
- (UIStatusBarStyle)preferredStatusBarStyle{
    return UIStatusBarStyleLightContent;//白色
}
-(void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

@end
