
//  Created by 邓盛明 on 2020/7/21.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunCourseListViewController.h"
#import "TalkfunSecondNewLoginViewController.h"
#import "MJExtension.h"
#import "TalkfunMyScrollview.h"
#include "AFNetworking.h"
#import "TalkfunListPartnerCell.h"
#import "TalkfunListPartnerModel.h"

#import "TalkfunSettingsController.h"
#import "TalkfunAllCourseViewController.h"
#import "TalkfunMyCourseViewController.h"


#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0

#define kWidth [TalkfunUtils getMainScreen].size.width
#define kHeight [TalkfunUtils getMainScreen].size.height

@interface TalkfunCourseListViewController ()<UITableViewDelegate,UITableViewDataSource,UIScrollViewDelegate,UIGestureRecognizerDelegate , TFcourseDownloadControllerDelegate>

//课程
@property(nonatomic,strong)UIImageView * upOrdownImg;

@property(nonatomic,strong)TalkfunMyScrollview * scrollView;
@property(nonatomic,strong)UITableView * listPartnerTableView; //合作商
@property(nonatomic,strong)UIView * maskView;
@property(nonatomic,strong)NSMutableArray * listPartnerData;
@property(nonatomic,strong)UILabel * lineLab;
@property(nonatomic,strong)UILabel * PartnerNameLab;

@property(nonatomic,strong)NSMutableArray * btnArr;

//@property(nonatomic,copy) NSString * uid;


@property(nonatomic,strong)UIView * NotReachableView; //无网络显示的

@property(nonatomic,strong)UIView * allCourseTitleView; //按钮view

@property(nonatomic,assign)NSInteger reloadTag;  //刷新的标识

@property(nonatomic,strong)NSString * checkStr;

@property(nonatomic,assign)CGFloat SafetyZone;

@property(nonatomic,assign)CGFloat bottomSafe;

@property(nonatomic,assign)NSInteger downTags;

//选中的
@property(nonatomic,assign)NSInteger patnerSelect;

@property(nonatomic,strong)UIButton * titleBtn;

@property(nonatomic,assign)BOOL isFirst;

@property(nonatomic,assign)BOOL isReload;
@property(nonatomic,strong)UIButton * addBtn ;

@property(nonatomic,strong)TalkfunAllCourseViewController  * allCourseController;  //所有课程
@property(nonatomic,strong)TalkfunMyCourseViewController * myCourseController;  //我的课程
@property(nonatomic,strong)TFcourseDownloadController * downLoadController;  //本地课程
@property(nonatomic,strong)TFdocDownloadController * courseDownLoadController;  // 课件下载
@end

@implementation TalkfunCourseListViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.view.backgroundColor = [UIColor whiteColor];
    self.reloadTag = 0;
    self.SafetyZone = 0;
    self.bottomSafe = 0;
    self.downTags = 0;
    self.isFirst = YES;
    if (@available(iOS 13.0, *)) {
        
 
    }else{
    [[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:NO];
    }
    


    
    [self createUI];
    [self loadData];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reachtoNOnetwork:) name:@"CourseListnoReachable" object:nil];
    
    CGFloat settingsBtnW = 40;
    
    TalkfunIncreaseButton * settingsBtn = [TalkfunIncreaseButton buttonWithType:UIButtonTypeCustom];
    [settingsBtn setImage:[UIImage imageNamed:@"Settings"] forState:UIControlStateNormal];
    [settingsBtn setImage:[UIImage imageNamed:@"Settings"] forState:UIControlStateSelected];
    [settingsBtn addTarget:self action:@selector(settingsBtnClick) forControlEvents:UIControlEventTouchUpInside];
    settingsBtn.frame = CGRectMake(kWidth - settingsBtnW, self.addBtn.frame.origin.y +10, settingsBtnW, 20);
    settingsBtn.imageView.contentMode = UIViewContentModeScaleAspectFit;
    [self.view addSubview:settingsBtn];
}

- (void)settingsBtnClick
{
    TalkfunSettingsController *settings = [[TalkfunSettingsController alloc]init];
    [self.navigationController pushViewController:settings animated:YES];
}

-(void)reachtoNOnetwork:(NSNotification *)noti
{
    NSDictionary * dict = noti.object;
    NSNumber * iswork = [dict objectForKey:@"iswork"];
    
    if ([iswork isEqualToNumber:@(1)]) {
      self.NotReachableView.hidden = YES;
      self.allCourseTitleView.hidden = NO;
    } else {
      self.NotReachableView.hidden = NO;
      self.allCourseTitleView.hidden = YES;

    }
   
}
// 控制器的view即将显示的时候调用
-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    //强制翻转屏幕，Home键在右边。

    [[UIDevice currentDevice] setValue:@(UIInterfaceOrientationPortrait) forKey:@"orientation"];
    self.navigationController.navigationBar.hidden = YES;

    self.navigationController.navigationBar.barStyle = UIBarStyleBlack;
    [UIApplication sharedApplication].statusBarStyle = UIStatusBarStyleLightContent;
    
}

-(void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
  
    [self hiddenListPartner];
}

- (CGRect)getMainScreenBounds
{
    
    CGFloat superViewW = [UIScreen mainScreen].bounds.size.width;
    CGFloat superViewH = [UIScreen mainScreen].bounds.size.height;
        
    //1 ==螢幕直立

    if (superViewH< superViewW) {
        //[UIDevice currentDevice].orientation==1 &&
            superViewH =  [UIScreen mainScreen].bounds.size.width;
            superViewW =  [UIScreen mainScreen].bounds.size.height ;
    }
    
    return CGRectMake(0, 0, superViewW, superViewH);
}
-(void)createUI
{
   
         if (KIsiPhoneX) {
           self.SafetyZone = 24;
           self.bottomSafe = 32;
            }

       UIView * bgview = [[UIView alloc]init];
       bgview.frame = CGRectMake(0, 0, [self getMainScreenBounds].size.width, 64+self.SafetyZone);
       bgview.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
       [self.view addSubview:bgview];
    
    self.maskView = [[UIView alloc]init];
    self.maskView.backgroundColor = [UIColor colorWithRed:229/255.0 green:229/255.0 blue:229/255.0 alpha:0.5];
    UITapGestureRecognizer * maskTap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(hiddenListPartner)];
    self.maskView.userInteractionEnabled = YES;
    self.maskView.hidden = YES;
    [self.maskView addGestureRecognizer:maskTap];
  
    [[UIApplication sharedApplication].keyWindow addSubview:self.maskView];
    
       UIButton * addBtn = [UIButton buttonWithType:UIButtonTypeCustom];
       self.addBtn = addBtn;
       [addBtn setImage:[UIImage imageNamed:@"add"] forState:UIControlStateNormal];
       [addBtn setImage:[UIImage imageNamed:@"add"] forState:UIControlStateSelected];
       [addBtn addTarget:self action:@selector(addBtnClick) forControlEvents:UIControlEventTouchUpInside];
       addBtn.frame = CGRectMake(0, 24+self.SafetyZone, 40, 40);
       [bgview addSubview:addBtn];

    
    self.titleBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    self.titleBtn.frame = CGRectMake(50,29.5+self.SafetyZone,[self getMainScreenBounds].size.width-100,25);
   [self.titleBtn addTarget:self action:@selector(titleBtnClick:) forControlEvents:UIControlEventTouchUpInside];
    [bgview addSubview:self.titleBtn];
    
       self.PartnerNameLab = [[UILabel alloc]init];
       self.PartnerNameLab.text = @"广州欢拓网络科技有限公司";
       
       self.PartnerNameLab.frame = CGRectMake(( self.titleBtn.frame.size.width-216-21)/2.0,0,216,25);
       self.PartnerNameLab.numberOfLines = 0;
       self.PartnerNameLab.textColor = [UIColor whiteColor];
       self.PartnerNameLab.textAlignment = NSTextAlignmentCenter;
       self.PartnerNameLab.font = [UIFont fontWithName:@"PingFang SC" size: 18];
       [self.titleBtn addSubview:self.PartnerNameLab];

     
        self.upOrdownImg = [[UIImageView alloc]init];
        self.upOrdownImg.image = [UIImage imageNamed:@"down"];
        self.upOrdownImg.frame = CGRectMake(CGRectGetMaxX(self.PartnerNameLab.frame)+8, 8.5, 13, 8);
        [self.titleBtn addSubview:self.upOrdownImg];
        
    
    
   self.allCourseTitleView = [[UIView alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(bgview.frame), [self getMainScreenBounds].size.width, 44)];
    self.allCourseTitleView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:self.allCourseTitleView];
    
    self.NotReachableView = [[UIView alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(bgview.frame), [self getMainScreenBounds].size.width, 44)];
    self.NotReachableView.backgroundColor = [UIColor colorWithRed:255/255.0 green:235/255.0 blue:235/255.0 alpha:1.0];
    self.NotReachableView.hidden = YES;
    [self.view addSubview:self.NotReachableView];
    
    UIImageView * noImagView = [[UIImageView alloc]initWithFrame:CGRectMake(12, 12, 20, 20)];
    noImagView.image = [UIImage imageNamed:@"NotReachable"];
    [self.NotReachableView addSubview:noImagView];
    
    UILabel * netLabel = [[UILabel alloc]initWithFrame:CGRectMake(39, 10, [self getMainScreenBounds].size.width-50, 24)];
    netLabel.font = [UIFont fontWithName:@"PingFang SC" size: 17];
    netLabel.text = @"当前网络不可用，请检查网络设置";
    netLabel.textColor = [UIColor colorWithRed:248/255.0 green:83/255.0 blue:83/255.0 alpha:1.0];
    [self.NotReachableView addSubview:netLabel];
    
    for (int i=0; i<4; i++) {
        TFMultifunctionButton * btn = [[TFMultifunctionButton alloc]init];
        btn.frame = CGRectMake(([self getMainScreenBounds].size.width/4.0-70)/2.0+i*[self getMainScreenBounds].size.width/4.0, 10, 70, 24);
        btn.tag = 1000+i;
        btn.titleLabel.font = [UIFont fontWithName:@"PingFang SC" size:17];
        [btn addTarget:self action:@selector(coreseListClick:) forControlEvents:UIControlEventTouchUpInside];
        if (i==0) {
            [btn setTitle:@"所有课程" forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0] forState:UIControlStateNormal];
        }else if (i==1){
            [btn setTitle:@"我的课程" forState:UIControlStateNormal];
           [btn setTitleColor:[UIColor colorWithRed:116/255.0 green:126/255.0 blue:136/255.0 alpha:1.0] forState:UIControlStateNormal];
        } else if(i==2) {
            [btn setTitle:@"本地课程" forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor colorWithRed:116/255.0 green:126/255.0 blue:136/255.0 alpha:1.0] forState:UIControlStateNormal];
        } else {
            [btn setTitle:@"课件下载" forState:UIControlStateNormal];
            [btn setTitleColor:[UIColor colorWithRed:116/255.0 green:126/255.0 blue:136/255.0 alpha:1.0] forState:UIControlStateNormal];
        }
        
        [self.allCourseTitleView addSubview:btn];
        [self.btnArr addObject:btn];
    }
    
    self.lineLab.frame =CGRectMake(([self getMainScreenBounds].size.width/4.0-40)/2.0, 42, 40, 2);
    UILabel * line = [[UILabel alloc]initWithFrame:CGRectMake(0, 43, [self getMainScreenBounds].size.width, 1)];
    line.backgroundColor = [UIColor colorWithRed:221/255.0 green:229/255.0 blue:236/255.0 alpha:1.0];
    [self.allCourseTitleView addSubview:line];
    [self.allCourseTitleView addSubview:self.lineLab];
    
    self.scrollView = [[TalkfunMyScrollview alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(self.allCourseTitleView.frame), [self getMainScreenBounds].size.width, kHeight-44-CGRectGetHeight(bgview.frame))];
    self.scrollView.delegate = self;
    self.scrollView.backgroundColor = [UIColor whiteColor];
    self.scrollView.scrollEnabled = YES;
    self.scrollView.bounces = NO;
    self.scrollView.pagingEnabled = YES;
    self.scrollView.alwaysBounceVertical = YES;
    self.scrollView.alwaysBounceHorizontal = YES;
    self.scrollView.contentSize= CGSizeMake([self getMainScreenBounds].size.width * 4, 0);
    if (@available(iOS 11.0, *)) {
        
        self.scrollView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
        
    }

    NSArray * gestureArr = self.navigationController.view.gestureRecognizers;
    
    for (UIGestureRecognizer * gestureRec in gestureArr) {
        if ([gestureRec isKindOfClass:[UIScreenEdgePanGestureRecognizer class]]) {
            [self.scrollView.panGestureRecognizer requireGestureRecognizerToFail:gestureRec];
        }
    }
    [self.view addSubview:self.scrollView];
    
    for (int i=0; i<4; i++) {
        if (i==0) {
            self.allCourseController = [[TalkfunAllCourseViewController alloc]init];
            [self addChildViewController:self.allCourseController];
            self.allCourseController.view.frame = CGRectMake(0, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
            self.allCourseController.view.backgroundColor = [UIColor whiteColor];
            [self.scrollView addSubview:self.allCourseController.view];
            //UITableView重新设置frame
            self.allCourseController.allCourseTableview.frame = self.allCourseController.view.frame;
            
        } else if (i==1) {
            self.myCourseController = [[TalkfunMyCourseViewController alloc]init];
            [self addChildViewController:self.myCourseController];
            self.myCourseController.view.frame = CGRectMake(self.scrollView.frame.size.width, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
            self.myCourseController.view.backgroundColor = [UIColor whiteColor];

            self.myCourseController.bottomSafe = self.bottomSafe;
            [self.scrollView addSubview:self.myCourseController.view];
            //UITableView重新设置frame
            self.myCourseController.myCourseTableview.frame = CGRectMake(0, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
        } else if (i==2) {
            self.downLoadController = [[TFcourseDownloadController alloc]init];
            [self addChildViewController:self.downLoadController];
            self.downLoadController.view.frame = CGRectMake(self.scrollView.frame.size.width*2, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
            self.downLoadController.view.backgroundColor = [UIColor whiteColor];
            [self.scrollView addSubview:self.downLoadController.view];
            self.downLoadController.delegate = self;
            //UITableView重新设置frame
            self.downLoadController.downlistTableview.frame = CGRectMake(0, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
        } else if (i==3) {
            self.courseDownLoadController = [[TFdocDownloadController alloc]init];
            [self addChildViewController:self.courseDownLoadController];
            self.courseDownLoadController.view.frame = CGRectMake(self.scrollView.frame.size.width*3, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);
            self.courseDownLoadController.view.backgroundColor = [UIColor whiteColor];
            [self.scrollView addSubview:self.courseDownLoadController.view];
            //UITableView重新设置frame
            self.courseDownLoadController.courseDownView.frame = CGRectMake(0, 0, self.scrollView.frame.size.width, self.scrollView.frame.size.height);

        }
    }
}
#pragma mark   获取下载列表的下载个数提示---代理方法
- (void)getDownLoadWithStatus:(TalkfunDownloadStatus)status
{
    [self getDownLoadStatue:status];
}
#pragma mark   获取下载列表的下载个数提示---代理方法
-(void)getDownLoadStatue:(TalkfunDownloadStatus)status
{
    if (status == TalkfunDownloadStatusError ||status ==TalkfunDownloadStatusExpired) {

    } else if (status == TalkfunDownloadStatusStart) {

     self.downTags = self.downTags + 1;
        TFMultifunctionButton * downCoursebtn = self.btnArr[2];
     [downCoursebtn drawRedDotWidthNumber:[NSString stringWithFormat:@"%ld",self.downTags]];

    } else if (status == TalkfunDownloadStatusFinish){

        [self.myCourseController.myCourseTableview reloadData];
  }
}


-(void)hiddenListPartner
{
    self.upOrdownImg.image = [UIImage imageNamed:@"down"];
    self.maskView.hidden = YES;
    self.listPartnerTableView.hidden = YES;
   
}
#pragma --mark  请求列表合作商
-(void)loadData
{
    [self.listPartnerData removeAllObjects];
    NSMutableDictionary * params = [NSMutableDictionary new];
    params[@"action"] = @"listPartner";

    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;
//    NSLog(@"请求列表合作商param==%@",params);
     WeakSelf
    [TalkfunLoginRequest requestForNewLogin:params callback:^(id result) {

         // 回到主线程更新UI
          dispatch_async(dispatch_get_main_queue(), ^{
        if ([result isKindOfClass:[NSDictionary class]]) {
                   if ([result[@"code"] intValue] == 0) {
                       if (result[@"data"]) {
                          NSDictionary * data = result[@"data"];
                           if ([data[@"partners"] isKindOfClass:[NSArray class]]) {
                               NSArray * partners = data[@"partners"];
                               if(partners.count==0)
                               {
                                   return;
                               }
                               
                               [weakSelf.listPartnerData addObjectsFromArray:[TalkfunListPartnerModel mj_objectArrayWithKeyValuesArray:partners]];
                               
                              //已经设置的合作方
                              NSDictionary *designatedPartner = [weakSelf getDesignatedPartner];
                               
                               
                               
                                NSDictionary * dict = partners[0];
                               
                               NSString * name = dict[@"name"];
                               NSString * listKey = dict[@"listKey"];
                               NSString * listSign = dict[@"listSign"];
                               
                               if (designatedPartner.count==0) {
                                   [weakSelf setDesignatedPartner:[NSMutableDictionary dictionaryWithDictionary:dict]];

                                   
                          
                               }else
                               {
                                   
                                name = designatedPartner[@"name"];
                                listKey = designatedPartner[@"listKey"];
                                listSign = designatedPartner[@"listSign"];
                                   
                                   for (int i = 0; i< weakSelf.listPartnerData.count;i++) {
                                       TalkfunListPartnerModel *model2 = weakSelf.listPartnerData[i];
                                 
                                       if ([model2.name isEqualToString:name] && [model2.listKey isEqualToString:listKey]) {
                                           weakSelf.patnerSelect = i;
                                       }
                                   }
                                   
                               }
                               
                               weakSelf.myCourseController.listKey = listKey;
                               weakSelf.allCourseController.listKey = listKey;
                               weakSelf.allCourseController.listSign = listSign;
                               [weakSelf.allCourseController getAllCourseData:weakSelf.allCourseController.listKey listSign:weakSelf.allCourseController.listSign];
                               
                               
                               if (weakSelf.isFirst) {
                                    weakSelf.PartnerNameLab.text = name;
                               }
                            CGRect rect = [TalkfunUtils getRectWithString:name size:CGSizeMake(200, 25) fontSize:18];
                               
                            weakSelf.PartnerNameLab.frame = CGRectMake(([weakSelf getMainScreenBounds].size.width-100-rect.size.width-21)/2.0, 0, rect.size.width, 25);
                               
                               weakSelf.upOrdownImg.frame = CGRectMake(CGRectGetMaxX(weakSelf.PartnerNameLab.frame)+8, 8.5, 13, 8);
                               
                           
                         
                           [weakSelf resetPartnerTableview];
                           [weakSelf.listPartnerTableView reloadData];
                              
                           }
                       }
                       
                   }
               }
                               
        });

       

    }];
}

//拼接检测课程需要的字符串
-(void)coreseListClick:(UIButton *)btn
{
    for (TFMultifunctionButton * chooseBtn in self.btnArr) {
        
         [chooseBtn setTitleColor:[UIColor colorWithRed:116/255.0 green:126/255.0 blue:136/255.0 alpha:1.0] forState:UIControlStateNormal];
        if (chooseBtn==btn) {
            [chooseBtn setTitleColor:[UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0] forState:UIControlStateNormal];
        }
    }


    NSInteger t = btn.tag - 1000;
    [self.scrollView setContentOffset:CGPointMake([self getMainScreenBounds].size.width*t, 0) animated:YES];
     self.reloadTag = t;
    self.lineLab.frame = CGRectMake(([self getMainScreenBounds].size.width/4.0-40)/2.0+t*[self getMainScreenBounds].size.width/4.0, 42, 40, 2);
    if (t==3) {

    } else if (t==2) {
        TFMultifunctionButton * downloadCourseBtn = self.btnArr[2];
        [downloadCourseBtn drawRedDotWidthNumber:@"0"];
        self.downTags = 0;


    } else if (t==1) {

        [self.myCourseController reloadMyCourseData];
    }else if (t==0) {
        
        [self.allCourseController getAllCourseData:self.allCourseController.listKey listSign:self.allCourseController.listSign];
    }

}

-(void)resetPartnerTableview
{
    CGFloat height = self.listPartnerData.count * 44+64+self.SafetyZone>[self getMainScreenBounds].size.height?[self getMainScreenBounds].size.height-64-self.SafetyZone:self.listPartnerData.count * 44;
    self.listPartnerTableView.frame = CGRectMake(0, 64+self.SafetyZone, [self getMainScreenBounds].size.width, height);
    self.maskView.frame = CGRectMake(0, CGRectGetMaxY(self.listPartnerTableView.frame), [self getMainScreenBounds].size.width, kHeight-CGRectGetMaxY(self.listPartnerTableView.frame));
}

-(void)titleBtnClick:(UIButton *)btn
{
    self.isFirst = NO;
    btn.selected = !btn.selected;
    
    if (btn.selected) {
       
        self.upOrdownImg.image = [UIImage imageNamed:@"up"];
        if (self.listPartnerData.count > 0 && self.listPartnerData) {
           self.maskView.hidden = NO;
          } else {
            self.maskView.hidden = YES;
          }
        self.listPartnerTableView.hidden = NO;
        [self loadData];
    } else {
        [self hiddenListPartner];
    }
  
}

#pragma mark -- 删除关联合作商

-(void)deletePartner:(UIButton *)btn
{

    if (btn.tag>=self.listPartnerData.count) {
        return;
    }
    TalkfunListPartnerModel * model = self.listPartnerData[btn.tag];
    NSMutableDictionary * params = [NSMutableDictionary new];
    
    params[@"action"] = @"delUserPid";
    
    NSString * newUid = [[TalkfunUtils UUID] stringByReplacingOccurrencesOfString:@"-" withString:@""];
    //uid用户的唯一标识
    params[@"uid"] = newUid;

    params[@"listKey"] = model.listKey;

    WeakSelf
    [TalkfunLoginRequest requestForNewLogin:params callback:^(id result) {

        if ([result isKindOfClass:[NSDictionary class]]) {
            if ([result[@"code"] intValue] == 0&&weakSelf.listPartnerData.count>btn.tag) {
                [weakSelf.listPartnerData removeObjectAtIndex:btn.tag];
                [weakSelf resetPartnerTableview];
                if (btn.tag <= weakSelf.patnerSelect && weakSelf.patnerSelect > 0) {
                    weakSelf.patnerSelect = weakSelf.patnerSelect-1;
                } else if (btn.tag == 0) {
                    weakSelf.patnerSelect = 0;
                }
                if (weakSelf.listPartnerData.count ==0) {
                    weakSelf.maskView.frame = CGRectMake(0, 0, [self getMainScreenBounds].size.width, 0);
                    weakSelf.PartnerNameLab.text = @"广州欢拓网络科技有限公司";
                    weakSelf.PartnerNameLab.frame = CGRectMake(( weakSelf.titleBtn.frame.size.width-216-21)/2.0,0,216,25);
                    weakSelf.upOrdownImg.frame = CGRectMake(CGRectGetMaxX(weakSelf.PartnerNameLab.frame)+8, 8.5, 13, 8);
                    return;
                }
                TalkfunListPartnerModel * model = weakSelf.listPartnerData[weakSelf.patnerSelect];
                
                //重新指定合作方
                [weakSelf setDesignatedPartner:[weakSelf modelOrDict:model]];
                
                weakSelf.PartnerNameLab.text = model.name;
                CGRect rect = [TalkfunUtils getRectWithString:model.name size:CGSizeMake(200, 25) fontSize:18];
                weakSelf.PartnerNameLab.frame = CGRectMake(([self getMainScreenBounds].size.width-100-rect.size.width-21)/2.0, 0, rect.size.width, 25);
                if (weakSelf.reloadTag == 0) {
                    [weakSelf.allCourseController getAllCourseData:model.listKey listSign:model.listSign];
                } else if (weakSelf.reloadTag == 1) {

                    [weakSelf.myCourseController reloadMyCourseData];
                }
              
                [weakSelf.listPartnerTableView reloadData];
              
        
            } else {
                
                [TalkfunLoginRootViewController TF_progressHUDShow:result[@"msg"]];
               
               
            }
        }
    }];
    
    
}

-(void)addBtnClick
{
    TalkfunSecondNewLoginViewController * vc = [[TalkfunSecondNewLoginViewController alloc]init];
    vc.hidesBottomBarWhenPushed = YES;
    
    [self.navigationController pushViewController:vc animated:YES];
}


-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 44;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
   return self.listPartnerData.count;
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{

        TalkfunListPartnerCell * cell = [tableView dequeueReusableCellWithIdentifier:@"listPartner"];
              if (!cell) {
                  cell = [[TalkfunListPartnerCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"listPartner"];
              }
        if (indexPath.row < self.listPartnerData.count ) {
            TalkfunListPartnerModel * model = self.listPartnerData[indexPath.row];
            cell.partnerLab.text = model.name;
            cell.widths = [self getMainScreenBounds].size.width;
            cell.deleteBtn.tag = indexPath.row;
        }
            
        if (indexPath.row == self.patnerSelect) {
            cell.partnerLab.textColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        } else {
            cell.partnerLab.textColor = [UIColor colorWithRed:89/255.0 green:93/255.0 blue:96/255.0 alpha:1.0];
        }
            [cell.deleteBtn addTarget:self action:@selector(deletePartner:) forControlEvents:UIControlEventTouchUpInside];
            
            
            cell.selectionStyle = UITableViewCellSelectionStyleNone;
              return cell;
    

}

- (UITableViewCellEditingStyle)tableView:(UITableView *)tableView editingStyleForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return UITableViewCellEditingStyleDelete | UITableViewCellEditingStyleInsert;
}
-(NSString*)getNumber:(NSObject*)obj
{
    NSString *UsersXid = @"0";
    
    if([obj isKindOfClass:[NSNumber class] ]){
        
        NSNumber  *num   = (NSNumber*) obj;
        NSNumberFormatter *tempNum = [[NSNumberFormatter alloc] init];
        
        UsersXid = [tempNum stringFromNumber:num];
    }else if([obj isKindOfClass:[NSString class] ]){
        
        NSString  *str    = (NSString*)obj;
        UsersXid = str;
    }
    
    return UsersXid;
}
//指定合作伙伴
- (void)setDesignatedPartner:(NSMutableDictionary*)dict
{
    NSUserDefaults *userDefaults = [NSUserDefaults standardUserDefaults];
    if (dict[@"name"]&&dict[@"pid"]&&dict[@"uid"]&&dict[@"listKey"]&&dict[@"listSign"]) {
        
        NSMutableDictionary *new = [NSMutableDictionary dictionaryWithDictionary:dict];

        [new setObject:[self getNumber:dict[@"pid"]] forKey:@"pid"];

        [userDefaults setObject:new forKey:@"TF_designatedPartner"];
       
    }else
    {
        [userDefaults setObject:[NSDictionary dictionary] forKey:@"TF_designatedPartner"];
    }
    
    [userDefaults synchronize];
    
}

-(NSDictionary*)getDesignatedPartner
{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    NSDictionary *dict = [defaults objectForKey:@"TF_designatedPartner"];
    [defaults synchronize];
    if (dict&&dict.count>0) {
        return dict;
    }else{
        return [NSDictionary dictionary];
    }
}

- (NSMutableDictionary*)modelOrDict:(TalkfunListPartnerModel*)model
{
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    
    [dict setObject:model.name?model.name:@"" forKey:@"name"];
    [dict setObject:model.pid?model.pid:@"" forKey:@"pid"];
    [dict setObject:model.uid?model.uid:@"" forKey:@"uid"];
    [dict setObject:model.listKey?model.listKey:@"" forKey:@"listKey"];
    [dict setObject:model.listSign?model.listSign:@"" forKey:@"listSign"];
    
    return dict;
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    
        if (indexPath.row < self.listPartnerData.count) {
            TalkfunListPartnerModel * model = self.listPartnerData[indexPath.row];
            
            [self setDesignatedPartner:[self modelOrDict:model]];
            
            
            self.PartnerNameLab.text = model.name;

            self.patnerSelect = indexPath.row;
            
            self.allCourseController.listKey  = model.listKey;
            self.allCourseController.listSign = model.listSign;
            self.myCourseController.listKey = model.listKey;
            if (self.reloadTag == 1) {
              
                [self.myCourseController reloadMyCourseData];
               
            } else if (self.reloadTag == 0) {

                [self.allCourseController getAllCourseData:model.listKey listSign:model.listSign];
            }
            
           
            CGRect rect = [TalkfunUtils getRectWithString:model.name size:CGSizeMake(300, 25) fontSize:18];
            self.PartnerNameLab.frame = CGRectMake(([self getMainScreenBounds].size.width-100-rect.size.width-21)/2.0, 0, rect.size.width+5, 25);
            self.upOrdownImg.frame = CGRectMake(CGRectGetMaxX(self.PartnerNameLab.frame)+8, 8.5, 13, 8);
            [self hiddenListPartner];
            self.titleBtn.selected = !self.titleBtn.selected;
            [self.listPartnerTableView reloadData];
        }

        
    
}



- (UIStatusBarStyle)preferredStatusBarStyle{
    return UIStatusBarStyleLightContent;//白色
}

-(void)removefromBgdBtn:(UIButton *)btn
{
    [btn removeFromSuperview];
}


//是否可以编辑  默认YES
-(BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath{
    return NO;
}


- (void)scrollViewDidScroll:(UIScrollView *)scrollView{

    if (scrollView == self.scrollView) {
           int a = self.scrollView.contentOffset.x/self.scrollView.frame.size.width;

              self.lineLab.frame = CGRectMake(([self getMainScreenBounds].size.width/4.0-40)/2.0+a*[self getMainScreenBounds].size.width/4.0, 42, 40, 2);
               for (TFMultifunctionButton * btn in self.btnArr) {
                   if(a<self.btnArr.count)
                   {
                [btn setTitleColor:[UIColor colorWithRed:116/255.0 green:126/255.0 blue:136/255.0 alpha:1.0] forState:UIControlStateNormal];
        
                   UIButton * chooseBtn = [self.btnArr objectAtIndex:a];
                  [chooseBtn setTitleColor:[UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0] forState:UIControlStateNormal];


                   }
               }

           }
}

-(void)scrollViewDidEndDecelerating:(UIScrollView *)scrollView
{
    if (scrollView == self.scrollView) {
        CGFloat a = self.scrollView.contentOffset.x/self.scrollView.frame.size.width;
        self.reloadTag = a;
        if (a==3) {

        } else if (a==2) {
            TFMultifunctionButton *downloadCourseBtn = self.btnArr[2];
              [downloadCourseBtn drawRedDotWidthNumber:@"0"];
              self.downTags = 0;

        } else if (a==1) {

            [self.myCourseController reloadMyCourseData];
        }else if (a==0){
                [self.allCourseController getAllCourseData:self.allCourseController.listKey listSign:self.allCourseController.listSign];
            
            
        }
        
       
    }
}
-(NSMutableArray *)btnArr
{
    if (!_btnArr) {
        _btnArr = [NSMutableArray array];
    }
    return _btnArr;
}

-(UILabel *)lineLab
{
    if (!_lineLab) {
        _lineLab = [[UILabel alloc]init];
        _lineLab.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        _lineLab.alpha = 1.0;
        _lineLab.textAlignment = NSTextAlignmentCenter;
    }
    return _lineLab;
}





-(UITableView *)listPartnerTableView
{
    if (!_listPartnerTableView) {
        _listPartnerTableView = [[UITableView alloc]initWithFrame:CGRectZero style:UITableViewStylePlain];
        _listPartnerTableView.delegate = self;
        _listPartnerTableView.dataSource = self;
        _listPartnerTableView.tag = 44;
        _listPartnerTableView.backgroundColor = [UIColor whiteColor];
        _listPartnerTableView.hidden = YES;
        if (@available(iOS 11.0, *)) {
            
            _listPartnerTableView.contentInsetAdjustmentBehavior = UIScrollViewContentInsetAdjustmentNever;
        }
        [self.view addSubview:_listPartnerTableView];
    }
    return _listPartnerTableView;
}

-(NSMutableArray *)listPartnerData
{
    if (!_listPartnerData) {
        _listPartnerData = [NSMutableArray array];
    }
    return _listPartnerData;
}

#pragma mark - 拿本地存储的数据
- (id)getNSUserDefaultWithKey:(NSString *)key{
    
    id obj = [[NSUserDefaults standardUserDefaults] objectForKey:key];
    return obj;
}
#pragma mark - 旋转
- (BOOL)shouldAutorotate{
   [[UIDevice currentDevice] setValue:@(UIDeviceOrientationPortrait) forKey:@"orientation"];
    return YES;
}
-(UIInterfaceOrientationMask)supportedInterfaceOrientations
{
   
    return UIInterfaceOrientationMaskPortrait;
}

- (void)dealloc
{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    
    printf("_____________downloadList_____________");
}

@end
