
//  Created by 莫瑞权 on 2021/11/9.
//  Copyright © 2021 Talkfun. All rights reserved.
//

#import "TFBehaviorController.h"
#import "TalkfunSettingsCell.h"
#import "UITextView+tf_Placeholder.h"
#import "TalkfunLoginRootViewController.h"
#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0
@interface TFBehaviorController ()<UITableViewDelegate,UITableViewDataSource,UITextViewDelegate>
@property(nonatomic,strong)NSArray *dataSource;
@property(nonatomic,strong)UITableView *tableView;
@property(nonatomic,strong)UIView *alertCView ;
@property(nonatomic,strong)UIButton *backgroundBtn;
@property(nonatomic,strong)UITextView *textView ;
@property(nonatomic,assign)NSInteger row;
@end

@implementation TFBehaviorController
/*
 监听键盘的即将显示
 */
- (void)keyBoardDidShow:(NSNotification *)notification
{
    

    NSDictionary * keyboardInfo = [notification userInfo];
    NSValue * keyboardFrameEnd  = [keyboardInfo valueForKey:UIKeyboardFrameEndUserInfoKey];
    
    CGRect frame = [keyboardFrameEnd CGRectValue];
    CGFloat duration = [notification.userInfo[UIKeyboardAnimationDurationUserInfoKey] doubleValue];
    
    if (CGRectGetMaxY(self.alertCView.frame) >frame.origin.y) {
        [UIView animateWithDuration:duration animations:^{
            CGFloat alertCViewW = self.alertCView.frame.size.width;
            CGFloat alertCViewH = self.alertCView.frame.size.height;
            CGFloat alertCViewX = ([UIScreen mainScreen].bounds.size.width - alertCViewW)/2 ;
            CGFloat alertCViewY = frame.origin.y - alertCViewH -20;
            self.alertCView.frame = CGRectMake(alertCViewX, alertCViewY, alertCViewW, alertCViewH);
               
           }];
    }

    
}
/**
 *  监听键盘的即将隐藏
 */
- (void)keyBoardDidHide:(NSNotification *)notification
{
   

    CGFloat duration = [notification.userInfo[UIKeyboardAnimationDurationUserInfoKey] doubleValue];
    
    CGFloat alertCViewW = self.alertCView.frame.size.width;
    CGFloat alertCViewH = self.alertCView.frame.size.height;
    CGFloat alertCViewX = self.alertCView.frame.origin.x ;
    CGFloat alertCViewY = ([UIScreen mainScreen].bounds.size.height - alertCViewH)/2;
    if (self.alertCView.frame.origin.y != alertCViewY) {
        [UIView animateWithDuration:duration animations:^{

            self.alertCView.frame = CGRectMake(alertCViewX, alertCViewY, alertCViewW, alertCViewH);
               
           }];
    }
    

        
//    }
}
- (void)viewDidLoad {
    [super viewDidLoad];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardDidShow:) name:UIKeyboardWillShowNotification object:nil];//键盘显示前


    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardDidHide:) name:UIKeyboardWillHideNotification object:nil];//键盘隐藏前
    CGFloat SafetyZone = 0;
    if (KIsiPhoneX) {
           SafetyZone = 32;
    }
    UIView *backgroundView = [[UIView alloc]init];
    backgroundView.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 64 +SafetyZone);
    backgroundView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
  
    [self.view addSubview:backgroundView];
    


    TalkfunIncreaseButton * backBtn = [TalkfunIncreaseButton buttonWithType:UIButtonTypeCustom];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
    [backBtn addTarget:self action:@selector(backBtnClick) forControlEvents:UIControlEventTouchUpInside];
    backBtn.frame = CGRectMake(0, 22+SafetyZone, 40, 40);
    [backgroundView addSubview:backBtn];
    
    UILabel *title = [[UILabel alloc]init];
    title.textAlignment = NSTextAlignmentCenter;
    CGFloat titleH = 25;
    title.frame = CGRectMake(0,backBtn.frame.origin.y+((backBtn.frame.size.height -titleH)/2), [UIScreen mainScreen].bounds.size.width, titleH);
    title.text = @"帮助与反馈";
    title.font = [UIFont systemFontOfSize:18];
    title.textColor = [UIColor whiteColor];
    [self.view addSubview:title];
    self.dataSource = [TalkfunBehaviorManager getFileList];
    
    UITableView *tableView = [[UITableView alloc]init];
    self.tableView = tableView;
    tableView.delegate = self;
    tableView.dataSource= self;
    //不要分割线  去线
    tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    tableView.separatorInset = UIEdgeInsetsZero;
    tableView.frame = CGRectMake(0, CGRectGetMaxY(backBtn.frame), [UIScreen mainScreen].bounds.size.width, [UIScreen mainScreen].bounds.size.height -(CGRectGetMaxY(backBtn.frame)));
    [self.view addSubview:tableView];

}
-(void)backBtnClick
{
    [self.navigationController popViewControllerAnimated:YES];
}

/**
*  告诉tableView第section组有多少行
*/
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
 return self.dataSource.count;
}
/**
* 告诉tableView每一行显示什么内容（tableView的每一行都是UITableViewCell）
*/
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    
    TFBehaviorData *model = self.dataSource[indexPath.row];

    TalkfunSettingsCell *cell = [tableView dequeueReusableCellWithIdentifier:@"TalkfunSettingsCell"];
  
    if (cell == nil) {
        cell = [[TalkfunSettingsCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"TalkfunSettingsCell"];
       
    }

    cell.arrowImageView.image = [UIImage imageNamed:@"CloudUpload"];
    cell.width = self.view.frame.size.width;
    cell.accessoryType = UITableViewCellAccessoryNone;

    cell.textLabel.text = model.date;
    cell.textLabel.textColor = [UIColor colorWithRed:129/255.0 green:133/255.0 blue:136/255.0 alpha:1.0];
    cell.backgroundColor = [UIColor whiteColor];
   return cell;
}

/*  返回每个cell的高度
*/
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    return 60;
}

- (void)backgroundBtnClick
{
    [self.view endEditing:YES];
}
/*
*  当选中一行的时候调用（点击）
 */
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];// 取消选中
    
    self.row = indexPath.row;
    if (self.backgroundBtn == nil) {
        self.backgroundBtn = [[UIButton alloc]init];
        self.backgroundBtn.frame = self.view.bounds;
        self.backgroundBtn.backgroundColor = [UIColor colorWithRed:15/255.0 green:25/255.0 blue:25/255.0 alpha:0.5];
        [self.view addSubview:self.backgroundBtn];
        [self.backgroundBtn addTarget:self action:@selector(backgroundBtnClick) forControlEvents:UIControlEventTouchUpInside];
        
    }else{
        self.backgroundBtn.hidden = NO;
    }
     
    
    
    if (self.alertCView == nil) {
        self.alertCView = [[UIView alloc]init];
        CGFloat alertCViewW = 270;
        CGFloat alertCViewH = 250;
        CGFloat alertCViewX = (self.view.frame.size.width - alertCViewW)/2 ;
        CGFloat alertCViewY = (self.view.frame.size.height - alertCViewH)/2 ;
        self.alertCView.frame = CGRectMake(alertCViewX, alertCViewY, alertCViewW, alertCViewH);
        // 圆角半径  能把一个下正文体,改成圆形
        self.alertCView.layer.cornerRadius = 10;
        self.alertCView.backgroundColor = [UIColor whiteColor];
        [self.view addSubview:self.alertCView];
        
        
        
        CGFloat titleW =  self.alertCView.frame.size.width;
        CGFloat titleH = 30;
        CGFloat titleX = 0 ;
        CGFloat titleY = 20;
        
        UILabel *title = [[UILabel alloc]init];
        title.textAlignment = NSTextAlignmentCenter;
        title.textColor = [UIColor blackColor];
        title.font = [UIFont systemFontOfSize:16];
        title.frame = CGRectMake(titleX, titleY, titleW, titleH);
        title.text = @"是否上传本地日志?";
        [self.alertCView addSubview:title];
        
        
        CGFloat textViewW = self.alertCView.frame.size.width -40;
        CGFloat textViewX = 20 ;
        CGFloat textViewY = CGRectGetMaxY(title.frame)+10;
        CGFloat textViewH = 100;
        UITextView *textView = [[UITextView alloc]init];
        self.textView = textView;
        self.textView.text = @"";
        textView.layer.cornerRadius = 5;
        textView.backgroundColor = [UIColor colorWithRed:15/255.0 green:25/255.0 blue:25/255.0 alpha:0.1];
        textView.frame = CGRectMake(textViewX, textViewY, textViewW, textViewH);
        [self.alertCView addSubview:textView];
        textView.tf_placeholder = @"请填写您的反馈信息";
    
        //竖线
        CGFloat verticalW = 1;
        CGFloat verticalH = 50;
        CGFloat verticalX = (self.alertCView.frame.size.width - verticalW )/2 ;
        CGFloat verticalY = self.alertCView.frame.size.height - verticalH ;
        UIView *vertical = [[UIView alloc]init];
        vertical.frame = CGRectMake(verticalX, verticalY, verticalW, verticalH);
        vertical.backgroundColor =  [UIColor colorWithRed:229/255.0 green:229/255.0 blue:229/255.0 alpha:1.0];
        [self.alertCView addSubview:vertical];
        
        //横线
        CGFloat horizontalLineW = self.alertCView.frame.size.width;
        CGFloat horizontalLineH = 1;
        CGFloat horizontalLineX = 0 ;
        CGFloat horizontalLineY = verticalY - horizontalLineH;
        UIView *horizontalLine = [[UIView alloc]init];
        horizontalLine.frame = CGRectMake(horizontalLineX, horizontalLineY, horizontalLineW, horizontalLineH);
        horizontalLine.backgroundColor =  [UIColor colorWithRed:229/255.0 green:229/255.0 blue:229/255.0 alpha:1.0];
        [self.alertCView addSubview:horizontalLine];
        
        //取消
        CGFloat cancelW = self.alertCView.frame.size.width /2;
        CGFloat cancelH = verticalH;
        CGFloat cancelX = 0 ;
        CGFloat cancelY = self.alertCView.frame.size.height - cancelH;
        UIButton *cancel = [[UIButton alloc]init];
        cancel.frame = CGRectMake(cancelX, cancelY, cancelW, cancelH);
        cancel.backgroundColor =  [UIColor clearColor];
        [cancel setTitle:@"取消" forState:UIControlStateNormal];
        [cancel setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];
        [self.alertCView addSubview:cancel];
        [cancel addTarget:self action:@selector(cancelClick) forControlEvents:UIControlEventTouchUpInside];
        //确认
        CGFloat confirmW = cancelW;
        CGFloat confirmH = verticalH;
        CGFloat confirmX = confirmW ;
        CGFloat confirmY = cancelY;
        UIButton *confirm = [[UIButton alloc]init];
        [confirm setTitle:@"确认" forState:UIControlStateNormal];
        [confirm setTitleColor:[UIColor blackColor] forState:UIControlStateNormal];
        confirm.frame = CGRectMake(confirmX, confirmY, confirmW, confirmH);
        confirm.backgroundColor = [UIColor clearColor];
        [self.alertCView addSubview:confirm];
        [confirm addTarget:self action:@selector(confirmClick) forControlEvents:UIControlEventTouchUpInside];
        

    }else{
        self.alertCView.hidden = NO;
    }

}
- (void)cancelClick
{
    self.backgroundBtn.hidden = YES;
    self.alertCView.hidden = YES;
    self.textView.text = @"";
    [self.view endEditing:YES];
}
//确认
- (void)confirmClick
{
     WeakSelf
    TFBehaviorData *model = self.dataSource[self.row];
    
    [TalkfunBehaviorManager feedbackContent:self.textView.text?self.textView.text:@"" path:model.path callback:^(NSInteger code, NSString * _Nullable msg) {

        if (code ==0 ) {
            weakSelf.dataSource = [TalkfunBehaviorManager getFileList];
            [weakSelf.tableView reloadData];
            
        }else{
            
        }
        [weakSelf cancelClick];
  
        [TalkfunLoginRootViewController TF_progressHUDShow:msg];
       
    }];
    
}
- (void)watchTextFieldMethod:(UITextField*)textfield
{
    
    NSLog(@"输入的内容====>%@",textfield.text);
}

// 控制器的view完全消失的时候调用
- (void)viewDidDisappear:(BOOL)animated
{
    [super viewDidDisappear:animated];
        NSLog(@"%s",__func__);
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
/**
 *  只要实现了这个方法，左滑出现Delete按钮的功能就有了
 *  点击了“左滑出现的Delete按钮”会调用这个方法
 */
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    
    TFBehaviorData *model = self.dataSource[indexPath.row];
    
   BOOL remove = [[NSFileManager defaultManager] removeItemAtPath:model.path error:nil];
    if (remove) {
        self.dataSource = [TalkfunBehaviorManager getFileList];
        [self.tableView reloadData];
    }
  
}
- (UIStatusBarStyle)preferredStatusBarStyle{
    return UIStatusBarStyleLightContent;//白色
}
- (void)dealloc
{
    
    NSLog(@"正常退出行为日志界面");
}
@end
