//
//  TalkfunCourseManager.m
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2020/8/3.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunCourseManager.h"
#import "FMDatabase.h"

@interface TalkfunCourseManager()

@property (nonatomic, strong)FMDatabase * fmDatabase;
@end

@implementation TalkfunCourseManager

static TalkfunCourseManager *manager = nil;
static dispatch_once_t predicate;

// 单例创建数据库管理类
+ (id)shareManager {
    dispatch_once(&predicate, ^{
        if (manager == nil) {
            manager = [[self alloc] init];
        }
    });
    
    return manager;
}
- (FMDatabase*)fmDatabase
{
    
    if (_fmDatabase == nil) {
        NSString *path = [NSHomeDirectory() stringByAppendingString:@"/Documents/MyCourseList5.db"];

        _fmDatabase = [[FMDatabase alloc] initWithPath:path];
    }
    
    return _fmDatabase;
}
- (void)createTable {

        BOOL isOpen = [self.fmDatabase open];
        if (isOpen) {
//            NSLog(@"数据库打开成功!");
        } else {
            NSLog(@"数据库打开失败!");
        }

       NSString *createTable = @"create table if not exists MyNote(ID  integer primary key autoincrement ,IDs text ,nickname text ,start_time text,type text,status text,title text,roomID text,account text,password text,listKey text,access_token text)";
        if ([self.fmDatabase executeUpdate:createTable]) {
//            NSLog(@"表创建成功!");
//            [fmDatabase close];
        } else {
            NSLog(@"表创建失败!");
        }
}
/**
   添加模型
 */
- (void)addCourseModel:(TalkfunMyCourseModel *)note {
    BOOL isOpen = [self.fmDatabase open];
    if (isOpen) {
//        NSLog(@"数据库打开成功!");
    } else {
        NSLog(@"数据库打开失败!");
    }

    NSString *sql = @"insert into MyNote(IDs,nickname,start_time,type,status,title,roomID,account,password,listKey,access_token) values(?,?,?,?,?,?,?,?,?,?,?)";
       NSString * IDs = note.IDs;

       NSString * nickname = note.nickname;
       NSString * start_time = note.start_time;
       NSString * type = note.type;
       NSString * status = note.status;
       NSString * title = note.title;
       NSString * roomid = note.roomID;
       NSString * account = note.account;
       NSString * password = note.password;
       NSString * listKey = note.listKey;
       NSString * access_token = note.access_token;
    if ([self.fmDatabase executeUpdate:sql, IDs, nickname, start_time, type, status, title,roomid,account,password,listKey,access_token]) {
        NSLog(@"数据插入成功!");
//        [fmDatabase close];
    } else {
        NSLog(@"数据插入失败!");
    }
}

/**
   更新模型
 */
- (void)updateCourseModel:(TalkfunMyCourseModel *)note {
    BOOL isOpen = [self.fmDatabase open];
    if (isOpen) {
//        NSLog(@"数据库跟新成功!");
    } else {
        NSLog(@"数据库跟新失败!");
    }
    @synchronized (self) {
        NSString *sql = [NSString stringWithFormat:@"update MyNote set IDs = '%@', nickname = '%@', start_time = '%@', type = '%@', status = '%@', title = '%@', roomID = '%@', account = '%@', password = '%@', listKey = '%@', access_token = '%@' where ID = '%zi'",note.IDs,  note.nickname, note.start_time, note.type, note.status, note.title, note.roomID, note.account, note.password, note.listKey, note.access_token, note.ID];
        if ([self.fmDatabase executeUpdate:sql]) {
            
            NSLog(@"数据更新成功!");
            
//            [fmDatabase close];
        } else {
            NSLog(@"数据更新失败!");
        }
    }
    
  
}
//读取数据库模型列表
- (NSArray *)selectCourseList {
    
    
        BOOL isOpen = [self.fmDatabase open];
        if (isOpen) {
    //        NSLog(@"数据库打开成功!");
        } else {
            NSLog(@"数据库打开失败!");
        }
    
        NSString *sql = @"select * from MyNote order by ID desc";
    FMResultSet *set = [self.fmDatabase executeQuery:sql];
        NSMutableArray *array = [[NSMutableArray alloc] init];
      @synchronized (self) {
        while ([set next]) {
            TalkfunMyCourseModel *model = [[TalkfunMyCourseModel alloc] init];
            model.IDs = [set stringForColumn:@"IDs"];
            model.nickname = [set stringForColumn:@"nickname"];
            model.start_time = [set stringForColumn:@"start_time"];
            model.type = [set stringForColumn:@"type"];
            model.status = [set stringForColumn:@"status"];
            model.title = [set stringForColumn:@"title"];
            model.roomID =  [set stringForColumn:@"roomID"];
            model.account = [set stringForColumn:@"account"];
            model.password = [set stringForColumn:@"password"];
            model.listKey = [set stringForColumn:@"listKey"];
            model.access_token = [set stringForColumn:@"access_token"];
            model.ID = [set intForColumn:@"ID"];
//            NSLog(@"数据查询==%@",model.password);
            [array addObject:model];
        }
        
//        [fmDatabase close];
    }
  

    return array;
}

- (void)deleteCourseModel:(TalkfunMyCourseModel *)note {
    BOOL isOpen = [self.fmDatabase open];
    if (isOpen) {
//        NSLog(@"数据库打开成功12!");
    } else {
        NSLog(@"数据库打开失败!");
    }
    
    NSString *sql = [NSString stringWithFormat:@"delete from MyNote where ID = '%zi'", note.ID];
    if ([self.fmDatabase executeUpdate:sql]) {
//         NSLog(@"数据删成功!");
//        [fmDatabase close];
    } else {
        NSLog(@"数据删除失败!");
    }
}


@end
