//
//  TalkfunLoginRequest.m
//  TalkfunSDKDemo
//
//  Created by Sunzn on 2017/4/22.
//  Copyright © 2017年 Talkfun. All rights reserved.
//

#import "TalkfunLoginRequest.h"
#include "AFNetworking.h"
@implementation TalkfunLoginRequest

+ (void)requestForNewLogin:(NSDictionary *)params callback:(void (^)(id result))callback{
    [self post:@"https://open.talk-fun.com/live/mobile/login_v2.php" params:params callback:^(id result) {
        PERFORM_IN_MAIN_QUEUE(
                              if (callback) {
                                  callback(result);
                              }
                        )
    }];
}

+ (void)requestForScanIn:(NSDictionary *)params callback:(void (^)(id result))callback{
    [self post:@"https://open.talk-fun.com/live/mobile/scanQrcodeV2.php" params:params callback:^(id result) {
        PERFORM_IN_MAIN_QUEUE(
                              if (callback) {
                                  callback(result);
                              }
                              )
    }];
}



+ (void)tempLoginRequestForScanIn:(NSDictionary *)params callback:(void (^)(id result))callback{
    [self post:@"https://open.talk-fun.com/live/mobile/tempLogin.php" params:params callback:^(id result) {
        PERFORM_IN_MAIN_QUEUE(
                              if (callback) {
                                  callback(result);
                              }
                              )
    }];
}
+ (void)getPlaybackType:(NSString *)access_token callback:(void (^)(id result))callback{
    if (access_token) {
        [self post:@"https://open.talk-fun.com/live/playbackData.php?action=videoType" params:@{@"access_token":access_token} callback:^(id result) {
            PERFORM_IN_MAIN_QUEUE(
                                  if (callback) {
                                      callback(result);
                                  }
                                  )
        }];
    }
   
}

+ (void)post:(NSString *)url params:(NSDictionary *)params callback:(void (^)(id result))callback

{
    AFHTTPSessionManager *manager = [AFHTTPSessionManager manager];

    [manager POST:url parameters:params headers:nil progress:^(NSProgress * _Nonnull uploadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
    
       
        if (callback &&[responseObject isKindOfClass:[NSDictionary class]]) {
            callback(responseObject);
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (error) {
            
            if (callback) {
                NSString *msg =  error.userInfo[NSLocalizedDescriptionKey];
                callback(@{@"msg":msg,
                           @"code":[NSString stringWithFormat:@"%li",(long)error.code]
                         });
            }
            
           
        }
        
       
    }];
}
@end
