
#import "TalkfunPasswordAlertView.h"
#define RememberNickID @"rememberNickID1"
#define RememberID @"rememberID"
#define AlertW 300
//#define AlertH  230
@interface TalkfunPasswordAlertView()<UITextFieldDelegate>

@property(nonatomic,strong)UIView * alertView;

@property(nonatomic,strong)UILabel * titleLab;

@property(nonatomic,strong)UIView * passwordView; // 设置密码

@property(nonatomic,strong)UIView * nickNameView; // 设置昵称

@property(nonatomic,strong)UIImageView * passwordImg;

@property(nonatomic,strong)UIImageView * nickNameImg;

@property(nonatomic,strong)UIButton * cancelBtn;

@property(nonatomic,strong)UIButton * sureBtn;


@end

@implementation TalkfunPasswordAlertView

-(instancetype)initWithTitle:(NSString *)title message:(NSString *)message sureBtn:(NSString *)sureTitle cancleBtn:(NSString *)cancleTitle
{
    if (self = [super init]) {
        self.frame = [TalkfunUtils getMainScreen];
        self.backgroundColor = [UIColor colorWithRed:0/255.0 green:0/255.0 blue:0/255.0 alpha:0.6];
        self.alertView = [[UIView alloc]init];
        self.alertView.frame = CGRectMake(0, 0, AlertW, 230);
        self.alertView.backgroundColor = [UIColor whiteColor];
        self.alertView.alpha = 1.0;
        self.alertView.layer.mask = [self passcgrect:self.alertView.bounds andradio:CGSizeMake(7.0, 7.0)];
        
        self.alertView.layer.position = self.center;
        
        
        if (title.length > 0) {
            self.titleLab = [[UILabel alloc]init];
            self.titleLab.frame = CGRectMake((AlertW-100)/2, 22, 100, 24);
            self.titleLab.textAlignment = NSTextAlignmentCenter;
            self.titleLab.font = [UIFont fontWithName:@"PingFang SC" size:17];
            self.titleLab.textColor = [UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0];
            self.titleLab.text = title;
            [self.alertView addSubview:self.titleLab];
        }
        if (message.length > 0) {
            self.passwordView = [[UIView alloc]init];
            self.passwordView.frame = CGRectMake(20, 22, AlertW-40, 44);
            self.passwordView.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
            self.passwordView.layer.borderWidth = 1.0;
            self.passwordView.layer.cornerRadius = 22.5;
            [self.alertView addSubview:self.passwordView];
           
            self.passwordImg = [[UIImageView alloc]init];
            self.passwordImg.frame = CGRectMake(22, 11, 22, 22);
            self.passwordImg.image = [UIImage imageNamed:@"password"];
            [self.passwordView addSubview:self.passwordImg];
           
           
            self.nickNameView = [[UIView alloc]init];
            self.nickNameView.frame = CGRectMake(20, CGRectGetMaxY(self.passwordView.frame)+20, AlertW-40, 44);
            self.nickNameView.layer.borderColor = [UIColor colorWithRed:216/255.0 green:220/255.0 blue:223/255.0 alpha:1.0].CGColor;
            self.nickNameView.layer.borderWidth = 1.0;
            self.nickNameView.layer.cornerRadius = 22.5;
            [self.alertView addSubview:self.nickNameView];
           
            self.nickNameImg = [[UIImageView alloc]init];
            self.nickNameImg.frame = CGRectMake(22, 11, 22, 22);
            self.nickNameImg.image = [UIImage imageNamed:@"昵称"];
            [self.nickNameView addSubview:self.nickNameImg];
            self.msgfield = [[UITextField alloc]init];
            self.msgfield.frame = CGRectMake(CGRectGetMaxX(self.passwordImg.frame)+10, 7, CGRectGetWidth(self.passwordView.frame)-44-13, 30);

            self.msgfield.delegate = self;
            self.msgfield.clearButtonMode = UITextFieldViewModeAlways;
            self.msgfield.secureTextEntry = YES;
            self.msgfield.placeholder = @"请输入密码";
            self.msgfield.keyboardType = UIKeyboardTypeDefault;
            self.msgfield.textColor = [UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0];
            self.msgfield.autocorrectionType = UITextAutocorrectionTypeNo;

             [self.passwordView addSubview:self.msgfield];
            
            self.NickNamefield = [[UITextField alloc]init];
            self.NickNamefield.placeholder = @"请输入昵称";
            self.NickNamefield.frame = CGRectMake(CGRectGetMaxX(self.passwordImg.frame)+10, 7, CGRectGetWidth(self.passwordView.frame)-44-13, 30);
            self.NickNamefield.delegate = self;
            self.NickNamefield.clearButtonMode = UITextFieldViewModeAlways;
            self.NickNamefield.secureTextEntry = NO;
            self.NickNamefield.keyboardType = UIKeyboardTypeDefault;
            self.NickNamefield.textColor = [UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0];
            self.NickNamefield.autocorrectionType = UITextAutocorrectionTypeNo;
            NSDictionary * nickIDStr = [self getNSUserDefaultWithKey:RememberNickID];
            NSString * remberID = [self getNSUserDefaultWithKey:RememberID];
            if (nickIDStr && ![nickIDStr isKindOfClass:[NSNull class]]) {
                   if (remberID.length > 0) {
                       self.NickNamefield.text = nickIDStr[remberID];

                   }
               }
   
            [self.nickNameView addSubview:self.NickNamefield];
            
            
            self.nosureLab = [[UILabel alloc]init];
            self.nosureLab.text = @"密码错误";
            self.nosureLab.frame = CGRectMake((AlertW-80)/2, CGRectGetMaxY(self.nickNameView.frame)+3, 80, 20);
            self.nosureLab.textColor = [UIColor colorWithRed:255/255.0 green:59/255.0 blue:59/255.0 alpha:1.0];
            self.nosureLab.hidden = YES;
            self.nosureLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
            [self.alertView addSubview:self.nosureLab];
            
        } else {
              self.titleLab.frame = CGRectMake((AlertW-160)/2, 61, 160, 24);
              self.alertView.frame = CGRectMake(0, 0, AlertW, 200);
        }
        
        if (cancleTitle.length > 0) {
            self.cancelBtn = [UIButton buttonWithType:UIButtonTypeCustom];
            self.cancelBtn.frame = CGRectMake(30, 173, 110, 44);
            [self.cancelBtn setTitle:cancleTitle forState:UIControlStateNormal];
            [self.cancelBtn setTitleColor:[UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0] forState:UIControlStateNormal];
            self.cancelBtn.layer.borderWidth = 1.0;
            self.cancelBtn.tag = 1;
            [self.cancelBtn addTarget:self action:@selector(btnClcik:) forControlEvents:UIControlEventTouchUpInside];
            self.cancelBtn.layer.borderColor =  [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
//            self.cancelBtn.layer.mask = [self passcgrect:self.cancelBtn.bounds andradio:CGSizeMake(6.0, 6.0)];
            self.cancelBtn.layer.cornerRadius = 6.0;
            [self.alertView addSubview:self.cancelBtn];
        }
        
        if (sureTitle.length > 0) {
            self.sureBtn = [UIButton buttonWithType:UIButtonTypeCustom];
            self.sureBtn.frame = CGRectMake(CGRectGetMaxX(self.cancelBtn.frame)+20, 173, 110, 44);
            [self.sureBtn setTitle:sureTitle forState:UIControlStateNormal];
            [self.sureBtn setTitleColor:[UIColor colorWithRed:255/255.0 green:255/255.0 blue:255/255.0 alpha:1.0] forState:UIControlStateNormal];
            self.sureBtn.tag = 2;
            [self.sureBtn addTarget:self action:@selector(btnClcik:) forControlEvents:UIControlEventTouchUpInside];
            [self.sureBtn setBackgroundColor:[UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0]];
            self.sureBtn.layer.borderColor =  [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
            self.sureBtn.layer.mask = [self passcgrect:self.sureBtn.bounds andradio:CGSizeMake(6.0, 6.0)];
            [self.alertView addSubview:self.sureBtn];
        }
        
        if (sureTitle.length > 0 && cancleTitle.length == 0) {
            self.titleLab.frame = CGRectMake(35, 52, AlertW-70, 48);
            self.titleLab.numberOfLines = 2;
            self.sureBtn.frame = CGRectMake((AlertW-110)/2, 200-25-44, 110, 44);
        }
        
        if (sureTitle.length > 0 && cancleTitle.length > 0 && message.length == 0) {
            self.sureBtn.frame = CGRectMake(CGRectGetMaxX(self.cancelBtn.frame)+20, 200-44-20, 110, 44);
             self.cancelBtn.frame = CGRectMake(30, 200-44-20, 110, 44);
        }
        
       [self addSubview:self.alertView];
       [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardDidShow:) name:UIKeyboardWillShowNotification object:nil];
       [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyBoardDidHide:) name:UIKeyboardWillHideNotification object:nil];
       
    }
    
    return self;
}

-(CAShapeLayer *)passcgrect:(CGRect)rect andradio:(CGSize)size
{
    UIBezierPath * bezierPath = [UIBezierPath bezierPathWithRoundedRect:rect byRoundingCorners:UIRectCornerTopLeft|UIRectCornerBottomLeft|UIRectCornerTopRight|UIRectCornerBottomRight  cornerRadii:size];
        CAShapeLayer * shaper = [[CAShapeLayer alloc]init];
        shaper.frame = rect;
        shaper.path = bezierPath.CGPath;
    return shaper;
}

-(void)btnClcik:(UIButton *)btn
{
    
    if (btn.tag == 2) {
       
        if (self.resultIndex) {
            self.resultIndex(self.msgfield.text, self.NickNamefield.text);
        }
        
        
        if ([self.delegate respondsToSelector:@selector(Index:nickStr:)]) {
             [self.delegate Index:self.msgfield.text nickStr:self.NickNamefield.text];
            [self removeFromSuperview];
         }
    } else {
        [self removeFromSuperview];
    }
    
}

-(void)textFieldDidEndEditing:(UITextField *)textField
{
   NSLog(@"texg:%@",textField.text);
    
}

#pragma mark - 监听键盘
- (void)keyBoardDidShow:(NSNotification *)notification
{
  
    [UIView animateWithDuration:0.1 animations:^{
        
        NSArray * subViews = self.subviews;
        for (UIView * subView in subViews) {

            subView.transform = CGAffineTransformMakeTranslation(0, - 45);
            if (subView.tag == 10) {
                subView.transform = CGAffineTransformMakeTranslation(0, 0);
            }
        }
 
        CGRect frame = self.alertView.frame;
        frame.origin.y = self.center.y-150;
        self.alertView.frame = frame;
    }];
    
}

- (void)keyBoardDidHide:(NSNotification *)notification
{
    
    
    [UIView animateWithDuration:0.1 animations:^{
        
        NSArray * subViews = self.subviews;
        for (UIView * subView in subViews) {
            subView.transform = CGAffineTransformMakeTranslation(0, 0);
        }
        
    }];
}


-(void)textfiendDidChange:(UITextField *)textfield
{
    NSLog(@"texg:%@",textfield.text);
}

-(void)showPasswordAlertView
{
    UIWindow * rootWindow = [UIApplication sharedApplication].keyWindow;
    [rootWindow addSubview:self];
    [self createShowAnimation];
}

//-(void)touchesBegan:(NSSet<UITouch *> *)touches withEvent:(UIEvent *)event
//{
//       CGPoint point = [[touches anyObject] locationInView:self.alertView];
//       point = [self.alertView.layer convertPoint:point fromLayer:self.layer];
//       if ([self.alertView.layer containsPoint:point]) {
//          //处理点击到这个view中要执行的事件
//           
//           return;
//       } else {
////           NSLog(@"2222");
//       }
//}

-(void)createShowAnimation
{
    self.alertView.layer.position = self.center;
    self.alertView.transform = CGAffineTransformMakeScale(0.90, 0.90);
    [UIView animateWithDuration:0.25 animations:^{
        self.alertView.transform = CGAffineTransformMakeScale(1.0, 1.0);
    } completion:^(BOOL finished) {
        
    }];
}

#pragma mark - 拿本地存储的数据
- (id)getNSUserDefaultWithKey:(NSString *)key{
    
    id obj = [[NSUserDefaults standardUserDefaults] objectForKey:key];
    return obj;
}

-(void)dealloc
{
    [[NSNotificationCenter defaultCenter]removeObserver:self];
}


@end
