//
//  TalkfunSettingsController.m
//  TalkfunSDKDemo
//
//  Created by 莫瑞权 on 2021/11/9.
//  Copyright © 2021 Talkfun. All rights reserved.
//

#import "TalkfunSettingsController.h"
#import "TFBehaviorController.h"
#import "TalkfunSettingsCell.h"
#import "TalkfunWebViewViewController.h"

#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0
@interface TalkfunSettingsController ()<UITableViewDelegate,UITableViewDataSource>

@end

@implementation TalkfunSettingsController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    CGFloat SafetyZone = 0;
    if (KIsiPhoneX) {
           SafetyZone = 32;
    }
    UIView *backgroundView = [[UIView alloc]init];
    backgroundView.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 64 +SafetyZone);
    backgroundView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
  
    [self.view addSubview:backgroundView];
    

    TalkfunIncreaseButton * backBtn = [TalkfunIncreaseButton buttonWithType:UIButtonTypeCustom];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
    [backBtn addTarget:self action:@selector(backBtnClick) forControlEvents:UIControlEventTouchUpInside];
    backBtn.frame = CGRectMake(0, 22+SafetyZone, 40, 40);
    [backgroundView addSubview:backBtn];
    

    
    UILabel *title = [[UILabel alloc]init];
    title.textAlignment = NSTextAlignmentCenter;
    CGFloat titleH = 25;
    title.frame = CGRectMake(0,backBtn.frame.origin.y+((backBtn.frame.size.height -titleH)/2), [UIScreen mainScreen].bounds.size.width, titleH);
    title.text = @"设置";
    title.font = [UIFont systemFontOfSize:18];
    title.textColor = [UIColor whiteColor];
    [self.view addSubview:title];
    
    // 示例用法
    CGFloat bottomSafeAreaHeight = [self getBottomSafeAreaHeight];
    NSLog(@"Bottom safe area height: %f", bottomSafeAreaHeight);
    //-----------------
    UILabel *filing = [[UILabel alloc] init];
    filing.userInteractionEnabled = YES; // 设置用户交互为可用
    // 添加手势
    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(labe66Tapped:)];
    [filing addGestureRecognizer:tapGesture];
    filing.textAlignment = NSTextAlignmentCenter;
    [self.view addSubview:filing];

    filing.numberOfLines = 0;
    [self.view addSubview:filing];
   
   NSString *hexColor = @"C1C1C1";

   // Convert hexadecimal color to UIColor
   UIColor *color = [self colorWithHexString:hexColor];
    NSMutableAttributedString *filingString = [[NSMutableAttributedString alloc] initWithString:@"粤ICP备17087286号-6A" attributes:@{NSFontAttributeName: [UIFont fontWithName:@"PingFang SC" size: 15], NSForegroundColorAttributeName: color}];
    
    CGFloat labe66H = [self heightForSingleLineAttributedString:filingString];
   NSTextAttachment *attachment = [[NSTextAttachment alloc] init];
    // 创建 NSTextAttachment 对象，并将图片设置为它的内容
   UIImage *originalImage = [UIImage imageNamed:@"备案跳转箭头"]; // Assuming the image name is "PK跳转箭头"
   
   UIImage *transparentImage = [self imageByApplyingAlpha:0.2 toImage:originalImage]; // Function to apply transparency
   attachment.image = transparentImage;
   attachment.bounds = CGRectMake(0, -5, labe66H, labe66H); // 设置图片的大小

    // 创建 NSAttributedString，使用 NSTextAttachment 来包装图片
    NSAttributedString *imageString = [NSAttributedString attributedStringWithAttachment:attachment];

    // 在 NSMutableAttributedString 中插入图片
    [filingString appendAttributedString:imageString];
    
    CGFloat labe66W = [self widthForSingleLineAttributedString:filingString];
 
    filing.frame = CGRectMake((self.view.frame.size.width-labe66W)/2,self.view.frame.size.height-bottomSafeAreaHeight-labe66H-20,labe66W,labe66H);

    filing.attributedText = filingString;

    //-----------
    UITableView *tableView = [[UITableView alloc]init];
    tableView.delegate = self;
    tableView.dataSource= self;
    //不要分割线  去线
    tableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    tableView.separatorInset = UIEdgeInsetsZero;
    CGFloat filingMaxY=  filing.frame.origin.y;
    CGFloat backBtnMaxY = CGRectGetMaxY(backBtn.frame);
    CGFloat tableViewH = filingMaxY - backBtnMaxY;
    tableView.frame = CGRectMake(0, backBtnMaxY, [UIScreen mainScreen].bounds.size.width, tableViewH);
    [self.view addSubview:tableView];

}
-(void)backBtnClick
{
    [self.navigationController popViewControllerAnimated:YES];
}
/** 告诉tableView一共有多少组
*/
//- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
//{    return 1;
//}
/**
*  告诉tableView第section组有多少行
*/
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
 return 2;

}
/**
* 告诉tableView每一行显示什么内容（tableView的每一行都是UITableViewCell）
*/
- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{

    TalkfunSettingsCell *cell = [tableView dequeueReusableCellWithIdentifier:@"TalkfunSettingsCell"];
  
        if (cell == nil) {
            cell = [[TalkfunSettingsCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"TalkfunSettingsCell"];
           
        }
    cell.width = self.view.frame.size.width;
    cell.accessoryType = UITableViewCellAccessoryNone;
    cell.textLabel.textColor = [UIColor colorWithRed:129/255.0 green:133/255.0 blue:136/255.0 alpha:1.0];
    if (indexPath.row == 0) {
        cell.arrowImageView.hidden = NO;
        cell.textLabel.text = @"帮助与反馈";
        
       
    }else if (indexPath.row == 1) {
        cell.arrowImageView.hidden = YES;
        cell.textLabel.text = [self GetVersionText];
      
    }else {
        cell.arrowImageView.hidden = YES;
        cell.textLabel.text = @"";
    }
    cell.backgroundColor = [UIColor whiteColor];
   return cell;
}
- (NSString*)GetVersionText{
    NSString * version = [[NSBundle mainBundle] infoDictionary][@"CFBundleShortVersionString"];
    NSString * str = [NSString stringWithFormat:@"欢云播 v %@",version];
    return str;
}
/*  返回每个cell的高度
*/
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
       return 60;
}

/*
*  当选中一行的时候调用（点击）
 */
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];// 取消选中
    if (indexPath.row ==0) {
        //取出选中的cell
        TFBehaviorController *behaviorController = [[TFBehaviorController alloc]init];
            

            
            [self.navigationController pushViewController:behaviorController animated:YES];
    }else  if (indexPath.row ==1) {
        
    }

}
- (UIStatusBarStyle)preferredStatusBarStyle{
    return UIStatusBarStyleLightContent;//白色
}

- (CGFloat)getBottomSafeAreaHeight {
    if (@available(iOS 11.0, *)) {
        UIWindow *window = [[[UIApplication sharedApplication] delegate] window];
        CGFloat bottomPadding = window.safeAreaInsets.bottom;
        return bottomPadding;
    } else {
        // 如果不支持iOS 11，则返回0，因为不会有安全区域
        return 0;
    }
}
- (UIImage *)imageByApplyingAlpha:(CGFloat)alpha toImage:(UIImage *)image {
    UIGraphicsBeginImageContextWithOptions(image.size, NO, 0.0f);
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    CGRect area = CGRectMake(0, 0, image.size.width, image.size.height);

    CGContextScaleCTM(ctx, 1, -1);
    CGContextTranslateCTM(ctx, 0, -area.size.height);

    CGContextSetBlendMode(ctx, kCGBlendModeMultiply);

    CGContextSetAlpha(ctx, alpha);

    CGContextDrawImage(ctx, area, image.CGImage);

    UIImage *newImage = UIGraphicsGetImageFromCurrentImageContext();

    UIGraphicsEndImageContext();

    return newImage;
}
- (UIColor *)colorWithHexString:(NSString *)hexString {
    unsigned int hexValue;
    [[NSScanner scannerWithString:hexString] scanHexInt:&hexValue];
    return [UIColor colorWithRed:((hexValue & 0xFF0000) >> 16) / 255.0
                           green:((hexValue & 0x00FF00) >> 8) / 255.0
                            blue:(hexValue & 0x0000FF) / 255.0
                           alpha:1.0];
}
- (CGFloat)heightForSingleLineAttributedString:(NSAttributedString *)attributedString {
    CGRect rect = [attributedString boundingRectWithSize:CGSizeMake(CGFLOAT_MAX, CGFLOAT_MAX)
                                                 options:NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading
                                                 context:nil];
    return ceil(rect.size.height);
}
- (CGFloat)widthForSingleLineAttributedString:(NSAttributedString *)attributedString {
    CGRect rect = [attributedString boundingRectWithSize:CGSizeMake(CGFLOAT_MAX, CGFLOAT_MAX)
                                                 options:NSStringDrawingUsesLineFragmentOrigin | NSStringDrawingUsesFontLeading
                                                 context:nil];
    return ceil(rect.size.width);
}

- (void)labe66Tapped:(UITapGestureRecognizer *)gesture {

    TalkfunWebViewViewController *vc = [[TalkfunWebViewViewController alloc]init];
    vc.url = @"https://beian.miit.gov.cn/";
    [self.navigationController pushViewController:vc animated:YES];

    
}
@end
