//
//  TalkfunPrivacyAgreementViewController.m
//  vkaijiang
//
//  Created by 莫瑞权 on 2020/2/26.
//  Copyright © 2020 孙兆能. All rights reserved.
//

#import "TalkfunWebViewViewController.h"
#import <WebKit/WebKit.h>
#define getRectNavAndStatusHight   (([[UIApplication sharedApplication] statusBarFrame].size.height)+(self.navigationController.navigationBar.frame.size.height))
#/*define is_iPhoneXSerious @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0*/

#define KIsiPhoneX  @available(iOS 11.0, *) && UIApplication.sharedApplication.keyWindow.safeAreaInsets.bottom > 0.0
@interface TalkfunWebViewViewController ()<WKNavigationDelegate>
@property (strong, nonatomic) WKWebView *webView;
@property (strong, nonatomic) UILabel * title2;
@end
 
@implementation TalkfunWebViewViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    [self deleteWebCache];
    
    CGFloat SafetyZone = 0;
    if (KIsiPhoneX) {
           SafetyZone = 32;
    }
    UIView *backgroundView = [[UIView alloc]init];
    backgroundView.frame = CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 64 +SafetyZone);
    backgroundView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
  
    [self.view addSubview:backgroundView];
    

    TalkfunIncreaseButton * backBtn = [TalkfunIncreaseButton buttonWithType:UIButtonTypeCustom];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
    [backBtn setImage:[UIImage imageNamed:@"back"] forState:UIControlStateSelected];
    [backBtn addTarget:self action:@selector(backBtnClick) forControlEvents:UIControlEventTouchUpInside];
    backBtn.frame = CGRectMake(0, 22+SafetyZone, 40, 40);
    [backgroundView addSubview:backBtn];
    
    UILabel *title = [[UILabel alloc]init];
    title.textAlignment = NSTextAlignmentCenter;
    CGFloat titleH = 25;
    title.frame = CGRectMake(0,backBtn.frame.origin.y+((backBtn.frame.size.height -titleH)/2), [UIScreen mainScreen].bounds.size.width, titleH);
//    title.text = @"设置";
    title.font = [UIFont systemFontOfSize:18];
    title.textColor = [UIColor whiteColor];
    [self.view addSubview:title];
    self.title2 = title;
    
    WKWebViewConfiguration *config = [[WKWebViewConfiguration alloc] init];
    config.websiteDataStore = [WKWebsiteDataStore nonPersistentDataStore];
    CGFloat backBtnMaxY = CGRectGetMaxY(backBtn.frame);
    self.webView = [[WKWebView alloc] initWithFrame:CGRectMake(0, backBtnMaxY, self.view.bounds.size.width, [UIScreen mainScreen].bounds.size.height - backBtnMaxY) configuration:config];
    self.webView.navigationDelegate = self;
    [self.view addSubview:self.webView];
    

    self.webView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;

   
    NSURL * url = [NSURL URLWithString:self.url?self.url:@""];
    
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
    request.cachePolicy = NSURLRequestReloadIgnoringLocalCacheData; // 忽略本地缓存数据
   
    
    [self.webView loadRequest:request];

    
}
- (void)exitBtnClicked
{
      if (self.navigationController) {
             [self.navigationController popViewControllerAnimated:YES];
      }else{
          [self dismissViewControllerAnimated:YES completion:^{

              NSLog(@"退出调用  ");
             
             
          }];
      }
    
}
- (void)deleteWebCache {
    NSString *libraryDir = NSSearchPathForDirectoriesInDomains(NSLibraryDirectory,
       NSUserDomainMask, YES)[0];
       NSString *bundleId  =  [[[NSBundle mainBundle] infoDictionary]
       objectForKey:@"CFBundleIdentifier"];
       NSString *webkitFolderInLib = [NSString stringWithFormat:@"%@/WebKit",libraryDir];
       NSString *webKitFolderInCaches = [NSString
       stringWithFormat:@"%@/Caches/%@/WebKit",libraryDir,bundleId];
        NSString *webKitFolderInCachesfs = [NSString
        stringWithFormat:@"%@/Caches/%@/fsCachedData",libraryDir,bundleId];

       NSError *error;
       /* iOS8.0 WebView Cache的存放路径 */
       [[NSFileManager defaultManager] removeItemAtPath:webKitFolderInCaches error:&error];
       [[NSFileManager defaultManager] removeItemAtPath:webkitFolderInLib error:nil];

       /* iOS7.0 WebView Cache的存放路径 */
       [[NSFileManager defaultManager] removeItemAtPath:webKitFolderInCachesfs error:&error];
}

#pragma mark - 旋转
- (BOOL)shouldAutorotate{
    return NO;
}
- (UIInterfaceOrientationMask)supportedInterfaceOrientations
{
       return UIInterfaceOrientationMaskPortrait;
}

- (void)webView:(WKWebView *)webView decidePolicyForNavigationAction:(nonnull WKNavigationAction *)navigationAction decisionHandler:(nonnull void (^)(WKNavigationActionPolicy))decisionHandler{
    NSURL *url = navigationAction.request.URL;
    NSString *scheme = [url scheme];
    UIApplication *app = [UIApplication sharedApplication];
    WKNavigationActionPolicy actionPolicy = WKNavigationActionPolicyAllow;
    
    if ([scheme isEqualToString:@"tel"]) {
        if ([app canOpenURL:url]) {
            CGFloat version = [[[UIDevice currentDevice]systemVersion]floatValue];
            if (version >= 10.0) {
                /// 大于等于10.0系统使用此openURL方法
                [[UIApplication sharedApplication] openURL:url options:@{} completionHandler:nil];
            } else {
                [[UIApplication sharedApplication] openURL:url];
            }
        }
    }
    /* 这句话一定要实现 不然会异常 */
    decisionHandler(actionPolicy);
}
// WKNavigationDelegate 方法，用于处理页面加载完成的回调
- (void)webView:(WKWebView *)webView didFinishNavigation:(WKNavigation *)navigation {
  
    NSString *title = webView.title;
    if (title) {
        NSLog(@"Page title: %@", title);
        
        
        if([self.url isEqual:@"https://beian.miit.gov.cn/"])
        {
            self.title2.text =title;
//            self.navigationItem.title = title;
        }
       
    }
}
-(void)backBtnClick
{
    [self.navigationController popViewControllerAnimated:YES];
}
@end
