//
//  TalkfunCourseListCell.m
//  TalkfunSDKDemo
//
//  Created by 邓盛明 on 2020/7/21.
//  Copyright © 2020 Talkfun. All rights reserved.
//

#import "TalkfunCourseListCell.h"

@interface TalkfunCourseListCell()



@end

@implementation TalkfunCourseListCell

- (void)awakeFromNib {
    [super awakeFromNib];
    // Initialization code
}

-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
   self =  [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        self.titleLab = [[UILabel alloc]init];
        self.titleLab.text = @"设计师如何做到年入百万";
        self.titleLab.font = [UIFont fontWithName:@"PingFang SC" size:17];
        self.titleLab.textColor = [UIColor colorWithRed:41/255.0 green:44/255.0 blue:46/255.0 alpha:1.0];
        [self.contentView addSubview:self.titleLab];
        
        self.timeLab = [[UILabel alloc]init];
        self.timeLab.text = @"02-08 08:00 至 10:00";
        self.timeLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
        self.timeLab.textColor = [UIColor colorWithRed:129/255.0 green:133/255.0 blue:136/255.0 alpha:1.0];
        [self.contentView addSubview:self.timeLab];
        
        self.nameLab = [[UILabel alloc]init];
        self.nameLab.text = @"汤村长";
        self.nameLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
        self.nameLab.textColor = [UIColor colorWithRed:66/255.0 green:67/255.0 blue:68/255.0 alpha:1.0];
        [self.contentView addSubview:self.nameLab];
        
        self.zhiboView = [[UIView alloc]init];
        self.zhiboView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        [self.contentView addSubview:self.zhiboView];
        
        self.zhiboLab = [[UILabel alloc]init];
        self.zhiboLab.text = @"直播中";
        self.zhiboLab.font = [UIFont fontWithName:@"PingFang SC" size:14];
        self.zhiboLab.textColor = [UIColor whiteColor];
        self.textLabel.textAlignment = NSTextAlignmentCenter;
        [self.zhiboView addSubview:self.zhiboLab];
        
        self.translateView = [[UIView alloc]init];
        self.translateView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        [self.zhiboView addSubview:self.translateView];
    
        self.linelab = [[UILabel alloc]init];
        self.linelab.backgroundColor =  [UIColor colorWithRed:229/255.0 green:229/255.0 blue:229/255.0 alpha:1.0];
        [self.contentView addSubview:self.linelab];
        
        self.downBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [self.downBtn setImage:[UIImage imageNamed:@"下载"] forState:UIControlStateNormal];
        [self.downBtn setImage:[UIImage imageNamed:@"下载"] forState:UIControlStateSelected];
        self.downBtn.hidden = YES;
        [self.contentView addSubview:self.downBtn];
      
    }
    return self;
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    self.titleLab.frame = CGRectMake(15, 13, 200, 24);
    self.timeLab.frame = CGRectMake(15, CGRectGetMaxY(self.titleLab.frame)+5, 200, 20);
    self.nameLab.frame = CGRectMake(15, CGRectGetMaxY(self.timeLab.frame)+5, 200, 20);
    
    self.zhiboView.frame = CGRectMake(self.contentView.frame.size.width-87, 10, 87, 34);
//    self.zhiboLab.frame = CGRectMake(15, 5, 48, 24);
     self.downBtn.frame = CGRectMake(self.width-50, 35, 30, 30);
    self.translateView.frame = CGRectMake(63, 0, 24, 24);
    
    self.linelab.frame = CGRectMake(0, 99, self.width, 1);
    
    UIBezierPath * maskPath = [UIBezierPath bezierPathWithRoundedRect:self.zhiboView.bounds byRoundingCorners:UIRectCornerTopLeft|UIRectCornerBottomLeft cornerRadii:CGSizeMake(17.5, 17.5)];
          
    CAShapeLayer *  maskLayer = [CAShapeLayer layer];
    maskLayer.frame = self.zhiboView.bounds;
    maskLayer.path = maskPath.CGPath;
          
    self.zhiboView.layer.mask = maskLayer;
    
}
-(void)setModel:(TalkfunAllCourseModel *)model
{
    _model = model;
    self.titleLab.text = model.title;
    self.nameLab.text = model.nickname;
    self.timeLab.text = [self gettime:model.start_time];
    if ([model.status intValue] == 2) {
        self.zhiboView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
        self.zhiboLab.frame = CGRectMake(15, 5, 48, 24);
        self.zhiboLab.text = @"直播中";
        self.zhiboLab.textColor = [UIColor whiteColor];
        self.translateView.hidden = NO;
        self.downBtn.hidden = YES;
         [self tranStateAnimation];
        self.zhiboView.hidden = NO;
    } else if ([model.status intValue] == 1) {
        self.zhiboView.backgroundColor = [UIColor colorWithRed:34/255.0 green:220/255.0 blue:176/255.0 alpha:1.0];
        self.zhiboLab.frame = CGRectMake(14, 5, 64, 24);
        self.zhiboLab.text = @"准备开播";
        self.zhiboLab.textColor = [UIColor whiteColor];
        self.translateView.hidden = YES;
        self.downBtn.hidden = YES;
        self.zhiboView.hidden = NO;
    } else if ([model.status intValue]==3) {
        self.zhiboView.backgroundColor = [UIColor colorWithRed:230/255.0 green:236/255.0 blue:241/255.0 alpha:1.0];
        self.zhiboLab.frame = CGRectMake(14, 5, 80, 24);
        self.zhiboLab.text = @"回放生成中";
        self.zhiboLab.textColor = [UIColor colorWithRed:133/255.0 green:146/255.0 blue:155/255.0 alpha:1.0];
        self.translateView.hidden = YES;
        self.downBtn.hidden = YES;
        self.zhiboView.hidden = NO;
    } else if ([model.status intValue] == 4) {
        self.zhiboView.hidden = YES;
        self.translateView.hidden = YES;
        self.downBtn.hidden = NO;
       
    }
}

-(void)setMymodel:(TalkfunMyCourseModel *)mymodel
{
    _mymodel = mymodel;
       self.titleLab.text = mymodel.title;
       self.nameLab.text = mymodel.nickname;
       self.timeLab.text = [self gettime:mymodel.start_time];
       if ([mymodel.status intValue] == 2) {
           self.zhiboView.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0];
           self.zhiboLab.frame = CGRectMake(15, 5, 48, 24);
           self.zhiboLab.text = @"直播中";
           self.zhiboLab.textColor = [UIColor whiteColor];
           self.translateView.hidden = NO;
           self.downBtn.hidden = YES;
            [self tranStateAnimation];
           self.zhiboView.hidden = NO;
       } else if ([mymodel.status intValue] == 1) {
           self.zhiboView.backgroundColor = [UIColor colorWithRed:34/255.0 green:220/255.0 blue:176/255.0 alpha:1.0];
           self.zhiboLab.frame = CGRectMake(14, 5, 64, 24);
           self.zhiboLab.text = @"准备开播";
           self.zhiboLab.textColor = [UIColor whiteColor];
           self.translateView.hidden = YES;
           self.downBtn.hidden = YES;
           self.zhiboView.hidden = NO;
       } else if ([mymodel.status intValue]==3) {
           self.zhiboView.backgroundColor = [UIColor colorWithRed:230/255.0 green:236/255.0 blue:241/255.0 alpha:1.0];
           self.zhiboLab.frame = CGRectMake(14, 5, 80, 24);
           self.zhiboLab.text = @"回放生成中";
           self.zhiboLab.textColor = [UIColor colorWithRed:133/255.0 green:146/255.0 blue:155/255.0 alpha:1.0];
           self.translateView.hidden = YES;
           self.downBtn.hidden = YES;
           self.zhiboView.hidden = NO;
//           self.selectionStyle = UITableViewCellSelectionStyleNone;
       } else if ([mymodel.status intValue] == 4) {
           self.zhiboView.hidden = YES;
           self.translateView.hidden = YES;
           self.downBtn.hidden = NO;
          
       }
    
}

-(NSString *)gettime:(NSString *)str
{
    NSTimeInterval time = [str integerValue];
    NSDate * myDate = [NSDate dateWithTimeIntervalSince1970:time];
    NSDateFormatter * dateFormatter = [[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"MM-dd:HH:mm"];
    NSString * timeStr = [dateFormatter stringFromDate:myDate];
    
    return timeStr;
}


//加载直播动画
-(void)tranStateAnimation
{
    //1.创建relicatorLayer对象
    
    if (!self.replicatorLayer) {
             self.replicatorLayer = [CAReplicatorLayer layer];
                self.replicatorLayer.frame  = CGRectMake(0, 0, 24, 24);
   
                 self.replicatorLayer.backgroundColor = [UIColor colorWithRed:23/255.0 green:145/255.0 blue:251/255.0 alpha:1.0].CGColor;
                self.replicatorLayer.cornerRadius    = 3;
                self.replicatorLayer.masksToBounds   = YES;
                
                [self.translateView.layer addSublayer:self.replicatorLayer];

                CGFloat count = 3;
                CGFloat lineH = 16;
                CGFloat lineMarginX = 2;
                CGFloat lineInter = 5;
                CGFloat lineW = 3;
                
                //2.创建CALayer对象
                CALayer *lineLayer        = [CALayer layer];
                lineLayer.bounds          = CGRectMake(0, 0, lineW, lineH);
                lineLayer.position        = CGPointMake(lineMarginX, self.replicatorLayer.frame.size.height);
                lineLayer.backgroundColor = [UIColor whiteColor].CGColor;
               
                [self.replicatorLayer addSublayer:lineLayer];
                
                
                self.replicatorLayer.instanceCount = count;
                
                self.replicatorLayer.instanceTransform = CATransform3DMakeTranslation(lineInter, 0, 0);
                
                

                //3.设置动画
                CABasicAnimation *animation = [CABasicAnimation animationWithKeyPath:@"transform.scale.y"];

                
                animation.toValue           = @(0.1);
                animation.duration          = 0.5;
                animation.autoreverses      = YES;
                animation.repeatCount       = MAXFLOAT;
              //防止动画结束后回到初始状态,只需要添加下面这两个属性就可以了
                animation.removedOnCompletion = NO;
                animation.fillMode = kCAFillModeForwards;
                animation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseIn];
                [lineLayer addAnimation:animation forKey:nil];
                
                self.replicatorLayer.instanceDelay = 0.5 / count;             
    }

}


- (void)setSelected:(BOOL)selected animated:(BOOL)animated {
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}



@end
